
.equ SongOffset,ChibiSoundRam+128 ; dc.l 0	;Remap internal addresses in song 
					;(eg compiled for $8000,loaded to $2000 = offsets of -$6000
.equ SongBase,SongOffset+4 ; dc.l Song1
.equ SongChannels,SongBase+4 ; dc.b 0
.equ SongSpeed,SongChannels+4 ; dc.b 0

;Unlike Z80, 68000 uses 32 bytes per channel due to 24 bit addresses
.equ channeldatalength,32	


;96 bytes - but should allocate at least 64+32 (32 for platform vars)
.equ channeldatalengthtotal,32*3

.equ channelstate0,chibisoundram
.equ channelstate1,chibisoundram+32
.equ channelstate2,chibisoundram+32+32


;Channel data layout
.equ chn_Note,0
.equ chn_Volu,1
.equ chn_Cnum,2
.equ chn_Pitc,3
.equ chn_InsL,4		;4 bytes
.equ chn_InsT,8		;1byte
.equ chn_PatT,9		;1byte
					;2 bytes unused
.equ chn_PatL,12	;4 bytes
.equ chn_SeqL,16	;4 bytes



;R0	 A        D0
;R1	 B        D1
;R2  D        D2
;R3  H        D3
;R4	 C  BC A1 D4
;R5	 E  DE A2 D5
;R6  L  HL A3 D6
;R7     IX A5
;R8     IY A6
;R9		      D7
;R10	   A0 
;R11	   A4
;R12

;Note: As addresses in ChibiTracks songs are 16 bit 
;Relocation support is MANDATORY on systems with a >16 bit address bus


.equ chibitracks_allowspeedchange,1
;chibitracks_allowspeedchange_inst equ 1		;affect instruments too
;command byte definitions

.equ Cmd_Ptch,0x0F	;&0F,n
.equ Cmd_Volu,0x0E	;&0E,n - Absolute volume n
.equ Cmd_Note,0x0D	;&0D,n - Play Note pitch n
.equ Cmd_Loop,0x0C	;&0C,n - Jump back n bytes
.equ Cmd_Inst,0x0B	;&0B,n - select instrument n

.equ Cmd_VolA,0xF0	;&F0+n - Volume Adjust
.equ Cmd_VolD,0x00	;&F0+ -n - Volume Adjust

.equ Cmd_PtcD,0xE0	;&E0+n
.equ Cmd_PtcU,0xD0	;&D0+n
.equ Cmd_Nois,0xC0	;&C0+n (1/0) - Noise On/Off

.equ Cmd_Pend,0x10	;&10 - Pattern End

.equ Seq_Repeat,255


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


	.ifdef chibitracks_allowspeedchange
speedmult:						;Multiply D0 by songspeed
		and r0,r0,#0xFF			;Limit to 1 byte
		
		adrl r10,adrSongSpeed
		ldr r10,[r10]
		ldrb r10,[r10]
		mov r1,r0				;Get the songspeed
		
		mul r0,r1,r10			;Multiply it
		
		mov pc,lr
	.endif

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
adrchannelstate0: .long channelstate0
channelstate0_chn_Cnum: .long channelstate0+chn_Cnum
channelstate1_chn_Cnum: .long channelstate1+chn_Cnum
channelstate2_chn_Cnum: .long channelstate2+chn_Cnum
adrSongSpeed: .long SongSpeed
adrSongBase: .long SongBase
adrSongChannels: .long SongChannels
adrsongoffset: .long songoffset
imm_0xFFFFFF00: .long 0xFFFFFF00


	.align 4
	
startsong:		;Init song (set 'songbase' first)
	STMFD sp!,{lr}
		adrl r5,adrchannelstate0		;channel ram
		ldr r5,[r5]
		mov r1,#channeldatalengthtotal  ;Byte count
		
		mov r10,#0
StartSong_ClearAgain:	
		strb r10,[r2],#1
		subs r1,r1,#1
		bne StartSong_ClearAgain
		
;Set default channel numbers
		mov r10,#0
		adrl r11,channelstate0_chn_Cnum
		ldr r11,[r11]
		strb r10,[r11]
		
		mov r10,#1
		adrl r11,channelstate1_chn_Cnum
		ldr r11,[r11]
		strb r10,[r11]
		
		mov r10,#2
		adrl r11,channelstate2_chn_Cnum
		ldr r11,[r11]
		strb r10,[r11]
		
		
		mov r0,#0			;start with pattern 0 in sequence
		
startsongagain:
		STMFD sp!,{r0}
		
			adrl r6,adrsongbase
			ldr r6,[r6]
			ldr r6,[r6]
			
			ldrb r0,[r6],#1
			
			adrl r1,adrsongchannels
			ldr r1,[r1]
			strb r0,[r1]			;get channel count
			mov r1,r0			
		
			add r6,r6,#1			;skip Repeat point
			
			ldrb r0,[r6],#1			;get Song Speed
			
			adrl r10,adrSongSpeed
			ldr r10,[r10]
			strb r0,[r10]			;Store Song speed
			
			
	;Base address of song - NOTE: All addresses are 16 bit little endian,
	;and MUST be treated as offsets on >16 bit systems
			
			ldrb r2,[r6,#1]			;Load Base address H
			mov r2,r2,lsl #8
			
			ldrb r10,[r6]			;Load Base address L
			orr r2,r2,r10
			
			adrl r10,adrsongbase	;Calc offset
			ldr r10,[r10]
			ldr r0,[r10]
			sub r0,r0,r2
						
			adrl r10,adrsongoffset
			ldr r10,[r10]
			str r0,[r10]
					
		LDMFD sp!,{r0}				;D0= first Sequence Number
				
		add r6,r6,#2+2+2			;skip to sequence pointers 
									;(Skip SongAddr,PatternList,InstList)
									
									
									
		adrl r11,adrchannelstate0	;First Channel to init
		ldr r11,[r11]
		
startnextseq:
		STMFD sp!,{r1,r4}
			bl initsongsequence				;init a channel
			add r11,r11,#channeldatalength	;move to next channel
		LDMFD sp!,{r1,r4}		
				
		subs r1,r1,#1
		bne startnextseq		;repeat for other channels
	LDMFD sp!,{pc}
	

	
initsongsequence:	;D0= start pattern point
	STMFD sp!,{r0,lr}
								;get address of sequence
		ldrb r1,[r6,#1]			;Load Sequence address H
		mov r1,r1,lsl #8		
		ldrb r10,[r6]			;Load Sequence address L
		orr r1,r1,r10
		add r6,r6,#2
		
		adrl r5,adrsongoffset
		ldr r5,[r5]
		ldr r5,[r5]
		add r5,r5,r1			;add offset to Sequence address
				
		STMFD sp!,{r6}
			and r0,r0,#0xFF
			add r5,r5,r0		;Add DO loop point
			
			bl getnextsequence		;Load in the Pattern from the seq

			str r6,[r11,#chn_patL]	;Save next sequence addr
			
			mov r0,#1
			strb r0,[r11,#chn_insT]	;Force Instrument update
			
			adrl r0,instsilent 		;Play silent instrument
			
			str r0,[r11,#chn_insl]	;Save instrument address
			
		LDMFD sp!,{r6}	
	LDMFD sp!,{r0,pc}	
	
	
	
patternend:
	ldr r5,[r11,#chn_seql]		;Get Next sequence address
	
getnextsequence:
	ldrb r0,[r5]				;Next sequence
	cmp r0,#255
	beq restartsong				;255=End of sequence (restart)

	.ifdef debugsong
			STMFD sp!,{r2,r5,lr}
				mov r2,#0
				mov r5,#10
				bl monitor		;Show new pattern for debug
			LDMFD sp!,{r2,r5,lr}	
	.endif
	
	add r5,r5,#1				;move to next pattern
	str r5,[r11,#chn_seql]		;save new pattern address
	
;Get pattern list address
	adrl r5,adrsongbase
	ldr r5,[r5]
	ldr r5,[r5]
	add r5,r5,#5	;skip channels / loop point / Speed / Songbase

	ldrb r1,[r5,#1]				;Load PatternList address H
	mov r1,r1,lsl #8
	ldrb r10,[r5]				;Load PatternList address L
	orr r1,r1,r10
	
;Add the offset
	adrl r5,adrsongoffset
	ldr r5,[r5]					;add offset to PatternList address
	ldr r5,[r5]
	add r5,r1,r5
		
;Add PatternNum D0 to address
	and r0,r0,#0xFF
	add r5,r5,r0,lsl #1			;2 bytes per pattern address

;Get Pattern address
	ldrb r1,[r5,#1]				;Load pattern address H
	mov r1,r1,lsl #8
	ldrb r10,[r5]				;Load pattern address L
	orr r1,r1,r10
	
;Add the offset	
	adrl r6,adrsongoffset		;add offset to pattern address
	ldr r6,[r6]
	ldr r6,[r6]
	add r6,r6,r1

	mov r0,#1
	strb r0,[r11,#chn_patT]		;Force an update
	
	mov pc,lr
	

	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

restartsong:			;at the end of pattern list

	add sp,sp,#4*3			;clear down the stack
	
	LDMFD sp!,{lr}
	
	adrl r6,adrsongbase
	ldr r6,[r6]
	ldr r6,[r6]
	
	add r6,r6,#1			;Skip channel count
	
	ldrb r0,[r6]			;get pattern repeat point (0=beginning)

	STMFD sp!,{lr}
		bl startsongagain	;Reset sequence point
	LDMFD sp!,{lr}
;	jmp chibitracks_play


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


chibitracks_play:			
	adrl r11,adrchannelstate0		;Pointer to Channel Data
	ldr r11,[r11]
	
	adrl r1,adrSongChannels			;channel count
	ldr r1,[r1]
	ldrb r1,[r1]

updatenextseq:
	STMFD sp!,{r1,r3,lr}

		ldrb r0,[r11,#chn_patt]		;pattern needs updating?
		subs r0,r0,#1
		strb r0,[r11,#chn_patt]
		
		bne NoPatternRead				
		bl ReadPattern				;0=yes... process pattern
		
		
NoPatternRead:
		ldrb r0,[r11,#chn_inst]		;no delay (no more commands)
		
		cmp r0,#0
		beq updatenextseq_nochange
		
		subs r0,r0,#1
		strb r0,[r11,#chn_inst]
		
		bne NoChannelUpdate
		bl UpdateChannel			;process channel instrument
NoChannelUpdate:
updatenextseq_nochange:


		add r11,r11,#channeldatalength	;move to next channel
		
	LDMFD sp!,{r1,r3,lr}

	subs r1,r1,#1					;Repeat for other channels
	bne updatenextseq
	b chibisoundpro_update		;Update hardware
	

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

ReadPattern:
	STMFD sp!,{lr}
		ldr r6,[r11,#chn_patl]		;Load current pattern point

		ldrb r0,[r6]				;Get next pattern line time	
	
		.ifdef chibitracks_allowspeedchange
			bl speedmult
		.endif
			
		strb r0,[r11,#chn_patt]		;Update pattern line time
		add r6,r6,#1

		bl processsoundcommands		;Read this lines commands

		str r6,[r11,#chn_patl]		;Update current pattern point
	
	LDMFD sp!,{pc}
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


UpdateChannel:					;Update instrument
	STMFD sp!,{lr,r11}
		ldr r6,[r11,#chn_insl]		;Get instrument point
		
		ldrb r0,[r6]				;Get next inst delay
		cmp r0,#0					;0= Instrument ends
		beq stopinst				
		
		.ifdef chibitracks_allowspeedchange_inst
			b speedmult
		.endif

		strb r0,[r11,#chn_inst]		;update instrument delay
		add r6,r6,#1
		
		bl processsoundcommands	;process instrument command line

		str r6,[r11,#chn_insl]		;update instrument address
				
				
				
;We need to play the current tone

		ldrb r2,[r11,#chn_note]		;Channel Note number
		ldrb r0,[r11,#chn_pitc]		;pitch shift
		
		bl tweentone				;R0= ooooffff
						;o=offset -16 to +15 f=fraction 0-15
		
		ldrb r3,[r11,#chn_volu]		;Volume
		
stopinst2:
		ldrb r6,[r11,#chn_cnum]		;Channel + noise state (bit 7)

		.ifdef debugnotes
			STMFD sp!,{r2,r5,lr}
				mov r0,r5
				mov r2,#0
				mov r5,#10
				bl monitor
			LDMFD sp!,{r2,r5,lr}	
		.endif
		
		bl chibisoundpro_set
		
	LDMFD sp!,{lr,r11}
	mov pc,lr
	
stopinst:
		mov r3,#0		;Instrument ended - silence channel
		b stopinst2

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

ProcessSoundCommands:		;process instrument/pattern commands

	ldrb r0,[r6],#1			;Get command
	cmp r0,#0
	beq instendb			;0=end of commands

	mov r1,r0				;Back up byte for later
	
	ands r0,r0,#0xF0		;Top nibble=command
	beq InstMultibyte		;0x=Multibyte commands

	cmp r0,#0xF0			;xn commands x=command n=param
	beq InstVol
	
	cmp r0,#0xD0
	beq InstPitchUp
	
	cmp r0,#0xE0
	beq InstPitchDown
	
	cmp r0,#0xC0
	beq InstNoise
	
	cmp r0,#0x10
	beq PatternEnd
	
instendb:
	mov pc,lr				;unknown! (shrug)
	
	;&B0 A0 90 80 70 60 50 40 30 20 spare!
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

InstPitchDown:
	and r1,r1,#0b00001111			;pitch bend
	eor r1,r1,#0b11111110
	strb r1,[r11,#chn_pitc]			;bend down
	b processsoundcommands

InstPitchUp:
	and r1,r1,#0b00001111			;pitch bend
	strb r1,[r11,#chn_pitc]			;bend up
	b processsoundcommands

	
InstVol:
	and r1,r1,#0b00001111			;volume shift
	mov r1,r1,lsl #4				;%VVVV----
	tst r1,#0b10000000
	bne InstVolDown
	
	ldrb r10,[r11,#chn_volu]
	add r1,r1,r10
	cmp r1,#255
	bcc InstVolDone	
	mov r1,#255						;over max vol
	
InstVolDone:
	strb r1,[r11,#chn_volu]			;volume
	b processsoundcommands

InstVolDown:
	ldrb r10,[r11,#chn_volu]
	mov r0,r1
	add r1,r1,r10
	and r1,r1,#255
	cmp r1,r0						;> orig? (wrapped around)
	bcs instvoldone
	
	mov r1,#0
	strb r1,[r11,#chn_volu]			;Under min vol
	b processsoundcommands

	
InstNoise:
	ldr r4,[r11,#chn_cnum]			;Keep Channel Number
	and r4,r4,#0b01111111			;%-CCCCCCC	

	and r1,r1,#0b00000001			;noise
	mov r1,r1,lsl #7				;%N-------
	orr r1,r1,r4
	strb r1,[r11,#chn_cnum]			;Save New Noise/Channel setting

	b processsoundcommands

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

InstMultibyte:			;0x,n commands x=command n=parameter 
	ldrb r4,[r6],#1			;Get parameter byte
	
	cmp r1,#0x0F			;Check command
	beq InstBytePitch
	
	cmp r1,#0x0E
	beq InstByteVol
	
	cmp r1,#0x0D
	beq InstByteNote
	
	cmp r1,#0x0C
	beq InstLoop
	
	cmp r1,#0x0B
	beq InstPlayInstrument
	
	mov pc,lr			;unknown! (shrug)
	
	;0x0a 09 08 07 06 05 04 03 02 01 spare!

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

InstByteNote:
	strb r4,[r11,#chn_note]			;note
	b processsoundcommands

InstByteVol:
	strb r4,[r11,#chn_volu]			;vol byte
	b processsoundcommands

InstBytePitch:
	strb r4,[r11,#chn_pitc]			;Bend byte
	b processsoundcommands
	
	
InstLoop:
	adrl r10,Imm_0xFFFFFF00			;Sign extend as negative
	ldr r10,[r10]
	orr r4,r4,r10
	add r6,r6,r4					;Jump back to previous script pos
	b processsoundcommands

	
InstPlayInstrument:				;2 bytes per inst address
	mov r4,r4,lsl #1
	
	adrl r5,adrsongbase
	ldr r5,[r5]
	ldr r5,[r5]
	add r5,r5,#5+2				;Jump to instrument list
	
	ldrb r1,[r5,#1]				;Get Address of Inst Table H
	mov r1,r1,lsl #8
	ldrb r10,[r5]				;Get Address of Inst Table L
	orr r1,r1,r10
	
	adrl r5,adrsongoffset
	ldr r5,[r5]
	ldr r5,[r5]					;Get offset
	
	add r5,r5,r1				;Add Instrument table address
	add r5,r5,r4				;Add required Instrument number
	
	ldrb r1,[r5,#1]				;Load Inst address H
	mov r1,r1,lsl #8
	ldrb r10,[r5]				;Load Inst address L
	orr r1,r1,r10
	
	adrl r10,adrsongoffset
	ldr r10,[r10]
	ldr r10,[r10]
	add r1,r1,r10				;Add offset
	
	mov r0,#1					;Trigger sound
	strb r0,[r11,#chn_inst]
	str r1,[r11,#chn_insl]		;Address of instrument script
	
	b processsoundcommands

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	; align 8
; dchannelstate0:
	; dc.b 0				;note (0-55) 0
	; dc.b 255			;volume 1
	; dc.b 0				;channel/noise state 2
	; dc.b 0				;pitch shift 3 
	; dc.l instsilent		 ;4 5 6 7
	; dc.b 1				;timeout for current inst state 8
	; dc.b 0				;9 timeout
	; dc.l 0				;10 11 12 13 pattern 
	; dc.l 0 				;14 15 16 17 sequence
	; ds.b 14
	
; dchannelstate1:
	; dc.b 0				;note (0-55) 0
	; dc.b 255			;volume 1
	; dc.b 1				;channel/noise state 2
	; dc.b 0				;pitch shift 3 
	; dc.l instsilent		 ;4 5 6 7
	; dc.b 1				;timeout for current inst state 8
	; dc.b 0				;9 timeout
	; dc.l 0				;10 11 12 13 pattern 
	; dc.l 0 				;14 15 16 17 sequence
	; ds.b 14
	
; dchannelstate2:
	; dc.b 0				;note (0-55) 0
	; dc.b 255			;volume 1
	; dc.b 2				;channel/noise state 2
	; dc.b 0				;pitch shift 3 
	; dc.l instsilent		 ;4 5 6 7
	; dc.b 1				;timeout for current inst state 8
	; dc.b 0				;9 timeout
	; dc.l 0				;10 11 12 13 pattern 
	; dc.l 0 				;14 15 16 17 sequence
	; ds.b 14
	
InstSilent:
	.byte 0		;Silent instrument
	
	.align 4
	
	