;R0	 A         D0
;R1	 B         D1
;R2	 D         D2
;R3	 H         D3
;R4	 C  BC A1  D4
;R5	 E  DE A2  D5
;R6 	 L  HL A3  D6
;R7     IX     A5
;R8     IY     A6
;R9		   D7
;R10	       A0 
;R11	       a4
;R12


TweenTone:	;D0= %ooooffff	o=offset -8 to +7 f=fraction 0-15  D2=note
	STMFD sp!,{lr}

	STMFD sp!,{r0}
		mov r0,r0,lsr #4		;Get signed Offset
		add r2,r2,r0			;Add to note
		
		STMFD sp!,{r2}
			bl GetChibiTone		;D2=note (bit 1-6=note  bit0=flat)
			
			mov r0,r2
			mov r2,r3
			mov r3,r0
			
		LDMFD sp!,{r2}
	LDMFD sp!,{r0}
	
	ands r0,r0,#0b00001111		;Any Fraction?
	beq TweenToneDone
	
	STMFD sp!,{r0,r3}
			add r2,r2,#1		;Next Note
			
			bl GetChibiTone		;R2=note (bit 1-6=note  bit0=flat)
	LDMFD sp!,{r0,r3}
	
	bl Tween16HLDE				;Get Fraction of next note
	
TweenToneDone:
	mov r5,r3					;result in r5
	
	LDMFD sp!,{pc}
	
	
	

GetChibiTone:		;D2=note (8 bit val: bit 1-6=note  bit 0=flat) 
					;Result in r2
					
	adrl r6,chibiOctave		;Returns 16 bit D2 frequency
	
	mov r0,r2
	and r2,r2,#0b11111110	;Clear Sharp/Flat
	add r6,r6,r2
	
	ldrb r2,[r6,#1]			;First note H
	mov r2,r2,lsl #8
	ldrb r10,[r6]			;First note L
	orr r2,r2,r10
	add r6,r6,#2
	
	tst r0,#0b00000001		;Sharp/Flat?
	beq ChibiToneGotNote	;No? we're done!

	mov r2,r2,lsr #1		;Halve first value
	
	ldrb r3,[r6,#1]			;Get second value H
	mov r3,r3,lsl #8
	ldrb r10,[r6]			;Get second value L
	orr r3,r3,r10
	
	mov r3,r3,lsr #1		;Halve second value

	add r2,r2,r3			;Add two halves
	
ChibiToneGotNote:
	mov pc,lr				;Result in R2

	
	
	