;R0	 A         D0
;R1	 B         D1
;R2	 D         D2
;R3	 H         D3
;R4	 C  BC A1  D4
;R5	 E  DE A2  D5
;R6 	 L  HL A3  D6
;R7     IX     A5
;R8     IY     A6
;R9		   D7
;R10	       A0 
;R11	       a4
;R12


Tween16hlde:	;R0/16 of R2, 16- R0/16 of R3  R3----R0----R2
				;Result in R3
	STMFD sp!,{lr}
	cmp r0,#0
	beq tween16hlde_Done	;R0=0 ?
	
	STMFD sp!,{r0,r3}	
		mov r10,r2
		mov r2,r3
		mov r3,r10
		
		bl fraction16		;Fraction of R2
		
		mov r10,r2
		mov r2,r3
		mov r3,r10
	LDMFD sp!,{r0,r3}
	
	rsb r0,r0,#0			;Amount of R3 to use
	add r0,r0,#16
	
	bl fraction16			;Fraction of R3
	add r3,r3,r2

tween16hlde_Done:
	LDMFD sp!,{pc}



Fraction16:	;Return R3=R3*(R0/16) (Divide by 16, mutlt by D0)
	cmp r0,#0
	bne fraction16_Not0
	mov r3,#0
fraction16_Done:
	mov pc,lr 
	
fraction16_Not0:	
	cmp r0,#16
	bcs fraction16_Done		;A>=16? 100% D3
	
	STMFD sp!,{r2}
	
		adrl r10,fraction16_wordmask
		ldr r10,[r10]
	
		mov r2,r3			;D2 = Value to fraction
		and r2,r2,r10
		mov r3,#0			;D3 = Build up
	
		mov r2,r2,lsr #1	;1/2
		tst r0,#0b00001000
		beq fraction16_8
		add r3,r3,r2
		
fraction16_8:
		mov r2,r2,lsr #1	;1/4
		tst r0,#0b00000100
		beq fraction16_4
		add r3,r3,r2

fraction16_4:
		mov r2,r2,lsr #1	;1/8
		tst r0,#0b00000010
		beq fraction16_2
		add r3,r3,r2

fraction16_2:
		mov r2,r2,lsr #1	;1/16
		tst r0,#0b00000001
		beq fraction16_1
		add r3,r3,r2

fraction16_1:
	LDMFD sp!,{r2}
	mov pc,lr

fraction16_wordmask: .long 0x0000FFFF	

