



DoMaxTileCall:	 ;Return address is on stack!
		adrl r8,vecMaxTile
	b ChibiVM_VectorCall	



.equ mxMaxTileInit,0				;NoParams (sets up LUTs
.equ mxMaxTileRedraw, 1			;NoParams
.equ mxMaxTileFillArea, 2		;B,C=X,Y pos HL=Tile to fill with  D,E=Wid,Hei
.equ mxMaxTileDrawArea, 3		;B,C=X,Y pos HL=SourceTilemap (2 byte per tile)  D,E=Wid,Hei  (Draw a tilemap/sprite to screen)
.equ mxMaxTilePrint, 4			;HL=source tilemap BC=xy pos de=offset (FF=End of line FF FF = end of string - 1 byte per tile DE=Offset)
.equ mxSetPalette, 5				;HL=Platform specific palette
.equ mxSetScroll, 6				;HL=TileMap Base Addr (if A=255 else unchanged) DE = Xoffset,Yoffset (only bottom 4 bits used)
.equ mxDrawBorder, 7				;NoParams
.equ mxFlagForRedraw,8			;B,C=X,Y pos D,E=Wid,Hei
vecMaxTile:
	.long InitMaxTile				;0
	.long MaxTileRedraw			;1
	.long MaxTileFillArea			;2
	.long MaxTileDrawArea			;3
	.long MaxTilePrint				;4
	.long SetPalette				;5
	.long MaxTileSetScroll				;HL=TileMap Base Addr (if A=255 else unchanged) DE = Xoffset,Yoffset (only bottom 4 bits used)
	.long MaxTileClearBorder
	.long MaxTileFlagForRedraw
;ShiftTilemap ;r4/C=Ypos r1/B=Xpos... Returns HL address

;BackgroundTilemapScrollX
;BackgroundTilemapScrollY
;InitMaxTile

adrbackgroundtilemapbase: .long backgroundtilemapbase

;R6 HL=TileMap Base Addr (if r0 A=255 else unchanged) r4 C = Xoffset r5 D = Yoffset (only bottom 4 bits used)
MaxTileSetScroll:		
	adrl r1,AdrBackgroundTilemapScrollX
	ldr r1,[r1]
	strb r4,[r1]
	
	adrl r1,AdrBackgroundTilemapScrollY
	ldr r1,[r1]
	strb r5,[r1]

	cmp r0,#255
	bne MaxTileSetScroll_Done
	
	adrl r1,adrbackgroundtilemapbase
	ldr r1,[r1]
	str r6,[r1]
	
MaxTileSetScroll_Done:		
	mov pc,lr
	
	
ShiftTilemap:
	adrl r6,adrbackgroundtilemapbase
	ldr r6,[r6]
	ldr r6,[r6]
	;move.l (backgroundtilemapbase),a3
	
	mov r10,r4,lsl #3	;*8 192
	
	.ifndef backgroundtilemapwidth32
		add r6,r6,r10		;hardcoded to 36*2 wide tilemap
	.endif
		
	mov r10,r10,lsl #3	;*64 1536
	add r6,r6,r10			;add ypos to A3

	mov r4,#backgroundtilemapwidthv*2
	
	mov r0,r1,lsl #1	;2 bytes per tile
	add r6,r6,r0			;add xpos D1 to A3
	
	mov pc,lr			;D4/C=Tilemap Width
	

MaxTileFlagForRedraw:;d1,d4 = XY d2,d5=wh
		
		STMFD sp!,{lr}
			bl ShiftTilemap
		LDMFD sp!,{lr}


ResetTilemapPart:
	mov r1,r2
	mov r3,r6
resettilemappartb:
		ldrb r0,[r6]
		orr r0,r0,#0x0001
		strb r0,[r6],#2	;flag tile for redraw
		subs r1,r1,#1
		bne resettilemappartb
	mov r6,r3

	add r6,r6,r4			;Down a line
	subs r5,r5,#1
	bne ResetTilemapPart
	mov pc,lr

	
;r6/HL=source tilemap r1/r4=BC=xy pos r5/de=offset (FF=End of line FF FF = end of string - 1 byte per tile DE=Offset)
MaxTilePrint:	
	mov r9,r6
	mov r8,r5
		STMFD sp!,{lr}
			bl ShiftTilemap
		LDMFD sp!,{lr}


MaxTilePrintY:
	mov r3,r6
MaxTilePrintX:
		ldrb r0,[r9],#1
		cmp r0,#255
		beq MaxTilePrint_Xdone
		add r0,r8,r0,lsl #4
		
		strb r0,[r6],#1	;Store Tile
		mov r0,r0,lsr #8
		strb r0,[r6],#1
		
		b MaxTilePrintX
MaxTilePrint_Xdone:
	ldrb r0,[r9]
	cmp r0,#255
	beq MaxTilePrint_Ydone

	mov r6,r3

	add r6,r6,r4			;Down a line
	b MaxTilePrintY
MaxTilePrint_Ydone:
	mov pc,lr
	
;R1,R4 B,C=X,Y pos R6/HL=Tile to fill with  R2,R5 D,E=Wid,Hei	
MaxTileDrawArea:	
	mov r9,r6
		STMFD sp!,{lr}
			bl ShiftTilemap
		LDMFD sp!,{lr}


MaxTileDrawAreaY:
	mov r1,r2
	mov r3,r6
MaxTileDrawAreaX:
		ldrb r0,[r9],#1
		strb r0,[r6],#1	;Store Tile
		ldrb r0,[r9],#1
		strb r0,[r6],#1
		
		subs r1,r1,#1
		bne MaxTileDrawAreaX
	mov r6,r3

	add r6,r6,r4			;Down a line
	subs r5,r5,#1
	bne MaxTileDrawAreaY
	mov pc,lr
	
	
;B,C=X,Y pos HL=Tile to fill with  D,E=Wid,Hei
MaxTileFillArea:			
	mov r9,r6
	mov r8,r6,lsr #8
		STMFD sp!,{lr}
			bl ShiftTilemap
		LDMFD sp!,{lr}


MaxTileFillAreaY:
	mov r1,r2
	mov r3,r6
MaxTileFillAreaX:
		strb r9,[r6],#1	;Store Tile
		strb r8,[r6],#1
		
		subs r1,r1,#1
		bne MaxTileFillAreaX
	mov r6,r3

	add r6,r6,r4			;Down a line
	subs r5,r5,#1
	bne MaxTileFillAreaY
	mov pc,lr

	
	
	
	
	
MaxTileRedraw:						;Draw straight to VRAM
	adrl r6,AdrScreenBase
	ldr r6,[r6]
	
	adrl r5,adrbackgroundtilemapbase
	ldr r5,[r5]
	ldr r5,[r5]
	adrl r4,MaxTilePatterns
	
	.ifdef BuildGBA
		mov r7,#30			;240 pixels =30 tiles
		mov r8,#20			;160 pixels = 20 tiles
		mov r9,#BackgroundTilemapWidthV*2
	.endif
	.ifdef BuildNDS
		mov r7,#32
		mov r8,#24
		mov r9,#BackgroundTilemapWidthV*2
	.endif
	.ifdef BuildROS
								;Center Vscreen
		add r6,r6,#16			;(160-120)/2
		add r6,r6,#0xF00		;(240-192/2)*160
		
		mov r7,#32
		mov r8,#24
		mov r9,#BackgroundTilemapWidthV*2
	.endif
	adrl r1,AdrBackgroundTilemapScrollX
	ldr r1,[r1]
	ldrb r1,[r1]
	
	adrl r2,AdrBackgroundTilemapScrollY
	ldr r2,[r2]
	ldrb r2,[r2]
	
	ands r1,r1,#0b00001100
	beq MaxTileRedraw_NoXShift
	.ifdef BuildGBA
		add r6,r6,r1
	.endif
	.ifdef BuildNDS
		add r6,r6,r1
	.endif
	.ifdef BuildROS
		add r6,r6,r1,lsr #2
	.endif
	sub r7,r7,#1			;Do one less X tile
MaxTileRedraw_NoXShift:	
	ands r2,r2,#0b00001100
	beq MaxTileRedraw_NoYShift
	sub r8,r8,#1			;Do one less Y tile
		
	
	.ifdef BuildGBA
		mov r1,#240
		mul r0,r2,r1
		add r6,r6,r0
	.endif
	.ifdef BuildNDS
		mov r1,#256
		mul r0,r2,r1
		add r6,r6,r0
	.endif
	.ifdef BuildROS
		mov r1,#80
		mul r0,r2,r1
		add r6,r6,r0
	.endif
MaxTileRedraw_NoYShift:	
	
	
;BC/r4  = Pattern Source
;DE/r5  = Source Tilemap
;HL/r6  = Vram Dest 
;IXH/D4/r7 = Draw Width IXL/D8=Draw Height
;IYH/A6/r9 = TilemapWidth

DrawTilemap:						;Draw straight to VRAM

	
NextLineD:
	STMFD sp!,{r7,r5,r6}
nexttile:	
		ldrb r0,[r5]		;A2=tilemap data 
		movs r0,r0,lsr #1			;get the 'needs update' bit
					
		.ifdef doublebuffered
			b drawtile	;update even if not needed!
		.else
			bcs drawtile	;update if needed
		.endif
emptytile:
		add r5,r5,#2 		;a2=tilemap data %NNNNXYPU %nnnnnnnn
TileDone:
;Platform specific commands to move across 8 pixels (one tile)

		.ifdef buildNDS
			add r6,r6,#16		;Across one tile
		.endif
		.ifdef buildGBA
			add r6,r6,#16		;Across one tile
		.endif
		
		.ifdef buildROS
			add r6,r6,#4		;Across one tile
		.endif
		
		subs r7,r7,#1
		bne nexttile
tiledone2:
	;moveM.l (sp)+,a2/a3/d7	;tilemap source / screen pos / width
	LDMFD sp!,{r7,r5,r6}
	
	
;Platform specific commands to move down 8 pixels (one strip of tiles)
	
	.ifdef buildNDS
		add r6,r6,#256*2*8		;Down one strip
	.endif
	.ifdef buildGBA
		add r6,r6,#240*2*8		;Down one strip
	.endif
	.ifdef buildROS
		add r6,r6,#160*8		;Down one strip
	.endif
	
	add r5,r5,r9				;Down a tilemap source
	
	subs r8,r8,#1				;Next v-line
	bne nextlined				;Repeat for next line
	mov pc,lr

	
	
		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
	
	
	
	.ifdef BuildGBA
		.include "\SrcGBA\V1_MaxTile.asm"	;MUST come before Adventure Engine!
	.endif
	.ifdef BuildNDS
		.include "\SrcNDS\V1_MaxTile.asm"	;MUST come before Adventure Engine!
	.endif
	.ifdef BuildROS
		.include "\SrcROS\V1_MaxTile.asm"	;MUST come before Adventure Engine!
	.endif
		
	.ifdef ScreenBase
AdrScreenBase: .long ScreenBase
	.endif
AdrBackgroundTilemapScrollX: .long BackgroundTilemapScrollX
AdrBackgroundTilemapScrollY: .long BackgroundTilemapScrollY

	
	