
	
	;BCD   Show R1
	
ShowBCDalt:				
	STMFD sp!,{r0-r4, lr}		
	b ShowBCDb
ShowBCD:			
	STMFD sp!,{r0-r4, lr}		
		mov r4,#8				;Char count
ShowBCDb:	
		and r0,r1,#0xF0000000	;Get a char
		mov r1,r1,lsl #4		;Remove it from R1
		
		mov r0,r0,lsr #28		;Shift char to -------X
		add r0,r0,#48			;Convrt to ascii +'0'
		bl PrintChar
	
		subs r4,r4,#1			
		bne ShowBCDb			;Repeat
		
	LDMFD sp!,{r0-r4, pc}		
	
	;BCD   R1=R1+R2	
AddBCD:
	STMFD sp!,{r2-r12, lr}		
		mov r0,#0				;Buildup
		mov r6,#0				;Carry
		mov r8,#0				;Rotation
		mov r7,#8				;Char count
		
AddBCDb:	
		and r3,r1,#0x0000000F	;Get A nibble of BCD1
		and r4,r2,#0x0000000F	;Get A nibble of BCD2
		
		add r3,r3,r4			;BCD1=BCD1+BCD2
		add r3,r3,r6			;Carry
		
		cmp r3,#10				;Any Overflow?
		blt AddBCD_NoOverFlow
		add r3,r3,#6			;Correct overflow
AddBCD_NoOverFlow:		

		and r5,r3,#0x00000000F
		orr r0,r0,r5,lsl r8		;OR this digit into result
		
		and r6,r3,#0x0000000F0	;Get the carry
		mov r6,r6,lsr #4		;Shift Carry
		
		mov r1,r1,lsr #4		;Remove nibble of BCD1
		mov r2,r2,lsr #4		;Remove nibble of BCD2
		
		add r8,r8,#4			;Increase Destination nibble
		
		subs r7,r7,#1
		bne AddBCDb				;Repeat
		
		mov r1,r0				;Final Value
	LDMFD sp!,{r2-r12, pc}	
	


	
	
	;BCD   R1=R1-R2
SubBCD:
	STMFD sp!,{r2-r12, lr}	
		mov r0,#0				;Buildup
		mov r6,#0				;Carry
		mov r8,#0				;Rotation
		mov r7,#8				;Char count
		
SubBCDb:	
		and r3,r1,#0x0000000F	;Get A nibble of BCD1
		and r4,r2,#0x0000000F	;Get A nibble of BCD2
		
		sub r3,r3,r4			;BCD1=BCD1+BCD2
		sub r3,r3,r6			;Carry
		
		mov r6,#0				;Zero Carry
		
		cmp r3,#0
		bgt SubBCD_NoOverFlow
		sub r3,r3,#6			;Correct overflow
		and r3,r3,#0x00000000F	
		mov r6,#1				;Set Carry
SubBCD_NoOverFlow:		
		
		orr r0,r0,r3,lsl r8		;OR this digit into result
		
		mov r1,r1,lsr #4		;Remove nibble of BCD1
		mov r2,r2,lsr #4		;Remove nibble of BCD2
		
		add r8,r8,#4			;Increase Destination nibble
		
		subs r7,r7,#1
		bne SubBCDb				;Repeat
		
		mov r1,r0				;Final Value
	LDMFD sp!,{r2-r12, pc}		
	