;As their screen format is similar This works for the GBA and NDS
	.align 4
	.ifndef MpBitmap_TileTints
MpBitmap_TileTints: .byte 255,0,0
	.endif
	
	.align 4
	
	.ifndef PaletteAddress
PaletteAddress:	.long GBA_mpbitmapPalettes
	.endif 

	.ifndef GBA_mpbitmapPalettes
GBA_mpbitmapPalettes:
		.word 0b0000000000000000; ;0  0b-BBBBBGGGGGRRRRR
		.word 0b0111110000010000; ;1  0b-BBBBBGGGGGRRRRR
		.word 0b0111111111100000; ;2  0b-BBBBBGGGGGRRRRR
		.word 0b0111111111111111; ;3  0b-BBBBBGGGGGRRRRR
		.word 0b0100000000000000; ;4  0b-BBBBBGGGGGRRRRR
		.word 0b0100000000010000; ;5  0b-BBBBBGGGGGRRRRR
		.word 0b0100001000000000; ;6  0b-BBBBBGGGGGRRRRR
		.word 0b0110001100011000; ;7  0b-BBBBBGGGGGRRRRR
		.word 0b0100001000010000; ;8  0b-BBBBBGGGGGRRRRR
		.word 0b0000000000011111; ;9  0b-BBBBBGGGGGRRRRR
		.word 0b0000001111100000; ;10  0b-BBBBBGGGGGRRRRR
		.word 0b0000001111111111; ;11  0b-BBBBBGGGGGRRRRR
		.word 0b0111110000000000; ;12  0b-BBBBBGGGGGRRRRR
		.word 0b0111110000011111; ;13  0b-BBBBBGGGGGRRRRR
		.word 0b0111111111100000; ;14  0b-BBBBBGGGGGRRRRR
		.word 0b0111111111111111; ;15  0b-BBBBBGGGGGRRRRR
	.endif 
	.align 4


;CS= offscreen / Result in R11	
mpbitmap_GetScreenPos:	
	and r5,r5,#0xFF				;Ypos
	and r2,r2,#0xFF				;Xpos
	
	.ifdef BuildGBA
		cmp r2,#240
		bcs mpbitmap_GetScreenPosAbort	;Offscreen?
		cmp r5,#160
		bcs mpbitmap_GetScreenPosAbort	;Offscreen?
	
		mov r11,#0x06000000 	;VRAM base
		add r11,r11,r2,lsl #1	;Xpos, 2 bytes per pixel
	
		mov r12,#240*2			;Ypos, 240 pixels per line,
		mul r10,r5,r12			; 2 bytes per pixel
		add r11,r11,r10
	.endif
	
	.ifdef BuildNDS
		cmp r2,#256
		bcs mpbitmap_GetScreenPosAbort	;Offscreen?
		cmp r5,#192
		bcs mpbitmap_GetScreenPosAbort	;Offscreen?
	
		mov r11,#0x06040000 	;VRAM base
		add r11,r11,r2,lsl #1	;Xpos, 2 bytes per pixel
	
		mov r12,#256*2			;Ypos, 256 pixels per line,
		mul r10,r5,r12			; 2 bytes per pixel
		add r11,r11,r10
	.endif
		
	mov r10,#1					;Set nothing (Clear Carry)
	adds r10,r10,#1				; CC=Draw OK
	
	mov pc,lr
		
mpbitmap_GetScreenPosAbort:
	mov pc,lr		  			;Carry Set CC=Offscreen, Can't draw
	
	
;R6 R2 LD= Xpos    R5 = Ypos  R0=Color
mpbitmap_setpixel:		
	STMFD sp!,{lr}
		
		bl mpbitmap_GetScreenPos	;R11=Vram Destination
		bcs mpbitmap_setpixel_Abort	;Can't draw if offscreen
				
		adrl r10,PaletteAddress
		ldr r10,[r10]				;Get a color in screen format
		ldr r10,[r10,r0,lsl #1]		; (%ABBBBBGGGGGRRRRR)
		
		.ifdef BuildNDS
			orr r10,r10,#0x8000		;Make sure we aren't transparent!
		.endif 
		strh r10,[r11]
		
mpbitmap_setpixel_Abort:	
	LDMFD sp!,{pc}
	
	

;r6 r2 LD= Xpos    r5 = Ypos
mpbitmap_getpixel:		;Get a pixel from the screen
	STMFD sp!,{lr}
		mov r0,#0
	
		bl mpbitmap_GetScreenPos	;R11=Vram Destination
		bcs mpbitmap_getpixel_Abort	;Can't draw if offscreen
				
		ldrh r12,[r11]				;Get a byte from the screen
		bl mpbitmap_getpixel_FindColor ;Convert to 0-15
		mov r0,r12
mpbitmap_getpixel_Abort:	
	LDMFD sp!,{pc}

	
;R12= Screen color / R12=Found Color
mpbitmap_getpixel_FindColor:	
	STMFD sp!,{lr,r10,r11,r0}
		mov r0,#0
		adrl r10,PaletteAddress		;Get a color in screen format
		ldr r10,[r10]				; (%ABBBBBGGGGGRRRRR)
		
mpbitmap_getpixel_FindColorAgain:		
		ldrh r11,[r10],#2			;Get a color from the palette
		.ifdef BuildNDS
			orr r11,r11,#0x8000		;Make sure we aren't transparent!
		.endif 
		cmp r11,r12					;See if it matches
		beq mpbitmap_getpixel_FindColorDone
		
		add r0,r0,#1				;Color +1
		cmp r0,#16					;No Color match (>=16)
		bne mpbitmap_getpixel_FindColorAgain
		
mpbitmap_getpixel_FindColorDone:			
		mov r12,r0					;Result in R0
	LDMFD sp!,{pc,r10,r11,r0}	
		

;HL/R6 = Source Pat D/R2=Xpos (tiles)
; E/R5=Ypos (Tiles) R0=Bitplanes
mpbitmap_settile:	
	STMFD sp!,{lr,r1,r2,r3,r4}
		mov r2,r2,lsl #3			;8x8 Tiles to pixels
		mov r5,r5,lsl #3
	
		bl mpbitmap_GetScreenPos	;R11=Vram Destination
		bcs mpbitmap_settile_Abort	;Can't draw if offscreen
		
		adrl r10,PaletteAddress
		ldr r10,[r10]				;Get the palette address
		
		mov r8,#8					;Line count
mpbitmap_settileY:				
		STMFD sp!,{r11}
			mov r9,#8				;Pixel count
			
			adrl r1,MpBitmap_TileTints
			
			ldrb r2,[r1],#1			;Load default tints
			ldrb r3,[r1],#1			; (Used when source doesn't have
			ldrb r4,[r1],#1			;  enough bitplanes)
			mov r1,#0
			
			ldrb r1,[r6],#1			;Get Bitplane 0
			cmp r0,#1
			beq mpbitmap_settileX	;More bitplanes?
			
			ldrb r2,[r6],#1			;Get Bitplane 1
			cmp r0,#2
			beq mpbitmap_settileX	;More bitplanes?
			
			ldrb r3,[r6],#1			;Get Bitplane 2
			cmp r0,#3
			beq mpbitmap_settileX	;More bitplanes?
			
			ldrb r4,[r6],#1			;Get Bitplane 3
				
mpbitmap_settileX:		
			mov r12,#0
			and r7,r1,#0x0080		;Get leftmost bit (bitplane 0)
			orr r12,r12,r7,lsr #7

			and r7,r2,#0x0080		;Get leftmost bit (bitplane 1)
			orr r12,r12,r7,lsr #6
			
			and r7,r3,#0x0080		;Get leftmost bit (bitplane 2)
			orr r12,r12,r7,lsr #5
			
			and r7,r3,#0x0080		;Get leftmost bit (bitplane 3)
			orr r12,r12,r7,lsr #4
			
			mov r1,r1,lsl #1		;Shift all bitplanes left 1 pixel
			mov r2,r2,lsl #1
			mov r3,r3,lsl #1
			mov r4,r4,lsl #1
			
			ldr r12,[r10,r12,lsl #1] ;Convert to screen data via palette
			.ifdef BuildNDS
				orr r12,r12,#0x8000	;Make sure we aren't transparent!
			.endif 
			strh r12,[r11],#2		;Store the color to the screen
			
			subs r9,r9,#1
			bne mpbitmap_settileX
		
		LDMFD sp!,{R11}
		
		.ifdef BuildNDS
			add r11,r11,#256*2		;Down a line
		.endif
		.ifdef BuildGBA
			add r11,r11,#240*2		;Down a line
		.endif
		
		subs r8,r8,#1
		bne mpbitmap_settileY
		
;You don't need these lines if you're not using ChibiVM
		bl VM_SaveA6R10
		adrl r11,ReturnKey2
		ldr r9,[r11]		;#$66660000
		
mpbitmap_settile_Abort:
	LDMFD sp!,{pc,r1,r2,r3,r4}
	
	
	
;HL/R6 = Dest Pat D/R2=Xpos (tiles)
; E/R5=Ypos (Tiles) R0=Bitplanes
mpbitmap_gettile:	
	STMFD sp!,{lr,r1,r2,r3,r4}
		mov r2,r2,lsl #3			;8x8 Tiles to pixels
		mov r5,r5,lsl #3
	
		bl mpbitmap_GetScreenPos	;R11=Vram Destination
		bcs mpbitmap_gettile_Abort	;Can't draw if offscreen
		
		mov r8,#8					;Line count
mpbitmap_gettileY:				
		STMFD sp!,{r11}
			mov r9,#8
			
			mov r1,#0
			mov r2,#0
			mov r3,#0
			mov r4,#0
			
mpbitmap_gettileX:		
			ldrh r12,[r11],#2			   ;Get a screen color
			bl mpbitmap_getpixel_FindColor ; (%ABBBBBGGGGGRRRRR)
			
			mov r1,r1,lsl #1		;Shift all bitplanes left 1 bit
			mov r2,r2,lsl #1
			mov r3,r3,lsl #1
			mov r4,r4,lsl #1
			
			and r7,r12,#0x0001		;Bitplane 0
			orr r1,r1,r7
			
			and r7,r12,#0x0002		;Bitplane 1
			orr r2,r2,r7,lsr #1
			
			and r7,r12,#0x0004		;Bitplane 2
			orr r3,r3,r7,lsr #2
			
			and r7,r12,#0x0008		;Bitplane 3
			orr r4,r4,r7,lsr #3
			
			subs r9,r9,#1			;Xloop
			bne mpbitmap_gettileX
		
		LDMFD sp!,{R11}
		
		strb r1,[r6],#1				;Store bitplane 0
		cmp r0,#1
		beq mpbitmap_SetTileLineDone ;More bitplanes?
		
		strb r2,[r6],#1				;Store bitplane 1
		cmp r0,#2
		beq mpbitmap_SetTileLineDone ;More bitplanes?
		
		strb r3,[r6],#1				;Store bitplane 2
		cmp r0,#3
		beq mpbitmap_SetTileLineDone ;More bitplanes?
		
		strb r4,[r6],#1				;Store bitplane 3
		
mpbitmap_SetTileLineDone:		
		.ifdef BuildNDS
			add r11,r11,#256*2		;Down a line
		.endif
		.ifdef BuildGBA
			add r11,r11,#240*2		;Down a line
		.endif
		
		subs r8,r8,#1
		bne mpbitmap_gettileY

;You don't need these lines if you're not using ChibiVM
		bl VM_SaveA6R10
		adrl r11,ReturnKey2
		ldr r9,[r11]		;#$66660000
		
mpbitmap_gettile_Abort:
	LDMFD sp!,{pc,r1,r2,r3,r4}


	
	
	
;Used by ChibiVM Syscall routine
MBCall:	 ;Return address is on stack!
		adrl r8,vecMB
	b ChibiVM_VectorCall	
	
	
	.align 4
	
.equ mbSetpixel,0
.equ mbGetpixel,1
.equ mbSettile,2
.equ mbGettile,3

vecMB:
	.long mpbitmap_setpixel ;0
	.long mpbitmap_getpixel ;1
	.long mpbitmap_settile	;2
	.long mpbitmap_gettile	;3
	
	.align 4
;regNO equ %11000000		;Don't Read or Write Regs
;regRR equ %10000000		;Only Read Regs
;regWW equ %01000000		;Only Write Regs

