;This module works for GBA AND NDS!!!!

NativeSpriteCall:	 ;Return address is on stack!
	adrl r8,vecNS	
	b ChibiVM_VectorCall	

.equ nsInit,0	
.equ nsDraw,1
.equ nsDrawExtra,2
.equ nsDrawArray,3
.equ nsHide,4
.equ nsClearUnused,5
.equ nsHideAll,6

vecNS:
	.long NativeSpr_InitReiKou ;dw NativeSpr_InitReiKou	;0
	.long DummySyscall ;dw NativeSpr_Draw	;1
	.long DummySyscall ;dw NativeSpr_DrawExtra ;2
	.long NativeSpr_DrawArrayReiKou ;dw NativeSpr_DrawArrayReiKou ;3
	.long DummySyscall ;dw NativeSpr_Hide ;4
	.long DummySyscall ;dw NativeSpr_ClearUnused ;5
	.long HideAll

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


		
NativeSpr_InitReiKou:
	STMFD sp!,{lr}
		bl AddressRemapViaTableR6
		b NativeSpr_Initb
		
		
NativeSpr_Init:			;R6=Sprite source
	STMFD sp!,{lr}
	
NativeSpr_Initb:	
;Define patterns 
	.ifdef BuildGBA
		;mov r2,#0x06010000		;Sprite Pattern Ram (Tilemap mode)
		mov r2,#0x06014000		;Sprite Pattern Ram (Bitmap mode
	.endif											;  - Tiles 512+)
	.ifdef BuildNDS
		mov r0, #0x4000000
		add r0, r0, #0x241
		mov r1, #0x82	;Turn on Sprite RAM
		strb r1, [r0]	;4000241h - NDS9 - VRAMCNT_B - 8bit
						;			VRAM-B (128K) Bank Control (W)
		mov r2,#0x06400000		;Sprite Pattern Ram
	.endif
	mov r1,#GBA_SpritePatternCount
	mov r1,r1,lsl #5	;*32 (64/2)
	
NativeSpr_Init_TransferPattern:
	ldrh r0,[r6],#2		;Get a half
	strh r0,[r2],#2		;Send it to vram
	subs r1,r1,#1
	bne NativeSpr_Init_TransferPattern
	
;Define palette
	adrl r3,GBA_SpritePalettes
	mov r2,#0x05000200			;Sprite Palettes
	mov r1,#256
NativeSpr_Init_Palette:
	ldrh r0,[r3],#2
	strh r0,[r2],#2
	subs r1,r1,#1
	bne NativeSpr_Init_Palette	
	
;Turn on sprites
	.ifdef BuildGBA
		mov r1,#0x04000000  ;DISPCNT -LCD Control
		ldr r0,[r1]
		orr r0,r0,#0x1040    	;1= Sprite on / 1= Layer 0 on 
								;  / 4= 1D Tile layout 
		str	r0,[r1]         	;0= ScreenMode 0 
	.endif
	.ifdef BuildNDS
		mov r0, #0x04000000	;4000000h - DISPCNT - LCD Control (R/W)
		mov r1,    #0x00010000	;1=Display On
		orr r1,r1, #0x00001000	;1=Sprites on
		orr r1,r1, #0x00000800	;8= BG3 On
		orr r1,r1, #0x00000005	;5= Mode 5
		str r1, [r0]
	.endif							
	LDMFD sp!,{pc}
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


NativeSpr_DrawArrayReikou:
	STMFD sp!,{lr}
	
	
		bl AddressRemapViaTableR6	
		adrl r10,HspriteCountAdr
		ldr r10,[r10]
		
		mov r0,#0
		strb r0,[r10]	;Spritecount=0
		
		ldrb r7,[r6],#1  	;Sprite Count
		cmp r7,#0
		beq NativeSpr_ClearUnused_RK
		
NativeSpr_DrawArrayB_RK:	
		ldrb r4,[r6],#1		;Ypos 
		ldrb r1,[r6],#1		;Xpos 
		
		ldrb r0,[r6],#1		;NativeSpriteDef L
		ldrb r5,[r6],#1		;NativeSpriteDef H
		
		mov r5,r5,lsl #8
		add r5,r5,r0
		
		STMFD sp!,{r7,r6}
			mov r6,r5
			bl AddressRemapViaTableR6	
			mov r5,r6
			bl NativeSpr_DrawExtra
		LDMFD sp!,{r7,r6}
		
		subs r7,r7,#1
		bne NativeSpr_DrawArrayB_RK

		
		
NativeSpr_ClearUnused_RK:
	adrl r10,HspriteCountAdr
	ldr r10,[r10]
	ldrb r0,[r10]
		
NativeSpr_ClearUnused_Again:
	mov r9,#0x07000000  	;Sprite (OAM) settings
	add r9,r9,r0,lsl #3		;8 bytes per sprite (6 used)

	mov r1,#255		;255=offscreen
	strh r1,[r9],#2			;SSCMTTDRYYYYYYYY
	strh r1,[r9],#2			;SSVHRRRXXXXXXXXX
	strh r1,[r9],#2			;CCCCPPTTTTTTTTTT
	strh r1,[r9],#2			;unused
	
	add r0,r0,#1

	cmp r0,#128				;Done all sprites?
	blt NativeSpr_ClearUnused_Again
	
	LDMFD sp!,{pc}
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
HideAll:
	STMFD sp!,{lr}
	adrl r10,HspriteCountAdr
	ldr r10,[r10]			
		
	mov r0,#0
	strb r0,[r10]	;Spritecount=0
		
	b NativeSpr_ClearUnused_RK	
	
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

HspriteCountAdr: .long HspriteCount		

NativeSpr_DrawArray:
	STMFD sp!,{lr}
		adrl r10,HspriteCountAdr
		ldr r10,[r10]
		
		mov r0,#0
		str r0,[r10]		;Zero used sprtite count
		
		ldr r7,[r6],#4  	;Array Sprite Count

NativeSpr_DrawArrayB:	
		ldr r1,[r6],#4		;Xpos 
		ldr r4,[r6],#4		;Ypos 
		
		ldr r5,[r6],#4		;NativeSpriteDef
		
		STMFD sp!,{r7,r6,lr}
			bl NativeSpr_DrawExtra	;Draw this sprite
		LDMFD sp!,{r7,r6,lr}
		
		subs r7,r7,#1
		bne NativeSpr_DrawArrayB

	b NativeSpr_ClearUnused_RK
		

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

NativeSpr_DrawExtra:	
	adrl r10,HspriteCountAdr
	ldr r10,[r10]
	ldrb r0,[r10]		;Next H-Sprnum
	STMFD sp!,{r10,lr}
		bl NativeSpr_Draw	;Draw the sprite
	LDMFD sp!,{r10,lr}
	strb r0,[r10]		;Next H-Sprnum
	mov pc,lr
		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

NativeSpr_Sizes:	;Combinations of 2 shape bits / 2 size bits
;Shape 0 = Square
	.long 8,8
	.long 16,16
	.long 32,32
	.long 64,64
;Shape 1 = Wide
	.long 16,8
	.long 32,8
	.long 32,16
	.long 64,32
;Shape 2 = Tall
	.long 8,16
	.long 8,32
	.long 8,32
	.long 8,64
;Shape = 3 isn't allowed!
	.long 0,0,0,0,0,0,0,0		

;r1,r4=XY in pairs of pixels r5=SpriteDef r0=HspriteNum	

NativeSpr_Draw:	
	ldrb r7,[r5],#1		;Wid
	ldrb r8,[r5],#1		;Hei
	ldrh r10,[r5],#2		;Attrib1
	ldrh r11,[r5],#2		;Attrib2
	ldrh r12,[r5],#2		;Attrib3
	
	adrl r2,NativeSpr_Sizes
	
	mov r6,r11				;Test size bits
	ands r6,r6,#0xC000		; SSVHRRRXXXXXXXXX
NativeSpr_SetSizeAgain:
	beq NativeSpr_SetSizeDone
	add r2,r2,#8			;8 bytes per size
	subs r6,r6,#0x4000
	b NativeSpr_SetSizeAgain	
NativeSpr_SetSizeDone:		

	mov r6,r10				;test shape bits
	ands r6,r6,#0xC000		; SSCMTTDRYYYYYYYY
NativeSpr_SetShapeAgain:
	beq NativeSpr_SetShapeDone
	add r2,r2,#32			;32 bytes per shape
	subs r6,r6,#0x4000
	b NativeSpr_SetShapeAgain	
NativeSpr_SetShapeDone:	

	sub r4,r4,#VscreenMinY
	mov r4,r4,lsl #1		;Logical Units to pixels
	
	sub r1,r1,#VscreenMinX	
	mov r1,r1,lsl #1 		;Logical Units to pixels
		
NativeSpr_DrawY:
	STMFD sp!,{r7,r1}
NativeSpr_DrawX:			

		ldrh r6,[r5]
		mov r9,#0xFFFF
		cmp r6,r9		;0XFFFF = Unused Tile
		beq NativeSpr_SkipOne

		mov r9,#0x07000000  	;Sprite (OAM) settings
		add r9,r9,r0,lsl #3		;8 bytes per sprite (6 used)
		
;S=Shape (Square /HRect / Vrect)  C=Colors(16/256)  M=Mosiac 
;T=Transparent  D=Disable/Doublesize  R=Rotation  Y=Ypos
		orr r6,r10,r4
		strH r6,[r9],#2    		;1st attrib - SSCMTTDRYYYYYYYY
			
;S=Obj Size  VH=V/HFlip  R=Rotation parameter  X=Xpos
		orr r6,r11,r1
		strH r6,[r9],#2    		;2nd attrib - SSVHRRRXXXXXXXXX
			
;C=Color palette   P=Priority   T=Tile Number
		ldrh r6,[r5]			;Tile Number
		
		.ifdef BuildGBA
			add r6,r6,#512		;First tilenumber in bmp mode
		.endif
		
		orr r6,r12,r6
		strH r6,[r9]    		;3rd attrib - CCCCPPTTTTTTTTTT
		
		add r0,r0,#1	;Next Hsprite
		
		ldr r6,[r2,#0]
		add r1,r1,r6	;Xpos+=???
NativeSpr_SkipOne:		
		add r5,r5,#2	;Next source
		
		subs r7,r7,#1
		bne NativeSpr_DrawX
	LDMFD sp!,{r7,r1}
	ldr r6,[r2,#4]
	add r4,r4,r6		;Ypos+=????
	
	subs r8,r8,#1
	bne NativeSpr_DrawY
		
	mov pc,lr
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
