
	
	
dorandom:				;RND outputs 8bit to R0 (no input)
	STMFD sp!,{r1-r6,lr}	
		mov r10,#randomseed	
		ldrh r1,[r10]			;Load 16 bit randomseed
		add r1,r1,#1			;INC R0
		add r1,r1,#0xFFFF0000	;Ensure register wraps around 
		strh r1,[r10]								;in 16 bits
		bl dorandomword			;Get Random R3/R6
		eor r0,r6,r3	
		and r0,r0,#0xff			;Cut down to 1 byte
	LDMFD sp!,{r1-r6,pc}	
	
RseedAddr:
	.long randomseed
	
dorandomword:	;Return Random pair in R6,R3 from Seed R1
	STMFD sp!,{lr}
		mov r0,#0		
		mov r4,r1				
		and r4,r4,#0x0000FF00 		;Get top byte of seed
		mov r4,r4,ror #8			;Move to bottom byte
		bl dorandombyte1			;Get 1st byte
		STMFD sp!,{r0}	
			STMFD sp!,{r1,r4} 	
				bl dorandombyte2	;Get 2nd byte
			LDMFD sp!,{r1,r4} 
			mov r6,r0				;Store 2nd byte in R6
		LDMFD sp!,{r3}				;Store 1st byte in R3
		add r1,r1,#1				;INC seed
	LDMFD sp!,{pc}
	
	
dorandombyte1:		;Return Byte R0 from Seeds R1/R4
	STMFD sp!,{lr}
		mov r0,r1 				;Get 1st seed
dorandombyte1b:
		and r0,r0,#0x000000FF
		orr r0,r0,r0, ror #24	;Fill 2nd byte byte 0x----FF--
		
		mov r0,r0,ror #2 		;Rotate Right
		eor r0,r0,r1			;Xor 1st Seed

		and r0,r0,#0x000000FF
		orr r0,r0,r0, ror #24	;Fill 2nd byte byte 0x----FF--
		
		mov r0,r0,ror #2 		;Rotate Right
		eor r0,r0,r4 			;Xor 2nd Seed
		
		and r0,r0,#0x000000FF
		orr r0,r0,r0, ror #24	;Fill 2nd byte byte 0x----FF--
		
		mov r0,r0,ror #1		;Rotate Right
		eor r0,r0,#0b10011101 	;Xor Constant
		eor r0,r0,r1 			;Xor 1st seed
		
		and r0,r0,#0x000000FF 	;Mask 1 byte
	LDMFD sp!,{pc}

	
dorandombyte2:		;Return Byte R0 from Seeds R1/R4
	STMFD sp!,{lr}
		adr r3,Randoms1			;LUT 1
		mov r0,r4 
		eor r0,r0,#0b00001011
		and r0,r0,#0b00001111 	;Convert 2nd seed low nibble to
									;Lookup offset
		
		ldrb r2,[r3,r0]			;Get Byte from LUT 1
		bl dorandombyte1		;Use 1st generator
		
		and r0,r0,#0b00001111 	;Convert random number from 
		adr r3,randoms2 			;1st generator to Lookup
		ldrb r0,[r3,r0]			;Get Byte from LUT2
		eor r0,r0,r2			;Xor 1st lookup
		and r0,r0,#0x000000FF 	;Mask to 1 byte
	LDMFD sp!,{pc}
	
	
	