;Some older Versions of DeSmuME will produce a clicking noise on
;  sample loop, but DeSmuME_0.9.13_x64.exe does not seem to,
; therefore I am forced to assume this is an emulator issue
; as I can find no coding error at this time.

;See if we have a command
ChibiSoundLoop:
		mov r1,#ChibiSoundb			;0x02F00008
		ldrb r0,[r1,#1]				;2nd byte= NZ=process!
		cmp r0,#0
		beq ChibiSoundDriverIdle	;1=ChibiSound 2=ChibiSound PRO
		cmp r0,#2
		beq ChibiSoundProDriver		;1=ChibiSound 2=ChibiSound PRO
		cmp r0,#3
		beq ChibiSoundProInitDriver	;3=Pro Init
		cmp r0,#1
		beq ChibiSoundDriver
	
ChibiSoundDriverDone:
	mov r1,#ChibiSoundb				;0x02F00008
	mov r0,#0
	strb r0,[r1,#1]
	b ChibiSoundDriverIdle
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
; ChibiSound 	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ChibiSoundDriver:
	
;See if we need to mute
		ldrb r0,[r1,#0]		;1st Byte= Chibisound Command
		cmp r0,#0
		bne ChibiSoundDriverMakeSound

;ChibiSoundDriverMute
		mov r1,#0x4000000 ;4000500h - NDS7 - SOUNDCNT - Sound Control Register (R/W)
		add r1,r1,#0x500
				;M-31RRLL-vvvvvvv
		mov r2,#0b000000000000000
		str r2,[r1]
		b ChibiSoundDriverDone
		
ChibiSoundDriverMakeSound:
		
;Turn on Sound
		mov r1,#0x4000000 ;4000304h - POWCNT2 - Sound/Wifi Power Control Register (R/W)
		add r1,r1,#0x304
		mov r2,#1
		str r2,[r1]
		
;Source Sample 
		mov r1,#0x4000000 ;40004x4h - SOUNDxSAD - Sound Channel X Data Source Register (W) - aligned to a 32 bit boundary (4 byte)
		add r1,r1,#0x404
		adrl r2,WavTone					;Tone Sample
		tst r0,#0b10000000		;Noise Bit
		beq ChibiSoundDriverTone
		adrl r2,WavNoise				;Noise Sample
ChibiSoundDriverTone:
		str r2,[r1]

;Sample Loop Start
		mov r1,#0x4000000 ;40004xAh - SOUNDxPNT - Sound Channel X Loopstart Register (W)
		add r1,r1,#0x40A
		mov r2,#1				;Loop From First byte
		str r2,[r1]
;Sample Length
		mov r1,#0x4000000 ;40004xCh - SOUNDxLEN - Sound Channel X Length Register (W)
		add r1,r1,#0x40C
		mov r2,#63 				;Sound Samples in bytes /4 
		str r2,[r1]
		
;Frequency
		mov r1,#0x4000000 ;40004x8h - SOUNDxTMR - Sound Channel X Timer Register (W)
		add r1,r1,#0x408
		and r2,r0,#0b00111111
		eor r2,r2,#0b00111111
		add r2,r2,#0b01000000
		mov r2,r2,asl #8
		mov r2,r2,asl #1
		str r2,[r1]
		
;Volume	
		mov r1,#0x4000000 ;4000500h - SOUNDCNT - Sound Control Register (R/W)
		add r1,r1,#0x500
				;M-31RRLL-VVVVVVV
		mov r2,#0b000000001111111
					;M-31RRLL-VVVVVVV
		add r2,r2,#0b1011000000000000
		str r2,[r1]
		
;Start the Sound
		mov r1,#0x4000000 ;40004x0h - SOUNDxCNT - Sound Channel X Control Register (R/W)
		add r1,r1,#0x400
		and r2,r0,#0b01000000
				   ;SFFRRWWW-PPPPPPPH-----DD-vvvvvvv FF=format (0=8bit signed) v=volume
		orr r2,r2,#0b0000000000000000000000000111111
					;SFFRRWWW-PPPPPPPH-----DD-vvvvvvv S=Start R=Repeat (Loop inf) P=Panning (64=center)
		add r2,r2,#0b10001000010000000000000000000000
		str r2,[r1]

		b ChibiSoundDriverDone
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
; ChibiSound PRO
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ChibiSoundProInitDriver:
	
;Turn on Sound
	mov r1,#0x4000000 ;0x4000304 - POWCNT2 Sound/Wifi Power
	add r1,r1,#0x304  ;				      Control Register (R/W)
	mov r2,#1
	str r2,[r1]
	
;Volume	
	mov r1,#0x4000000 ;0x4000500 - SOUNDCNT Sound Control Register (R/W)
	add r1,r1,#0x500
			 ;M-31RRLL-VVVVVVV
	mov r2,#0b0000000001111111
				;M-31RRLL-VVVVVVV
	add r2,r2,#0b1011000000000000
	str r2,[r1]	
	
	b ChibiSoundDriverDone

	
;r3=volume (0-255) 
;r6=channel num (0-127 unused channels will wrap around) / top bit=noise
;r2=pitch (0-65535) Higher=Higher Pitch
	
	
	
ChibiSoundProDriver:		;R1=0x02F00008
;Get params from shared memory 
	ldrb r3,[r1,#2]		;Vol
	ldrb r6,[r1,#3]		;Channel
	ldrh r5,[r1,#4]		;Pitch
		
;Calculate Channel base address R7
	mov r7,r6
	and r7,r7,#0b00000011
	mov r7,r7,lsl #4		;Channel *16
	add r7,r7,#0x4000000 
	add r7,r7,#0x0000400	;0x40004c0 where c=channel
	
	
;Source Sample 
	adrl r0,WavTone			;Tone Sample
	tst r6,#0b10000000		;Noise Bit
	beq ChibiSoundProDriverTone
	adrl r0,WavNoise		;Noise Sample
ChibiSoundProDriverTone:
	str r0,[r7,#4]			;0x40004x4 SOUNDxSAD Sound Channel X Data
							;          Source Register (W) 32 bit aligned
;Sample Loop Start
	mov r0,#1				;Loop From First byte
	strh r0,[r7,#0x0A]		;0x40004xA SOUNDxPNT Sound Channel X Loopstart
;Sample Length
	mov r0,#63 				;Sound Samples in bytes /4 
	str r0,[r7,#0xC]		;0x40004xC SOUNDxLEN Sound Channel X Length (W)

	
;Frequency
	strh r5,[r7,#8]
	
;Start the Sound & Set Volume (v=127 is max)
	mov r0,r3,lsr #1
				;SFFRRWWW-PPPPPPPH-----DD-vvvvvvv S=Start R=Repeat
	add r0,r0,#0b10001000010000000000000000000000	; (Loop inf) 
	str r0,[r7,#0]							;P=Panning (64=center)
	
	b ChibiSoundDriverDone
	
	

	;.align 4

WavTone:	;8 bit 32x4 samples (signed)
	.byte 000,000,128,128,000,000,128,128	
	.byte 000,000,128,128,000,000,128,128
	.byte 000,000,128,128,000,000,128,128
	.byte 000,000,128,128,000,000,128,128	;32
	.byte 000,000,128,128,000,000,128,128	
	.byte 000,000,128,128,000,000,128,128
	.byte 000,000,128,128,000,000,128,128
	.byte 000,000,128,128,000,000,128,128	;32
	.byte 000,000,128,128,000,000,128,128	
	.byte 000,000,128,128,000,000,128,128
	.byte 000,000,128,128,000,000,128,128
	.byte 000,000,128,128,000,000,128,128	;32
	.byte 000,000,128,128,000,000,128,128	
	.byte 000,000,128,128,000,000,128,128
	.byte 000,000,128,128,000,000,128,128
	.byte 000,000,128,128,000,000,128,128	;32
	.byte 000,000,128,128,000,000,128,128	
	.byte 000,000,128,128,000,000,128,128
	.byte 000,000,128,128,000,000,128,128
	.byte 000,000,128,128,000,000,128,128	;32
	.byte 000,000,128,128,000,000,128,128	
	.byte 000,000,128,128,000,000,128,128
	.byte 000,000,128,128,000,000,128,128
	.byte 000,000,128,128,000,000,128,128	;32
	.byte 000,000,128,128,000,000,128,128	
	.byte 000,000,128,128,000,000,128,128
	.byte 000,000,128,128,000,000,128,128
	.byte 000,000,128,128,000,000,128,128	;32
	.byte 000,000,128,128,000,000,128,128	
	.byte 000,000,128,128,000,000,128,128
	.byte 000,000,128,128,000,000,128,128
	.byte 000,000,128,128,000,000,128,128	;32
	
WavNoise:	;8 bit 32x4 samples
	;Or we can program code as a 'random' sample!!
	.byte 0xa7,0x00,0xda,0xca,0xc2,0x06,0xd6,0xb8,0x13,0x97,0xca,0x2e,0xb6,0x1e,0x96,0x1a
	.byte 0xa5,0xb5,0x42,0xe3,0x42,0x2e,0x8b,0x5c,0x45,0x25,0xda,0xf1,0x58,0x21,0x04,0x75
	.byte 0x62,0x9c,0x82,0x80,0x92,0xd1,0x31,0x3a,0xd5,0x6a,0x5d,0x62,0xc5,0x42,0xe1,0x6c
	.byte 0x94,0xf2,0xe3,0x47,0xd9,0x46,0x6c,0x79,0x35,0xe0,0x4c,0x3e,0x43,0xc6,0x2c,0x69
	.byte 0xd7,0x8e,0x21,0xea,0x4c,0xca,0x46,0xd0,0xd2,0x63,0x7b,0x35,0xb7,0x7a,0xdf,0xfe
	.byte 0x6b,0xb2,0x70,0x87,0x13,0xbd,0x63,0x98,0xbf,0x9a,0xa5,0xbf,0x30,0xc0,0xad,0x23
	.byte 0x40,0x19,0x7a,0x45,0x6a,0xd0,0x8f,0x94,0xe1,0xa6,0x72,0x81,0xca,0xee,0xbe,0x27
	.byte 0xbb,0xa8,0xdb,0x84,0x75,0x8f,0x4c,0x3c,0x50,0xef,0x0c,0x2a,0x2e,0x9d,0x1d,0xbb
	.byte 0x39,0xf1,0xc9,0xa8,0x7d,0x3c,0xc1,0x95,0x69,0x9e,0x77,0xa2,0xda,0x18,0x76,0x7b
	.byte 0xbe,0x3e,0xff,0x5b,0x00,0xe4,0x11,0xe3,0x34,0x3d,0xd3,0x20,0x9c,0x50,0x57,0xb8
	.byte 0xc5,0x09,0xb8,0x6d,0xcf,0xb0,0xaa,0xb0,0xf7,0x5f,0xad,0x66,0x8c,0xd0,0x6d,0x76
	.byte 0x92,0x63,0x40,0x0a,0xc6,0xd6,0x36,0x17,0xa8,0x56,0x24,0xbe,0x63,0x43,0x24,0x8e
	.byte 0x8e,0xa6,0x88,0x65,0x37,0x09,0x40,0x47,0x91,0x25,0x51,0xc4,0x00,0xd9,0x3c,0x1b
	.byte 0xe6,0x70,0x25,0x6b,0x99,0xd8,0x56,0xee,0x41,0xb9,0x92,0x18,0x90,0x74,0xf8,0xcf
	.byte 0xad,0xe1,0x05,0xd6,0xf8,0x3b,0x03,0xf7,0x57,0xe9,0x5a,0xa7,0x72,0xfa,0x0b,0x6e
	.byte 0x2e,0x00,0xc4,0x7f,0x77,0x90,0x99,0x50,0xc1,0xef,0xbd,0x34,0x74,0x68,0x95,0x8f
	
;	.align 4
Sound_End:	

ChibiSoundDriverIdle:
	

	