

	.align 4
	.ifndef MpBitmap_TileTints
MpBitmap_TileTints:
		.byte 255,0,0,0
	.endif
	.align 4
	
mpbitmap_GetScreenPosTile:
		and r5,r5,#0xFF
		and r2,r2,#0xFF		
		mov r2,r2,lsl #3	;3 pixels per tile
		mov r5,r5,lsl #3
		b mpbitmap_GetScreenPosB
	
;CS= offscreen / Result in R11		
mpbitmap_GetScreenPos:	;CS= offscreen / Result in R11
		and r5,r5,#0xFF
		and r2,r2,#0xFF		;R2(D) is bottom byte of Xpos
		and r6,r6,#0xFF		;R6(L) is top byte of Xpos
		add r2,r2,r6,lsl #8	; This is for z80 compatability

mpbitmap_GetScreenPosB:		
			cmp r2,#320
			bcs mpbitmap_GetScreenPosAbort 	;Offscreen?
		
			cmp r5,#192
			bcs mpbitmap_GetScreenPosAbort	;Offscreen?
		
			adrl r11,AdrScreenBase
			ldr r11,[r11]			;Get Screen Base
		
			add r11,r11,r2,lsr #1	;Xpos, 2 pixels per byte
		
			mov r12,#160			;Ypos, 320 pixels per line,
			mul r10,r5,r12			;      2 pixels per byte
			add r11,r11,r10
		
	mov r10,#1			;Set nothing (Clear Carry)
	adds r10,r10,#1
	mov pc,lr
		
mpbitmap_GetScreenPosAbort:
	mov pc,lr			;Carry Set CC=Offscreen, Can't draw
	
	
	
;R6 R2 LD= Xpos    R5 = Ypos  R0=Color	
mpbitmap_setpixel:		
	STMFD sp!,{lr}
	
		bl mpbitmap_GetScreenPos		;R11=Vram Destination
		bcs mpbitmap_setpixel_Abort		;Can't draw if offscreen
			
		and r0,r0,#0x0F					;Limit color to 0-16
				
		mov r12,#0xF0					;Mask for Pixel to Keep
		
		tst r2,#0b00000001				;2 pixels per byte,
		beq mpbitmap_setpixelLeftPixel	; which are we processing?
		
			mov r12,r12,lsr #4			;Right Pixel, so do shift
			mov r0,r0,lsl #4			;0xRL (nibbles are reversed)
			
mpbitmap_setpixelLeftPixel:
		ldrb r10,[r11]				;Get current screen byte (2 pixels)
		and r10,r10,r12				;keep other pixel
		orr r10,r10,r0				;Set this pixel 
		strb r10,[r11]				;Store back to screen
		
mpbitmap_setpixel_Abort:	
	LDMFD sp!,{pc}
	
	
	

;r6 r2 LD= Xpos    r5 = Ypos
mpbitmap_getpixel:	;Get a pixel from the screen
	STMFD sp!,{lr}
			
		bl mpbitmap_GetScreenPos	;R11=Vram source
		bcs mpbitmap_getpixel_Abort	;Can't read if offscreen
		
		mov r0,#0		
		ldrb r0,[r11]		;Get the screen byte (2 pixels)
		
		tst r2,#0b00000001
		beq mpbitmap_getpixelLeftPixel
			mov r0,r0,lsr #4 ;Need most significant nibble
mpbitmap_getpixelLeftPixel:
		and r0,r0,#0x0F		 ;return 0-15
		
mpbitmap_getpixel_Abort:	
	LDMFD sp!,{pc}

	
	

;HL/R6 = Source Pat D/R2=Xpos (tiles)
; E/R5=Ypos (Tiles) R0=Bitplanes
	
mpbitmap_settile:	
	STMFD sp!,{lr,r1,r2,r3,r4}
							
		bl mpbitmap_GetScreenPosTile ;R11=Vram Destination
		bcs mpbitmap_settile_Abort	;Can't draw if offscreen

		mov r8,#8					;Line count
mpbitmap_settileY:				
		STMFD sp!,{r11}
			mov r9,#8				;Pixel count
			
			adrl r1,MpBitmap_TileTints
			
			ldrb r2,[r1],#1			;Load default tints
			ldrb r3,[r1],#1			; (Used when source doesn't have
			ldrb r4,[r1],#1			;  enough bitplanes)
			mov r1,#0
			
			ldrb r1,[r6],#1			;Get Bitplane 0
			cmp r0,#1
			beq mpbitmap_settileX	;More bitplanes?
			
			ldrb r2,[r6],#1			;Get Bitplane 1
			cmp r0,#2
			beq mpbitmap_settileX	;More bitplanes?
			
			ldrb r3,[r6],#1			;Get Bitplane 2
			cmp r0,#3
			beq mpbitmap_settileX	;More bitplanes?
			
			ldrb r4,[r6],#1			;Get Bitplane 3
		
mpbitmap_settileX:		
			mov r12,#0
		;Left pixel Nibble
			and r7,r1,#0x0080		;Get leftmost bit (bitplane 0)
			orr r12,r12,r7,lsr #3+4

			and r7,r2,#0x0080		;Get leftmost bit (bitplane 1)
			orr r12,r12,r7,lsr #2+4
			
			and r7,r3,#0x0080		;Get leftmost bit (bitplane 2)
			orr r12,r12,r7,lsr #1+4
			
			and r7,r3,#0x0080
			orr r12,r12,r7,lsr #4
			
		;Right pixel Nibble
			and r7,r1,#0x0040		;Get leftmost bit (bitplane 0)
			orr r12,r12,r7,lsr #2

			and r7,r2,#0x0040		;Get leftmost bit (bitplane 1)
			orr r12,r12,r7,lsr #1
			
			and r7,r3,#0x0040		;Get leftmost bit (bitplane 2)
			orr r12,r12,r7
			
			and r7,r3,#0x0040
			orr r12,r12,r7,lsl #1	;Get leftmost bit (bitplane 3)
			
			
			mov r1,r1,lsl #2		;We used 2 pixels
			mov r2,r2,lsl #2		; from each bitplane
			mov r3,r3,lsl #2
			mov r4,r4,lsl #2
				
			strb r12,[r11],#1		;store the byte to the screen 
									; (2 pixels)
			subs r9,r9,#2			
			bne mpbitmap_settileX	;Repeat for other pixels
		
		LDMFD sp!,{R11}
		
		add r11,r11,#160			;Down a line
		
		subs r8,r8,#1
		bne mpbitmap_settileY

;You don't need these lines if you're not using ChibiVM
		bl VM_SaveA6R10
		adrl r11,ReturnKey2
		ldr r9,[r11]		;#$66660000
		
mpbitmap_settile_Abort:
	LDMFD sp!,{pc,r1,r2,r3,r4}


	
;HL/R6 = Dest Pat D/R2=Xpos (tiles)
; E/R5=Ypos (Tiles) R0=Bitplanes
mpbitmap_gettile:	
	STMFD sp!,{lr,r1,r2,r3,r4}
		bl mpbitmap_GetScreenPosTile ;R11=Vram Destination
		bcs mpbitmap_gettile_Abort
			
		mov r8,#8
mpbitmap_gettileY:				
		STMFD sp!,{r11}
			mov r9,#4
			
mpbitmap_gettileX:		
			ldrb r12,[r11],#1
				
			mov r1,r1,lsl #2	;Shift all bitplanes 2 bits 
			mov r2,r2,lsl #2	;(2 pixels - 1 byte)
			mov r3,r3,lsl #2
			mov r4,r4,lsl #2
			
			
;Right pixel Nibble
			and r7,r12,#0x0010		;Bitplane 0
			orr r1,r1,r7,lsr #4

			and r7,r12,#0x0020		;Bitplane 1
			orr r2,r2,r7,lsr #5
			
			and r7,r12,#0x0040		;Bitplane 2
			orr r3,r3,r7,lsr #6
			
			and r7,r12,#0x0080		;Bitplane 3
			orr r4,r4,r7,lsr #7
			
;Left pixel Nibble
			and r7,r12,#0x0001		;Bitplane 0
			orr r1,r1,r7,lsl #1

			and r7,r12,#0x0002		;Bitplane 1
			orr r2,r2,r7
			
			and r7,r12,#0x0004		;Bitplane 2
			orr r3,r3,r7,lsr #1
			
			and r7,r12,#0x0008		;Bitplane 3
			orr r4,r4,r7,lsr #2
			
			subs r9,r9,#1
			bne mpbitmap_gettileX
		
		LDMFD sp!,{R11}
		
		strb r1,[r6],#1				;Store bitplane 0
		cmp r0,#1
		beq mpbitmap_SetTileLineDone ;More bitplanes?
		
		strb r2,[r6],#1				;Store bitplane 1
		cmp r0,#2
		beq mpbitmap_SetTileLineDone ;More bitplanes?
		
		strb r3,[r6],#1				;Store bitplane 2
		cmp r0,#3
		beq mpbitmap_SetTileLineDone ;More bitplanes?
		
		strb r4,[r6],#1				;Store bitplane 3
		
mpbitmap_SetTileLineDone:			
		add r11,r11,#160			;Down a line
		
		subs r8,r8,#1
		bne mpbitmap_gettileY
		
;You don't need these lines if you're not using ChibiVM
		bl VM_SaveA6R10
		adrl r11,ReturnKey2
		ldr r9,[r11]		;#$66660000
		
mpbitmap_gettile_Abort:
	LDMFD sp!,{pc,r1,r2,r3,r4}


	
;Used by ChibiVM Syscall routine
	
MBCall:	 ;Return address is on stack!
		adrl r8,vecMB
		;move.l #vecAdventureCall,a6
	b ChibiVM_VectorCall	
	
	
;regNO equ %11000000		;Don't Read or Write Regs
;regRR equ %10000000		;Only Read Regs
;regWW equ %01000000		;Only Write Regs

.equ mbSetpixel,0
.equ mbGetpixel,1
.equ mbSettile,2
.equ mbGettile,3

vecMB:
	.long mpbitmap_setpixel ;0
	.long mpbitmap_getpixel ;1
	.long mpbitmap_settile	;2
	.long mpbitmap_gettile	;3

