
ROS_nativespriteaddr:	.long 0	;Base of pattern data

adrAdrScreenBaseNS: .long AdrScreenBase

nativespriteactivebuffer:		;NativeSpriteArray for sprite onscreen
	.space 128

NativeSpriteCall:	 ;Return address is on stack!
		adrl r8,vecNS
	b ChibiVM_VectorCall	

.equ nsInit,0	
.equ nsDraw,1
.equ nsDrawExtra,2
.equ nsDrawArray,3
.equ nsHide,4
.equ nsClearUnused,5
.equ nsHideAll,6

vecNS:
	.long NativeSpr_InitReiKou ;dw NativeSpr_InitReiKou	;0
	.long DummySyscall ;dw NativeSpr_Draw	;1
	.long DummySyscall ;dw NativeSpr_DrawExtra ;2
	.long NativeSpr_DrawArrayReiKou ;dw NativeSpr_DrawArrayReiKou ;3
	.long DummySyscall ;dw NativeSpr_Hide ;4
	.long DummySyscall ;dw NativeSpr_ClearUnused ;5
	.long nativespr_hideall_reikou


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
	
	
NativeSpr_InitReiKou:
	STMFD sp!,{lr}
		bl AddressRemapViaTableR6
		b NativeSpr_Initb
		
NativeSpr_Init:			;r6=Sprite source
	STMFD sp!,{lr}
NativeSpr_Initb:	
		adrl r10,ROS_nativespriteaddr
		str r6,[r10]	;Store the sprite pattern source address
	LDMFD sp!,{pc}
	

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
	
NativeSpr_DrawArrayReikou:
	STMFD sp!,{lr}
		bl AddressRemapViaTableR6	
		adrl r5,nativespriteactivebuffer
		
		ldrb r7,[r6],#1  	;Sprite Count
		strb r7,[r5],#1  	;Sprite Count
	
NativeSpr_DrawArrayB_RK:
		cmp r7,#0
		beq NativeSpr_ClearUnused_RK
		
		bl nativespr_testoneRK
		bcc nativespr_nochangeRK
			
		STMFD sp!,{r7,r6,r5}
			STMFD sp!,{r6}
				mov r6,r5
				bl nativespr_drawoneRK  ;Remove old sprite (R5)
			LDMFD sp!,{r6}
			bl nativespr_drawoneRK		;Draw new sprite (R6)
		LDMFD sp!,{r7,r6,r5}
		
nativespr_nochangeRK:		
		mov r1,#4
nativespr_TransferRK:
		ldrb r0,[r6],#1		;Copy 4 bytes
		strb r0,[r5],#1
		
		subs r1,r1,#1
		bne nativespr_TransferRK
		
		subs r7,r7,#1
		b NativeSpr_DrawArrayB_RK

NativeSpr_ClearUnused_RK:
	LDMFD sp!,{pc}
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

nativespr_hideall_reikou:
	STMFD sp!,{lr}
		adrl r6,nativespriteactivebuffer
		ldrb r7,[r6]	  	;Used Sprite Count
		mov r0,#0
		strb r0,[r6],#1		;Zero Sprite count
		
nativespr_drawarrayb_hideRK:
		cmp r7,#0
		beq NativeSpr_ClearUnused_RK	;All sprites done?
		
		STMFD sp!,{r7,r6,r5}
			bl nativespr_drawoneRK		;Renove this sprite
		LDMFD sp!,{r7,r6,r5}
		
		mov r1,#4			;4 bytes per entry
		mov r0,#0
nativespr_drawarrayb_hideClearAgainRK:		
		strb r0,[r6],#1		;Clear this entry
		subs r1,r1,#1
		bne nativespr_drawarrayb_hideClearAgainRK	
	
		sub r7,r7,#1
		b nativespr_drawarrayb_hideRK
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	

nativespr_hideall:			;Remove all sprites from the screen
	STMFD sp!,{lr}
		adrl r6,nativespriteactivebuffer
		ldr r7,[r6]	  		;Used Sprite Count
		mov r0,#0
		str r0,[r6],#4		;Zero Sprite count
		
nativespr_drawarrayb_hide:
		cmp r7,#0
		beq nativespr_hideDone
		
		STMFD sp!,{r7,r6,r5}
			bl nativespr_drawone	;Remove this sprite
		LDMFD sp!,{r7,r6,r5}
	
		mov r1,#3			;12 bytes per entry
		mov r0,#0
nativespr_drawarrayb_hideClearAgain:		
		str r0,[r6],#4		;Clear this entry
		subs r1,r1,#1
		bne nativespr_drawarrayb_hideClearAgain	
	
		sub r7,r7,#1
		b nativespr_drawarrayb_hide

nativespr_hideDone:
	LDMFD sp!,{pc}
		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

nativespr_testoneRK:
	ldr r0,[r5]
	ldr r1,[r6]
	cmp r0,r1
	bne	nativespr_TestOne_fail
	
	mov r10,#1			;Clear Carry
	adds r10,r10,#1		;Clear Carry
	mov pc,lr
		

nativespr_testone:
	mov r2,#3			;Word count
nativespr_testoneB:	
	ldr r0,[r5]			;Test this word
	ldr r1,[r6]
	cmp r0,r1
	bne	nativespr_TestOne_fail
	subs r2,r2,#1
	bne nativespr_testoneB
	
	mov r10,#1			;Clear Carry
	adds r10,r10,#1		;Clear Carry
	mov pc,lr
	
	
nativespr_TestOne_fail:
	mov r10,#3			;Set Carry (needs Draw)
	subs r10,r10,#1		;Set Carry (needs Draw)
	mov pc,lr
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

NativeSpr_DrawArray:
	STMFD sp!,{lr}
	
		adrl r5,nativespriteactivebuffer
		
		ldr r7,[r6],#4  	;Array Sprite Count
		str r7,[r5],#4  	;Store Sprite Count in buffer
	
NativeSpr_DrawArrayB:
		cmp r7,#0
		beq NativeSpr_ClearUnused
		
		bl nativespr_testone	;Has this sprite changed?
		bcc nativespr_nochange
			
		STMFD sp!,{r7,r6,r5}
			STMFD sp!,{r6}
				mov r6,r5
				bl nativespr_drawone  ;Remove old sprite (R5)
			LDMFD sp!,{r6}
			bl nativespr_drawone	  ;Draw new sprite (R6)
		LDMFD sp!,{r7,r6,r5}
		
nativespr_nochange:		
		mov r1,#3
nativespr_Transfer:
		ldr r0,[r6],#4		;Copy 4 bytes
		str r0,[r5],#4
		
		subs r1,r1,#1
		bne nativespr_Transfer
		
		subs r7,r7,#1
		b NativeSpr_DrawArrayB

NativeSpr_ClearUnused:
	LDMFD sp!,{pc}
		
		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
nativespr_drawoneRK:		
	STMFD sp!,{lr}
		ldrb r4,[r6],#1		;Ypos 
		ldrb r1,[r6],#1		;Xpos 
		
		ldrb r0,[r6],#1		;NativeSpriteDef L
		ldrb r5,[r6],#1		;NativeSpriteDef H
		
		add r5,r0,r5,lsl #8
			
		orrs r0,r4,r1		;XY = 0?
		beq nativespr_drawone_SpriteEmptyRK	
			
		mov r6,r5
		bl AddressRemapViaTableR6	
		mov r5,r6
		bl nativespr_drawextra
		
nativespr_drawone_SpriteEmptyRK:
	LDMFD sp!,{pc}
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
nativespr_drawone:		
	STMFD sp!,{lr}
		ldr r1,[r6],#4		;Xpos 
		ldr r4,[r6],#4		;Ypos 
		
	
		ldr r5,[r6],#4		;NativeSpriteDef 
		
		orrs r0,r4,r1		;XY = 0?
		beq nativespr_drawone_SpriteEmpty
			
		bl nativespr_drawextra
			
nativespr_drawone_SpriteEmpty:
	LDMFD sp!,{pc}
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;r1,r4=XY in pairs of pixels	 r5=SpriteDef r0=HspriteNum

Nativespr_drawextra:
NativeSpr_Draw:	
	STMFD sp!,{lr}	
		ldr r7,[r5],#4		;Wid
		ldr r8,[r5],#4		;Hei
		
		orrs r0,r8,r7  		;Wid/Hei zero?
		beq nativespr_RTS
				
drawnativespry:
		STMFD sp!,{r4,r1}
			mov r12,r7		;    ld ixl,d

drawnativesprx:
			ldr r0,[r5]
			cmp r0,#0xFFFFFFFF
			beq drawnativeskipx
			
			sub r0,r1,#vscreenminx	;Logical screen is 128x96
			cmp r0,#vscreenwid		;starting at X,Y 64,80
			bcs drawnativeskipx
			mov r1,r0		;Start Xpos in pairs of pixels
drawnativeokx:

			sub r0,r4,#vscreenminy
			cmp r0,#vscreenhei-2
			bcs drawnativeskipx
drawnativeoky:				;Start Ypos in Pairs of lines

			adrl r10,adrAdrScreenBaseNS
			ldr r10,[r10]
			ldr r10,[r10]			;Get Screen Base
			
			.ifdef ROS_256Color
				add r10,r10,r1,lsl #1;Xpos 
				mov r11,#320*2		;Ypos (320 bytes per line) 
			.else
				add r10,r10,r1		;Xpos
				mov r11,#160*2		;Ypos (160 bytes per line)
			.endif
			
			mul r9,r11,r0
			add r10,r10,r9			;R10=Vram Dest
			
drawnativesprxfast:
			ldr r0,[r5]				;Pattern Number
			cmp r0,#0xFFFFFFFF		;Unused pattern?
			beq drawnativeskipf
		
			adrl r11,ROS_nativespriteaddr
			ldr r11,[r11]			;Pattern Base
			.ifdef ROS_256Color
				add r11,r11,r0,lsl #6 ;64 bytes per pattern (256 col)
			.else
				add r11,r11,r0,lsl #5 ;32 bytes per pattern (16 col)
			.endif
			
			

			mov r2,r10	;Backup VRAM addr
			
			STMFD sp!,{r1}
				mov r1,#8		;lines
drawnative_Yloop:		
				.ifdef ROS_256Color
					mov r3,#8	;Bytes per line (256 color)
				.else
					mov r3,#4	;Bytes per line
				.endif
				
drawnative_Xloop:		
				ldrb r0,[r11],#1 ;We work in bytes so we can
				ldrb r9,[r10]	; cope with unaligned Destinatuions
				eor r0,r0,r9		
				strb r0,[r10],#1
				
				subs r3,r3,#1
				bne drawnative_Xloop
				
				.ifdef ROS_256Color
					add r10,r10,#320-8	;Vram Down one line, across 8 px
				.else
					add r10,r10,#160-4	;Vram Down one line, across 8 px
				.endif 
				subs r1,r1,#1
				bne drawnative_Yloop
			LDMFD sp!,{r1}	
			
			add r10,r2,#4		;Across screen (Vram)
			add r1,r1,#4		;Across screen (Co-ordinate in LU)
			
drawnativeskipf:
			cmp r1,#128		;At far right?
			bcs DrawNative_overRow
			
			add r5,r5,#4		;Move to the next sprite pattern
				
			subs r12,r12,#1
			bne drawnativesprxfast
			
drawnative_overrowb:
		LDMFD sp!,{r1,r4}	
		add r4,r4,#4			;Down one block (Co ordinate in LU)
		subs r8,r8,#1
		bne drawnativespry
						
nativespr_RTS:		
	LDMFD sp!,{pc}

drawnative_overrow:
drawnativeskipfb:
    add r5,r5,#4			;Skip a tile
	subs r12,r12,#1
	bne drawnativeskipfb
	b drawnative_overrowb
	
drawnativeskipx:
	add r1,r1,#4			;Across one block
	add r5,r5,#4			;Skip a tile
	subs r12,r12,#1
	bne drawnativesprx
	b drawnative_overrowb
	
	
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	