.equ ChibiSoundRam,ramarea+32
	.ifdef BuildGBA
		.include "GBA_Header.asm"
	.endif
	.ifdef BuildNDS
		.include "NDS_Header.asm"
	.endif
	.ifdef BuildROS
		.include "ROS_Header.asm"
	.endif
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	

	bl ChibiSoundPro_Init
; *Voices
       ; Voice Name
; 12         1 WaveSynth-Beep
  ; 34       2 StringLib-Soft
           ; 3 StringLib-Pluck
           ; 4 StringLib-Steel
           ; 5 StringLib-Hard
    ; 56     6 Percussion-Soft
           ; 7 Percussion-Medium
      ; 78   8 Percussion-Snare
           ; 9 Percussion-Noise
; ^^^^^^^^ Channel Allocation Map
	
	
	mov r3,#255
	mov r6,#2
	
	mov r5,#0x0000
		
InfLoop:
	
	and r3,r3,#255
	and r6,r6,#255
	
	adrl r0,Mask0xFFFF
	ldr r0,[r0]
	and r5,r5,r0
	
	STMFD sp!,{r3,r5,r6}
		bl ChibiSoundPro_set
	LDMFD sp!,{r3,r5,r6}
	STMFD sp!,{r3,r5,r6}
		mov r1,r5
	
		mov r2,#0	;Xpos
		mov r5,#0	;Ypos
		bl monitor				;Show Regs
		bl readjoystick 
	LDMFD sp!,{r3,r5,r6}
	
	
	
	

;d3=volume (0-255) 
;d6=channel num (0-127 unused channels will wrap around) / top bit=noise
;d5=pitch (0-65535) Higher=Higher Pitch
	
	
	add r10,r10,#1
	
	tst r0,#0b00000001
	bne Joy_NotUp
	sub r5,r5,#1
Joy_NotUp:	
	tst r0,#0b00000010
	bne Joy_NotDown
	add r5,r5,#1
Joy_NotDown:	


	tst r0,#0b00000100
	bne Joy_NotLeft			;
	sub r5,r5,#64*4
Joy_NotLeft:	
	tst r0,#0b00001000
	bne Joy_NotRight
	add r5,r5,#64*4
Joy_NotRight:	
	

	tst r0,#0b00010000
	bne Joy_NotFire
	eor r6,r6,#0x80			;Noise
Joy_NotFire:		


	tst r0,#0b00100000
	bne Joy_NotFire2
	add r3,r3,#0x10			;Volume
Joy_NotFire2:		
		
	
	mov r0,#0xF000
	
Delay:
	nop
	nop
	nop
	nop
	nop
	nop
		nop
	nop
	nop
	nop
	nop
	nop
	subs r0,r0,#1
	bne Delay
	

    b InfLoop					;Halt

Mask0xFFFF:	.long 0xFFFF

; SlowDown:			;This exists for systems that run too fast (Like SMS)
	; ret
	
; DoLddr:
	; lddr			;For gameboy compatibility
	; ret	

	
Mask16bit: .long 0xFFFF0000
	
	
ramareaAddress:
	.long ramarea

	.include "\SrcALL\V1_ChibiSoundPro.asm"
	

	.ifndef ChibiSound
ChibiSound:
	mov pc,lr
	.endif 	
	
	.include "V1_Monitor.asm"
	
	.include "core.asm"
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
	
	.ifdef BuildGBA
		.include "GBA_Footer.asm"
	.endif
	.ifdef BuildNDS
		.include "NDS_Footer.asm"
	.endif
	.ifdef BuildROS
		.include "ROS_Footer.asm"
	.endif