

;R0	 A        D0
;R1	 B        D1
;R2  D        D2
;R3  H        D3
;R4	 C  BC A1 D4
;R5	 E  DE A2 D5
;R6  L  HL A3 D6
;R7     IX A5
;R8     IY A6
;R9		      D7
;R10	   A0 
;R11
;R12


vm_syscalls: .long DummySyscall	;0 - ChipExt
			 .long DummySyscall	;1 - VMControl
			 .long DummySyscall	;2 - VMMonitor
			 .long AdventureCall	;3
			 .long DummySyscall ;4 - ChibiSoundCall
			 
			 .ifdef DoMaxTileCall
			 	.long DoMaxTileCall ;5 - MaxTileCall  
			 .else
				.long DummySyscall ;5 - MaxTileCall  
			 .endif 
			
			 .long DummySyscall ;6 - QTVCall
			 .ifdef NativeSpriteCall
				.long NativeSpriteCall ;7 - NSCall
			 .else 
				.long DummySyscall ;7 - NSCall
			.endif
			 .long DummySyscall ;8 - LoadMultiReg
			 .ifdef MBCall
				.long MBCall ;7 - NSCall
			 .else 
				.long DummySyscall ;7 - NSCall
			.endif
	;dw ChipEXT			;0
	;dw VMControl		;1
	;dw VMMonitor		;2
	;dw AdventureCall	;3
	;dw ChibiSoundCall	;4
	;dw MaxTileCall		;5
	;dw QTVCall			;6
	;dw NSCall			;7
	;dw LoadMultiReg		;8
	
.equ syscallAdventure,3		
.equ syscallNativeSprite,7
.equ syscallMB,9			;Multiplatform Bitmap
	
DummySyscall:
	mov pc,lr
	
	.macro AdvCall p1		
		dbb SYSi,syscallAdventure
		.byte \p1
	.endm

	.macro NsCall p1		
		dbb SYSi,syscallNativeSprite
		db \p1
	.endm
		
		
	
	.macro MaxTileCall p1		
		dbb SYSi,syscallNativeSprite
		db \p1
	.endm
			
	.Macro MBcall p1
		dbb SYSi,syscallMB
		db \p1
	.endm
	
.equ regRR,0
.equ regNO,0

.equ aPrintChar,0
.equ aPrintSeq,1
.equ aPrintNumber,2
.equ aPrintSeqNC,3
.equ aPrintSeqNL,4
.equ aShowDecimal,5
.equ aNewLine,6
.equ acls,7
.equ aFillArea,8
.equ aWaitForFire,9
.equ aJoyAxis,10
.equ aPause50,11
.equ aPauseA,12
.equ aDivideAbyH,13
.equ aRangedRandom,14
.equ aRangeLimit,15
.equ aRangeTest,16
.equ aDoRandom,17
.equ aChibiSoundBeep,18
.equ aChibiSound,19
.equ aDoLdir,20
.equ aDoLddr,21
.equ aSlowDown,22
.equ aReadJoystick,23
.equ aWaitForRelease,24
.equ aLastCommand,25
	
	
vecAdventureCall:	
	.long PrintChar
	.long PrintSeqADV
	.long PrintNumber
	.long PrintSeqNC
	.long PrintSeqNL
	.long ShowDecimal
	.long NewLine
	.long cls
	.long FillArea
	.long WaitForFire
	.long JoyAxis
	.long Pause50
	.long PauseA
	.long DivideAbyH
	.long RangedRandom
	.long RangeLimit
	.long RangeTest
	.long DoRandom
	.long ChibiSoundBeep
	.long ChibiSound
	.long DoLdir
	.long DoLddr
	.long SlowDown
	.long ReadJoystick
	.long WaitForRelease

	

AdventureCall:	 ;Return address is on stack!

		adrl r8,vecAdventureCall
		;move.l #vecAdventureCall,a6
ChibiVM_VectorCall:	 	
	;STMFD sp!,{lr}
		
	
		adrl r10,vm_rambaseAddr
		ldr r7,[r10]			;Get Base of VM Ram
		ldr r10,[r10]			;Get Base of VM Ram
		loadLEA0 vm_rpc,r7		;Load Little endian A3 from A0
								;(Program Counter)
		
		
		
		
		
		;move.l (VM_RamBaseAddr),a3
		;move.l (VM_RamBaseAddr),a0
		;clr.l d7
		;move.b (VM_rPC+1,a3),d7
		;asl.l #8,d7
		;move.b (VM_rPC,a3),d7
		;add.l d7,a0
		
		ldrb r0,[r7],#1
		
		
		;clr.l d0
		;move.b (a0),d0
		;addq.l #1,d7
		
		storeLEa0 r7,vm_rpc
		
		;move.b d7,(VM_rPC,a3)
		;asr.l #8,d7
		;move.b d7,(VM_rPC+1,a3)
		
		;mov r0,r0,lsl #2
		;asl.l #2,d0
			
		ldr r8,[r8,r0,lsl #2]
		
		
		
		
		;move.l (a6,d0),a6
		
		; clr.l d0
		; clr.l d1
		; clr.l d2
		; clr.l d3
		; clr.l d4
		; clr.l d5
		; clr.l d6
		
		ldrb r0,[r10,#VM_rR0]
		
		;move.b (VM_rR0,a3),d0
		
		ldrb r1,[r10,#VM_rR3]
		ldrb r4,[r10,#VM_rR2]
		orr r4,r4,r1,lsl #8
		;move.b (VM_rR3,a3),d1
		;move.b d1,d4
		;asl.l #8,d4
		;move.b (VM_rR2,a3),d4
		
		
		ldrb r2,[r10,#VM_rR5]
		ldrb r5,[r10,#VM_rR4]
		orr r5,r5,r2,lsl #8
		
		;move.b (VM_rR5,a3),d2
		;move.b d2,d5
		;asl.l #8,d5
		;move.b (VM_rR4,a3),d5
		
		ldrb r3,[r10,#VM_rR7]
		ldrb r6,[r10,#VM_rR6]
		orr r6,r6,r3,lsl #8
		
		;move.b (VM_rR7,a3),d3
		;move.b d3,d6
		;asl.l #8,d6
		;move.b (VM_rR6,a3),d6
		
		;move.l #VM_RamBase,d7
		;add.l d7,d4
		;add.l d7,d5
		;add.l d7,d6
		adrl r11,Mask16bitInv
		ldr r11,[r11]
		and r10,r10,r11
		
		; move.l (VM_RamBaseAddr),d7
		; move.l d4,a1
		add r4,r4,r10
		; move.l d5,a2
		add r5,r5,r10
		; move.l d6,a3
		add.l r6,r6,r10
		
		;move.b #1,Cursor_Y
		;clr.b Cursor_X
		;jsr monitor
		;clr.l d7
		
		mov r9,#0			;Return Key
		
		adrl lr,ChibiVM_VectorCall_Return
			
		mov pc,r8
		
ChibiVM_VectorCall_Return:	


		
		
		adrl r11,ReturnKey
		ldr r11,[r11]		;#$66660006
		
		cmp r11,r9
		beq AdventureCall_CustomSave	;Allow override for all regs
		
		adrl r10,vm_rambaseAddr
		ldr r10,[r10]			;Get Base of VM Ram
		;move.l (VM_RamBaseAddr),a0
		
		strb r0,[r10,#VM_rR0]
		
		;Note: ChibiAdventure was designed for the Z80, so registers mimic A BC DE HL
		;move.b d0,(VM_rR0,a0)	;Accumulator is always 8 bits... R1 doesn't exist on Z80
		
		adrl r11,ReturnKey2
		ldr r11,[r11]		;#$66660000
		
		cmp r11,r9
		beq AdventureCall_CustomSave	;Allow override for A3/A2/A1 or 16 bit D1/D2/D3
		
		
		
		
		;Store 8 bit regs back to VM
		
		strb r3,[r10,#VM_rR7]
		strb r6,[r10,#VM_rR6]
		strb r2,[r10,#VM_rR5]
		strb r5,[r10,#VM_rR4]
		strb r1,[r10,#VM_rR3]
		strb r4,[r10,#VM_rR2]
		
		
		;move.b d3,(VM_rR7,a0)	;HL
		;move.b d6,(VM_rR6,a0)
		;move.b d2,(VM_rR5,a0)	;DE
		;move.b d5,(VM_rR4,a0)
		;move.b d1,(VM_rR3,a0)	;BC
		;move.b d4,(VM_rR2,a0)
AdventureCall_CustomSave:	
	ldr lr,[sp],#4			;Pop return address (command)
	mov pc,lr

ReturnKey:	.long 0x66660006
ReturnKey2:	.long 0x66660000

PrintSeqADV:
	STMFD sp!,{lr}

		;move.b #1,Cursor_Y
		;clr.b Cursor_X
		;jsr monitor

		mov r3,r6			;16 bit val into r3
		
		;mov r0,r3
		;mov r1,#2				;Lines
		;bl MemDump				;Dump to screen
		
		bl PrintSeq
		
		
		
		
		
		adrl r10,vm_rambaseAddr
		ldr r10,[r10]			;Get Base of VM Ram
		;move.l (VM_RamBaseAddr),a0
		
		bl VM_SaveA3
		
		;move.b d2,(VM_rR5,a0)	;DE
		;move.b d5,(VM_rR4,a0)
;		
		;move.b d1,(VM_rR3,a0)	;BC
		;move.b d4,(VM_rR2,a0)
		
		strb r2,[r10,#VM_rR5]
		strb r5,[r10,#VM_rR4]
		strb r1,[r10,#VM_rR3]
		strb r4,[r10,#VM_rR2]
		
		adrl r11,ReturnKey2
		ldr r9,[r11]		;#$66660000
	LDMFD sp!,{pc}
		;move.l #$66660000,d7			;We needto restore A3
		;rts
		
VM_SaveA3:
		sub r3,r3,r10
		mov r8,r3
		strb r8,[r10,#VM_rR6]	;HL (Address)
		mov r8,r8,lsr #8
		strb r8,[r10,#VM_rR7]
	mov pc,lr
	
VM_SaveA6R10:	
	adrl r10,vm_rambaseAddr
	ldr r10,[r10]			;Get Base of VM Ram
VM_SaveA6:
		sub r6,r6,r10
		mov r8,r6
		strb r8,[r10,#VM_rR6]	;HL (Address)
		mov r8,r8,lsr #8
		strb r8,[r10,#VM_rR7]
	mov pc,lr
	
	
adrvm_AddressRemapTable:
	.long vm_AddressRemapTable

AddressRemapViaTableR6:
	adrl r10,Mask16bit
	ldr r10,[r10]
	
	and r0,r10,r6
AddressRemapViaTableR6b:
	
	cmp	r0,#0x200		;first 511 bytes of VM ram for 32 bit remaps
	bge AddressRemapViaTableHL_Done
	
	
	.ifdef vm_remap_TableAddr
		adrl r9,vm_rambaseAddr
		ldr r9,[r9]			;Get Base of VM Ram
		
		adrl r11,vm_remap_TableAddr
		ldr r11,[r11]			;Get Base of VM Ram
		
		add r9,r9,r11
	.else 
		adrl r9,adrvm_AddressRemapTable
		ldr r9,[r9]
	.endif 
	
	;move.l (VM_RamBaseAddr),d7
	;add.l (vm_remap_TableAddr),d7
	;move.l d7,a3	

	
	
	;mov r0,r0,lsl #2 ;*4 bytes per entry
	ldr r6,[r9,r0,lsl #2]
	mov pc,lr
	
AddressRemapViaTableHL_Done:
	cmp r10,r6	;>16 bit?
	bgt AddressRemapViaTableHL_Done2
	adrl r9,vm_rambaseAddr
	ldr r9,[r9]			;Get Base of VM Ram
	
	add r9,r9,r6		;should this be add r6,r9,r6?
		
		
AddressRemapViaTableHL_Done2:	
	mov pc,lr