.equ VM_ProgLoadAddr,0x400	

.equ VscreenMinX,64		;Top left of visible screen in logical co-ordinates
.equ VscreenMinY,80

.equ VscreenWid,128		;Visible Screen Size in logical units
.equ VscreenHei,96

.equ tempbuffer,ramarea+128

.equ GBA_SpritePatternCount,128

	.ifdef BuildROS
.equ VM_RamBase,0x10000
	.else
.equ VM_RamBase,ramarea+65536
	.endif

	.include "\srcALL\ChibiVm_InstSet.asm"

	.ifdef BuildGBA
		.include "GBA_Header.asm"
	.endif
	.ifdef BuildNDS
		.include "NDS_Header.asm"
	.endif
	.ifdef BuildROS
		.include "ROS_Header.asm"
	.endif
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
.equ HspriteCount,ramarea+32

	;adrl r6,SpritePatterns
	;bl NativeSpr_Init

	;adrl r6,SpriteArray
	
	;bl NativeSpr_DrawArray
	
	;bl NativeSpr_HideAll
	
	
	;mov r0,#0x00	;Sprite Num
	;mov r1,#64		;Xpos
	;mov r4,#80		;Ypos
	;adrl r5,SpriteData_Bat1
	;bl NativeSpr_Draw
	
	; mov r2,#2	;Xpos
	; mov r5,#5	;Ypos

	 ;ldr r3,HelloWorldAddress	;Address of Hello World Message
	 ;bl PrintSeq				;Show Message
	 
	; bl NewLine
	
	; bl ReadJoystick
	
	; bl monitor				;Show Regs
	
	; bl NewLine
		
	; adr	r0,HelloWorld		;Address
	; mov r1,#2				;Lines
	; bl MemDump				;Dump to screen
	

	; bl NewLine
	
	; bl ReadJoystick
	
	; bl monitor				;Show Regs
	
	; bl NewLine
		
	; adr	r0,HelloWorld		;Address
	; mov r1,#2				;Lines
	; bl MemDump				;Dump to screen
	
	; bl NewLine
	; .macro StoreLE src,dest
		; mov r12,\src
		; strb r12,[\dest]
		; mov r12,r12,lsr #8
		; strb r12,[\dest,#1]
	; .endm 
	
	; .macro LoadLE src,dest
		; adrl r11,Mask16bit
		; ldr r11,[r11]
		
		; and \dest,\dest,r11
		; ldrb r12,[\src,#1]
		; mov r12,r12,lsl #8
		; ldrb r11,[\src]
		; add \dest,\dest,r11
		; add \dest,\dest,r12
	; .endm 
	
	; .macro loadLEA0 off,dest
		; adrl r11,Mask16bit
		; ldr r11,[r11]
		; and \dest,\dest,r11
		
		; ldrb r12,[r10,#\off+1]
		; mov r12,r12,lsl #8
		; ldrb r11,[r10,#\off]
		; add \dest,\dest,r11
		; add \dest,\dest,r12
	; .endm
	
	
	; adrl r10,HelloWorld
	
	; adrl r11,Mask16bit
	; ldr r0,[r11]
	; loadLEA0 3,r0
	
	; ldr	r10,ramareaAddress		;Address
	
	; StoreLE r0,r10
	
	
	bl ChibiVM_Init

	
	;mov r0,#0x0800				;Prog Start
	
	;adrl r10,vm_rambaseAddr		;Address
	;ldr r10,[r10]
	;StoreLEA0 r0,vm_rpc
	
	
	;mov r0,#0x0200				;Stack
	;StoreLEA0 r0,vm_rsp
	
	; mov r0,#0x0000
	; StoreLEA0 r0,vm_rBank0
	; mov r0,#0x4000
	; StoreLEA0 r0,vm_rBank1
	; mov r0,#0x8000
	; StoreLEA0 r0,vm_rBank2
	; mov r0,#0xC000
	; StoreLEA0 r0,vm_rBank3
	
;Copy our program to VM Ram
	; adrl r10,vm_rambaseAddr		;Address
	; ldr r2,[r10]
	; ldr r10,[r10]
	; LoadLEA0 vm_rpc,r2
	
	; adrl r3,VM_Program
	; mov r1,#VM_Program_End-VM_Program
	
; ProgramCopyAgain:	
	; ldrb r0,[r3],#1
	; strb r0,[r2],#1

	; subs r1,r1,#1
	; bne ProgramCopyAgain
	
	
	
;use this to skip part of the test program	
	; mov r1,#140
; ProgSkip:
	; bl VM_Tick
	; subs r1,r1,#1
	; bne ProgSkip
	b InfLoop2
	
InfLoop:	
	mov r2,#0	;Xpos
	mov r5,#0	;Ypos
	; bl monitor				;Show Regs

	adrl r0,vm_rambaseAddr		;Address
	ldr r0,[r0]
	mov r1,#4				;Lines
	bl MemDump				;Dump to screen
	
	
	
	adrl r10,vm_rambaseAddr		;Address
	ldr r0,[r10]
	add r0,r0,#0x0200				;Stack
	sub r0,r0,#8+4
	;ldr r10,[r10]
	;LoadLEA0 vm_rsp,r0
	;sub r0,r0,#12
	mov r1,#2				;Lines
	bl MemDump				;Dump to screen
	
	
	adrl r10,vm_rambaseAddr		;Address
	ldr r0,[r10]
	ldr r10,[r10]
	LoadLEA0 vm_rpc,r0
	mov r1,#3				;Lines
	bl MemDump				;Dump to screen

InfLoop2:	
	bl VM_Tick
	b InfLoop2



    b InfLoop					;Halt
	
vm_rambaseAddr: .long VM_RamBase;ramarea+65536


TestSysCall1:
	mov r0,#0xE4
	adrl r10,vm_rambaseAddr
	ldr r10,[r10]
	strb r0,[r10,#VM_rR1]
	
	
	
	ldr lr,[sp],#4			;Pop return address (command)
	mov pc,lr
	
vm_trap_TableAddr: .long  VM_RamBase + 0x800+(vm_Traps-VM_Program)


	.ifdef BuildGBA
		.include "\srcGBA\V1_MultiplatformBitmap.asm"
	.endif
	.ifdef BuildNDS
		.include "\srcGBA\V1_MultiplatformBitmap.asm"
	.endif
	.ifdef BuildROS
		.include "\srcROS\V1_MultiplatformBitmap.asm"
	.endif
		
	
		
	.include "ChibiVM_AdventureEngine.asm"
	.include "\SrcALL\V1_ChibiSound.asm"

	.align 16
VM_Program_Zero:	
	.space 0x400
VM_Program:	
	.byte "!!!!Chibi/VM!!!!"			;Magic key - must be on a $xxxxxx00 boundary
	.byte "Your product name here          "		;Software Name - 32 bytes

	;rorg $10000+VM_ProgLoadAddr+$30
	.byte 0			;Header Version
	.byte 0b00000011	; config {COpy Vectors to $100}
	.byte 0b00111111	;Requirements {adv} {reikou} {maxtile} {QTV} {NS} {memmapper} {ChibiTracks}
	.byte 0			;Spare
	.byte 0			;Spare
	.byte 0			;Cpu Requirements
	.byte 0			;Ram Requirements
	.byte 0 			;Vector Requorements {Vblank}
	.byte 0 			;SysCall Requirements {VmMonitor}{VmControl}{ChipExt}
	.byte 0 			;SysCall Requirements
	.byte 0			;ChipExt Requirements ???
	.byte 0			;ChipExt Requirements ???
	.byte 0x11		;Bitmap Modes 0-7 {NS / Maxtile} 0=ZXS 1=CPC 2=GBC 3=SMS 4=SAM 5=VGA 6=GBA 7=RGBA
	.byte 0x01		;Bitmap Modes 0-7 {AdvFont / QTV } 0=ZXS 1=CPC 2=GBC 3=SMS 4=SAM 5=VGA 6=GBA 7=RGBA
	.byte 0			;Bitmap modes (spare)
	.byte 0			;Bitmap modes (spare)
	
	;rorg $10000+VM_ProgLoadAddr+$40
	.long 0x400		;Rom Load Address
	.long 0x200		;StackPointer
	.long 0x100		;Trap table Ram address (0=none)
	.long 0x0000		;Memmap 1
	.long 0x4000		;Memmap 2
	.long 0x8000		;Memmap 3
	.long 0xC000		;Memmap 4

	.byte 0,0,0,0
	.byte 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	;rorg $10000+VM_ProgLoadAddr+$70
	.long (vm_traps-VM_Program)	;Vector table (0=none)
	.long 0x2000		;Address remap table (0=none)
	.long 0			;VMAssets (Palette,Font etc)
	.long 0			;???

VM_Program_Hend:
	.space 0x800-(VM_Program_Hend-VM_Program_Zero)	;Program load address


ProgramLaunch:

	;org &800
TestProgram:
	;dbw braj,TileTest
;                                     

;                                         ld b,191
	dbbb movx,r3_imm8,191
;                                     testagain:    
testagain:
;                                         ld a,b
	dbb movx,r0_r3
	db asrb
	db asrb
	db asrb
	dbb andi,0b00001111
;                                         ld d,b
	dbbb movx,zeropg_r3,r5
	
;                                         ld e,b
	dbb movx,r4_r3
;                                         ld l,0                ;ld = xpos e=ypos
	dbbb movx,r6_imm8,0
	
	
	
;                                         push bc
	;db ph2b
;                                             call mpbitmap_setpixel
	;dbw bsrj,mpbitmap_setpixel
	MBcall mbSetpixel					;Diagonal line
;                                         pop bc
	;db pl2b
;                                         

;                                         

;                                         

;                                         ld a,b
	dbb movx,r0_r3
	db asrb
	db asrb
	db asrb
	dbb andi,0b00001111
;                                         ld d,b
	dbbb movx,zeropg_r3,r5
;                                         ld e,b
	dbb movx,r4_r3
    dbb lsrz,r4
    dbb lsrz,r4
    dbb lsrz,r4
	dbbb movx,r6_imm8,0

;	db ph2b
;                                             call mpbitmap_setpixel
	;dbw bsrj,mpbitmap_setpixel
	MBcall mbSetpixel
;                                         pop bc
	;db pl2b
;                                         

;                                         ld d,b
	dbbb movx,zeropg_r3,r5
;                                         ld e,b
	dbb movx,r4_r3
;                                         ld l,0
	dbbb movx,r6_imm8,0
;                                         

;                                         push bc
	;db ph2b
;                                             call mpbitmap_getpixel
	dbb movi,1
	;dbw bsrj,mpbitmap_getpixel
	MBcall mbGetpixel
;                                         pop bc
	;db pl2b
;                                         inc a
	db incb
;                                         ld d,b
	dbbb movx,zeropg_r3,r5
	dbb incz,r5
	dbb incz,r5
	dbb incz,r5
	dbb movx,r4_r3
	dbbb movx,r6_imm8,0
;                                         push bc
	;db ph2b
;                                             call mpbitmap_setpixel
	;dbw bsrj,mpbitmap_setpixel
	MBcall mbSetpixel
;                                         pop bc
	;db pl2b
;                                         

;                                         

;                                         djnz testagain
	dbb decz,r3
	dbw bnej,testagain

	
TileTest:	
	
	dbbw mov16x,r6_imm16,bitmap2bitplane
;                                         ld de,&0010
	dbbw mov16x,r4_imm16,0x0010
;                                             

;                                         ld c,6
	dbbb movx,r2_imm8,6
;                                     tiletestagainy3:    
tiletestagainy3:
;                                         ld b,6
	dbbb movx,r3_imm8,6
;                                     tiletestagainx3:    
tiletestagainx3:
;                                         ld a,2
	dbb movi,2
;                                         push bc
	db ph2b
;                                         push de
	db ph4b
;                                             call mpbitmap_settile
	;dbw bsrj,mpbitmap_settile
	MBcall mbSettile
;                                         pop de
	db pl4b
;                                         inc d
	dbb incz,r5
;                                         pop bc
	db pl2b
;                                         djnz tiletestagainx3
	dbb decz,r3
	dbw bnej,tiletestagainx3
;                                         ld d,0
	dbbbb movx,zeropg_imm8,r5,0
;                                         inc e
	dbb incz,r4
;                                         dec c
	dbb decz,r2
;                                         jr nz,tiletestagainy3
	dbb bnei,tiletestagainy3-lbl_1CD7xD783
lbl_1CD7xD783:
;                                         

;                                         

;                                         ld hl,bitmap4bitplane
	dbbw mov16x,r6_imm16,bitmap4bitplane
;                                         ld de,&0008
	dbbw mov16x,r4_imm16,0x0008
;                                             

;                                         ld c,6
	dbbb movx,r2_imm8,6
;                                     tiletestagainy:    
tiletestagainy:
;                                         ld b,6
	dbbb movx,r3_imm8,6
;                                     tiletestagainx:    
tiletestagainx:
;                                         ld a,4
	dbb movi,4
;                                         push bc
	db ph2b
;                                         push de
	db ph4b
;                                             call mpbitmap_settile
	;dbw bsrj,mpbitmap_settile
	MBcall mbSettile
;                                         pop de
	db pl4b
;                                         inc d
	dbb incz,r5
;                                         pop bc
	db pl2b
;                                         djnz tiletestagainx
	dbb decz,r3
	dbw bnej,tiletestagainx
;                                         ld d,0
	dbbbb movx,zeropg_imm8,r5,0
;                                         inc e
	dbb incz,r4
;                                         dec c
	dbb decz,r2
;                                         jr nz,tiletestagainy
	dbb bnei,tiletestagainy-lbl_9803x75B7
lbl_9803x75B7:
;                                         

;                                         

;                                         ld de,&0008
	dbbw mov16x,r4_imm16,0x0008
;                                         ld c,6
	dbbb movx,r2_imm8,6
;                                     tiletestagainy2:    
tiletestagainy2:
;                                         ld b,6
	dbbb movx,r3_imm8,6
;                                     tiletestagainx2:    
tiletestagainx2:
;                                         

;                                         push bc
	db ph2b
;                                         push de
	db ph4b
;                                             push de
	db ph4b
;                                                 ld hl,tempbuffer
	dbbw mov16x,r6_imm16,tempbuffer
;                                                 ld a,1
	dbb movi,1
	MBcall mbGettile
;                                             pop de
	db pl4b
;                                             ld hl,tempbuffer
	dbbw mov16x,r6_imm16,tempbuffer
;                                             ld a,d
	dbbb movx,r0_zeropg,r5
;                                             add 24
	dbb addi,12
;                                             ld d,a
	dbbb movx,zeropg_r0,r5
;                                             

;                                             

;                                             ld a,1
	dbb movi,1
	MBcall mbSettile
;                                         pop de
	db pl4b
;                                         inc d
	dbb incz,r5
;                                         pop bc
	db pl2b
;                                         djnz tiletestagainx2
	dbb decz,r3
	dbw bnej,tiletestagainx2
;                                         ld d,0
	dbbbb movx,zeropg_imm8,r5,0
;                                         inc e
	dbb incz,r4
;                                         dec c
	dbb decz,r2
;                                         jr nz,tiletestagainy2
	dbb bnei,tiletestagainy2-lbl_7409xD7E8
lbl_7409xD7E8:
;                                         

;                                     



Bitmap2bitplane:
	.incbin "\ResALL\Sprites\RawGB.RAW"
	
Bitmap4bitplane:
	.incbin "\ResALL\Sprites\RawSMS_16Color.RAW"
	
	.align 4
vm_AddressRemapTable:

vm_traps: 	.word ProgramLaunch
			.word 0

VM_Program_End:			
	
ramareaAddress:
	.long ramarea
		

		
	.include "V1_Monitor.asm"
	
	.include "core.asm"
	
	.include "\srcALL\ChibiVm_CPU.asm"
	.include "ChibiVM_Host.asm"
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
	
	.ifdef BuildGBA
		.include "GBA_Footer.asm"
	.endif
	.ifdef BuildNDS
		.include "NDS_Footer.asm"
	.endif
	.ifdef BuildROS
		.include "ROS_Footer.asm"
	.endif