;.equ ROS_256Color,1
.equ ROS_GreyScale16,1

;.equ DebugStream,1
.equ QuadtreeFxColor,1   
;.equ QuadtreeFxColor256,1   
;.equ QuadtreeFxColor16, 1  
;.equ QuadtreeLowQuality,1
;.equ QuadtreeHighQuality,1

;.equ tiletest_basiconly,1
.equ doublebuffered,1			;Needed for GBA if tilemap is in ROM


.equ VM_ProgLoadAddr,0x400	


.equ VscreenMinX,64		;Top left of visible screen in logical co-ordinates
.equ VscreenMinY,80

.equ VscreenWid,128		;Visible Screen Size in logical units
.equ VscreenHei,96

.equ BackgroundTilemapWidthV,36 ;Tilemap width in words


.equ GBA_SpritePatternCount,128


	.ifdef BuildROS
.equ VM_RamBase,0x10000
	.else
.equ VM_RamBase,ramarea+65536
	.endif

	.include "\srcALL\ChibiVm_InstSet.asm"

	.ifdef BuildGBA
		.include "GBA_Header.asm"
	.endif
	.ifdef BuildNDS
		.include "NDS_Header.asm"
	.endif
	.ifdef BuildROS
		.include "ROS_Header.asm"
	.endif
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	

.equ LUT_FullRes,ramarea+256
.equ frameticks,ramarea+255
.equ FxFlags,ramarea+254
.equ QTV_SimpleTblock,ramarea+253
.equ QTV_SimpleCount,ramarea+252

.equ TestSkip,ramarea+200			; for testing (4 bytes)

.equ QuadTree_Palette,ramarea+240
.equ _speed,4
.equ speed,4



.equ HspriteCount,ramarea+32

.equ BackgroundTilemapScrollX,ramarea+64
.equ BackgroundTilemapScrollY,BackgroundTilemapScrollX+4
.equ backgroundtilemapbase,BackgroundTilemapScrollY+4
	;adrl r6,SpritePatterns
	;bl NativeSpr_Init

	;adrl r6,SpriteArray
	
	;bl NativeSpr_DrawArray
	
	;bl NativeSpr_HideAll
	
	mov r3,#4
	adrl r1,adrQuadTree_Palette
	ldr r1,[r1]
	adrl r2,TemplateQuadTree_Palette
CopyPalette:	
	ldrb r0,[r2],#1
	strb r0,[r1],#1
	ldrb r0,[r2],#1
	strb r0,[r1],#1
	subs r3,r3,#1
	bne CopyPalette
	
	;mov r0,#0x00	;Sprite Num
	;mov r1,#64		;Xpos
	;mov r4,#80		;Ypos
	;adrl r5,SpriteData_Bat1
	;bl NativeSpr_Draw
	
	; mov r2,#2	;Xpos
	; mov r5,#5	;Ypos

	 ;ldr r3,HelloWorldAddress	;Address of Hello World Message
	 ;bl PrintSeq				;Show Message
	 
	; bl NewLine
	
	; bl ReadJoystick
	
	; bl monitor				;Show Regs
	
	; bl NewLine

	; bl NewLine
	
	; bl ReadJoystick
	
	; bl monitor				;Show Regs
	
	; bl NewLine
		
	; adr	r0,HelloWorld		;Address
	; mov r1,#2				;Lines
	; bl MemDump				;Dump to screen
	
	; bl NewLine
	; .macro StoreLE src,dest
		; mov r12,\src
		; strb r12,[\dest]
		; mov r12,r12,lsr #8
		; strb r12,[\dest,#1]
	; .endm 
	
	; .macro LoadLE src,dest
		; adrl r11,Mask16bit
		; ldr r11,[r11]
		
		; and \dest,\dest,r11
		; ldrb r12,[\src,#1]
		; mov r12,r12,lsl #8
		; ldrb r11,[\src]
		; add \dest,\dest,r11
		; add \dest,\dest,r12
	; .endm 
	
	; .macro loadLEA0 off,dest
		; adrl r11,Mask16bit
		; ldr r11,[r11]
		; and \dest,\dest,r11
		
		; ldrb r12,[r10,#\off+1]
		; mov r12,r12,lsl #8
		; ldrb r11,[r10,#\off]
		; add \dest,\dest,r11
		; add \dest,\dest,r12
	; .endm
	
	
	; adrl r10,HelloWorld
	
	; adrl r11,Mask16bit
	; ldr r0,[r11]
	; loadLEA0 3,r0
	
	; ldr	r10,ramareaAddress		;Address
	
	; StoreLE r0,r10
	
	
	;mov r0,#0x0800				;Prog Start
	
	;adrl r10,vm_rambaseAddr		;Address
	;ldr r10,[r10]
	;StoreLEA0 r0,vm_rpc
	
	
	;mov r0,#0x0200				;Stack
	;StoreLEA0 r0,vm_rsp
	
	; mov r0,#0x0000
	; StoreLEA0 r0,vm_rBank0
	; mov r0,#0x4000
	; StoreLEA0 r0,vm_rBank1
	; mov r0,#0x8000
	; StoreLEA0 r0,vm_rBank2
	; mov r0,#0xC000
	; StoreLEA0 r0,vm_rBank3
	
;Copy our program to VM Ram

	; adrl r10,vm_rambaseAddr		;Address
	; ldr r2,[r10]
	; ldr r10,[r10]
	; LoadLEA0 vm_rpc,r2
	
	; adrl r3,VM_Program
	; mov r1,#VM_Program_End-VM_Program
	
; ProgramCopyAgain:	
	; ldrb r0,[r3],#1
	; strb r0,[r2],#1

	; subs r1,r1,#1
	; bne ProgramCopyAgain
	
	
	bl QTV_Init
	

	; mov r2,#0
	; mov r5,#0
	; adrl r0,adrLUT_FullRes		;Address
	; ldr r0,[r0]
	; mov r1,#16				;Lines
	; bl MemDump				;Dump to screen


	
	bl QTV_RestartAnim
	
;use this to skip part of the test program	
	; mov r1,#140
; ProgSkip:
	; bl VM_Tick
	; subs r1,r1,#1
	; bne ProgSkip
	
InfLoop:	
	mov r2,#0	;Xpos
	mov r5,#0	;Ypos
	; bl monitor				;Show Regs

	adrl r0,vm_rambaseAddr		;Address
	ldr r0,[r0]
	mov r1,#4				;Lines
	bl MemDump				;Dump to screen
	
	
	
	adrl r10,vm_rambaseAddr		;Address
	ldr r0,[r10]
	add r0,r0,#0x0200				;Stack
	sub r0,r0,#8+4
	;ldr r10,[r10]
	;LoadLEA0 vm_rsp,r0
	;sub r0,r0,#12
	mov r1,#2				;Lines
	bl MemDump				;Dump to screen
	
	
	adrl r10,vm_rambaseAddr		;Address
	ldr r0,[r10]
	ldr r10,[r10]
	LoadLEA0 vm_rpc,r0
	mov r1,#3				;Lines
	bl MemDump				;Dump to screen

InfLoop2:	
	bl VM_Tick
	b InfLoop2



    b InfLoop					;Halt
	
vm_rambaseAddr: .long VM_RamBase;ramarea+65536

TestSysCall1:
	mov r0,#0xE4
	adrl r10,vm_rambaseAddr
	ldr r10,[r10]
	strb r0,[r10,#VM_rR1]
	
	
	
	ldr lr,[sp],#4			;Pop return address (command)
	mov pc,lr
	
vm_trap_TableAddr: .long  VM_RamBase + 0x800+(vm_Traps-VM_Program)


	.ifdef BuildGBA
		.include "\SrcGBA\V1_NativeSprite.asm"	;MUST come before Adventure Engine!
	.endif
	.ifdef BuildNDS
		.include "\SrcGBA\V1_NativeSprite.asm"	;MUST come before Adventure Engine!
	.endif
	.ifdef BuildROS
		.include "\SrcROS\V1_NativeSprite.asm"	;MUST come before Adventure Engine!
	.endif
		
		
	.include "ChibiVM_AdventureEngine.asm"
	.include "\SrcALL\V1_ChibiSound.asm"

; SlowDown:			;This exists for systems that run too fast (Like SMS)
	; ret
	
; DoLddr:
	; lddr			;For gameboy compatibility
	; ret	
	.align 16
VM_Program_Zero:	
	.space 0x400
VM_Program:	
	.byte "!!!!Chibi/VM!!!!"			;Magic key - must be on a $xxxxxx00 boundary
	.byte "Your product name here          "		;Software Name - 32 bytes

	;rorg $10000+VM_ProgLoadAddr+$30
	.byte 0			;Header Version
	.byte 0b00000011	; config {COpy Vectors to $100}
	.byte 0b00111111	;Requirements {adv} {reikou} {maxtile} {QTV} {NS} {memmapper} {ChibiTracks}
	.byte 0			;Spare
	.byte 0			;Spare
	.byte 0			;Cpu Requirements
	.byte 0			;Ram Requirements
	.byte 0 			;Vector Requorements {Vblank}
	.byte 0 			;SysCall Requirements {VmMonitor}{VmControl}{ChipExt}
	.byte 0 			;SysCall Requirements
	.byte 0			;ChipExt Requirements ???
	.byte 0			;ChipExt Requirements ???
	.byte 0x11		;Bitmap Modes 0-7 {NS / Maxtile} 0=ZXS 1=CPC 2=GBC 3=SMS 4=SAM 5=VGA 6=GBA 7=RGBA
	.byte 0x01		;Bitmap Modes 0-7 {AdvFont / QTV } 0=ZXS 1=CPC 2=GBC 3=SMS 4=SAM 5=VGA 6=GBA 7=RGBA
	.byte 0			;Bitmap modes (spare)
	.byte 0			;Bitmap modes (spare)
	
	;rorg $10000+VM_ProgLoadAddr+$40
	.long 0x400		;Rom Load Address
	.long 0x200		;StackPointer
	.long 0x100		;Trap table Ram address (0=none)
	.long 0x0000		;Memmap 1
	.long 0x4000		;Memmap 2
	.long 0x8000		;Memmap 3
	.long 0xC000		;Memmap 4

	.byte 0,0,0,0
	.byte 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	;rorg $10000+VM_ProgLoadAddr+$70
	.long (vm_traps-VM_Program)	;Vector table (0=none)
	.long 0x2000		;Address remap table (0=none)
	.long 0			;VMAssets (Palette,Font etc)
	.long 0			;???

VM_Program_Hend:
	.space 0x800-(VM_Program_Hend-VM_Program_Zero)	;Program load address

	
.equ VramBase,0
.equ ballpos,64+16
.equ ballmove,64+18
.equ PlayerPaddle,64+20
.equ CpuPaddle,64+22
.equ PlayerScore,64+24
.equ CpuScore,64+25
.equ GameTick,64+26
.equ GameSpeed,64+27		
.equ GameAI,64+28
.equ SoundByte,64+29 

ProgramLaunch:

	dbbw mov16x,r6_imm16,0;SpritePatterns		;Sprite patterns
	;dbbw mov16x,r2_imm16,4*SpritePatternSize	;ByteCount
	NSCall nsInit 
	
	
	
	;dbbw mov16x,r6_imm16,SpriteArrayRam	;Ram
	;NSCall nsDrawArray+regRR 			;SpriteArray
	
	dbbw mov16x,r6_imm16,1;5	;Ram
	NSCall nsDrawArray+regRR 			;SpriteArray
		
	; ld hl,SpritePatterns		;Sprite patterns
	; ld bc,4*SpritePatternSize	;ByteCount
	; call NativeSpr_Init
	
	
	
;                                     

;                                     newgame:
newgame:
	NSCall nsHideAll+regNO
	
	;db hltb
	
	;dbbw mov16x,r6_imm16,SpriteArrayRam	;Ram
	;NSCall nsDrawArray+regRR 			;SpriteArray

;                                     	advcall acls
	advcall acls
;                                     	mov16x r6,#0x0000		;speed - ai
	dbbw mov16x,r6_imm16,0x0000
;                                     titlescreen:

titlescreen:
;                                     	advcall apause50
	advcall apause50
;                                     	mov16x r4,#0x0000		;cursorpos
	dbbw mov16x,r4_imm16,0x0000
;                                     	ph6
	db ph6b
;                                     		mov16x r6,#strstart
	dbbw mov16x,r6_imm16,strstart-VramBase
;                                     		advcall aprintseq
	advcall aprintseq
;                                     		mov16x r6,#strspeed
	dbbw mov16x,r6_imm16,strspeed-VramBase
;                                     		advcall aprintseq
	advcall aprintseq
;                                     	pl6
	db pl6b
;                                     	movx r0,r7
	dbbb movx,r0_zeropg,r7
;                                     	advcall ashowdecimal
	advcall ashowdecimal
;                                     	ph6
	db ph6b
;                                     		mov16x r6,#strai
	dbbw mov16x,r6_imm16,strai-VramBase
;                                     		advcall aprintseq
	advcall aprintseq
;                                     	pl6
	db pl6b
;                                     	movx r0,r6
	dbb movx,r0_r6
;                                     	advcall ashowdecimal
	advcall ashowdecimal
;                                     

;                                     	advcall areadjoystick	;0b---frldu
	advcall areadjoystick
;                                     	movx r2,r0
	dbb movx,r2_r0
;                                     

;                                     	mov16x r4,#0x0004		;cursorpos
	dbbw mov16x,r4_imm16,0x0004
;                                     

;                                     	movx r0,r6
	dbb movx,r0_r6
;                                     	advcall ajoyaxis		;ud
	advcall ajoyaxis
;                                     	advcall arangelimit
	advcall arangelimit
;                                     	movx r6,r0
	dbb movx,r6_r0
;                                     

;                                     	movx r0,r7
	dbbb movx,r0_zeropg,r7
;                                     	advcall ajoyaxis		;lr
	advcall ajoyaxis
;                                     	advcall arangelimit
	advcall arangelimit
;                                     	movx r7,r0
	dbbb movx,zeropg_r0,r7
;                                     

;                                     	tstx r2,#1			;fire?
	dbbb tstx,r2_imm8,1
;                                     	bnei titlescreen
	dbb bnei,titlescreen-lbl35419
lbl35419:



	dbbb movx,r0_zeropg,r7
	dbw bsrj,readmask-VramBase
	dbbw stox,r0_addr16,gamespeed

	dbb movx,r0_r6
	dbw bsrj,readmask-VramBase
	dbbw stox,r0_addr16,gameai

	dbw bsrj,rezeroball-VramBase

 	dbbw sto16x,r4_addr16,ballpos

	dbbww mov16x,addr16_imm16,ballmove,0xffff	;ball pos -1 = facing player

	dbbwb movx,addr16_imm8,playerpaddle,6*4		;ypos
	dbbwb movx,addr16_imm8,cpupaddle,6*4

	dbbw clrx,addr16_r0,cpuscore
	dbbw clrx,addr16_r0,playerscore

	dbbwb movx,addr16_imm8,playerpaddle+1,0*4	;Xpos
	dbbwb movx,addr16_imm8,cpupaddle+1,19*4

	advcall acls
	dbbw mov16x,r6_imm16,strwall-VramBase				;Draw Walls
	advcall aprintseq
	
	dbw bsrj,ShowScores-VramBase							;ShowScores

gameloop:

	dbbw mov16x,r4_addr16,ballpos
	db ph4b
		
	dbbbb addx,zeropg_imm8,r4,VscreenMinY
	dbbbb addx,zeropg_imm8,r5,VscreenMinX
	
	dbbw sto16x,r4_addr16,SpriteArrayRam+9
	
	dbw bsrj,getplayerpaddlede-VramBase
	
	dbbbb addx,zeropg_imm8,r4,VscreenMinY
	dbbbb addx,zeropg_imm8,r5,VscreenMinX
	
	dbbw sto16x,r4_addr16,SpriteArrayRam+1
		
	dbw bsrj,getcpupaddlede-VramBase
		
	dbbbb addx,zeropg_imm8,r4,VscreenMinY
	dbbbb addx,zeropg_imm8,r5,VscreenMinX
	
	dbbw sto16x,r4_addr16,SpriteArrayRam+5
		
	dbbw mov16x,r6_imm16,SpriteArrayRam	;Ram
	NSCall nsDrawArray+regRR 			;SpriteArray

	dbbw mov16x,r6_imm16,SpriteArrayRam	;Ram
	NSCall nsDrawArray+regRR 			;SpriteArray
	
	;dbw bsrj,drawpaddle

	

	dbbw movx,r0_addr16,soundbyte
	advcall achibisound+regRR
	dbbw clrx,addr16_r0,soundbyte
	
	dbb movi,1
	advcall apausea
	
	db pl4b

	;db ph4b
	;dbb movi,' '
	;advcall aprintchar
	;db pl4b

	
	
	
	dbbw movx,r0_addr16,gametick
	db incb
	dbbw stox,r0_addr16,gametick

	dbbw andx,r0_addr16,gamespeed

	dbb bnei,noballmove-lbl65191
lbl65191:
	dbbw mov16x,r2_addr16,ballmove
	dbw bsrj,moveball-VramBase
noballmove:

	dbw bsrj,getplayerpaddlede-VramBase

	advcall areadjoystick
	dbb movx,r2_r0
	dbw bsrj,processpaddle-VramBase

 	dbbw sto16x,r6_addr16,playerpaddle
	dbw bsrj,getcpupaddlede-VramBase

	dbbw movx,r0_addr16,gametick
	dbbw andx,r0_addr16,gameai

	dbb bnei,cpudecided-lbl61257
lbl61257:

	dbbb movx,r2_imm8,0b11111111	;nomove
	dbbw movx,r0_addr16,ballpos
	dbb subi,1
	dbb cmpz,r4
	dbb beqi,cpudecided-lbl43064
lbl43064:
	dbb bcsi,cpuup-lbl27499
lbl27499:
	dbbb movx,r2_imm8,0b11111101
	dbb brai,cpudecided-lbl36249
lbl36249:

cpuup:
	dbbb movx,r2_imm8,0b11111110

cpudecided:
	dbw bsrj,processpaddle-VramBase

	dbbw mov16x,addr16_r6,cpupaddle

	dbbw movx,r0_addr16,cpuscore
	dbbw orrx,r0_addr16,playerscore
	dbb cmpi,8
	dbw bcsj,gameloop-VramBase
	
	
	
	dbbw mov16x,r6_imm16,strgameover-VramBase
	dbbw mov16x,r4_imm16,0x0608
	advcall aprintseq
	advcall awaitforfire
	dbw braj,newgame-VramBase

	
getplayerpaddlede:
	dbbw mov16x,r4_addr16,playerpaddle
	db rtsb

getcpupaddlede:
	dbbw mov16x,r4_addr16,cpupaddle
	db rtsb

	
moveball:
	dbbwb movx,addr16_imm8,soundbyte,0b10100000
	dbbw mov16x,r6_addr16,playerpaddle
	
	;dbbb movx,r0_zeropg,r5
	;dbb cmpi,1*4
	dbbbb cmpx,zeropg_imm8,r5,1*4-1
	
	dbb bnei,noplayerpaddlehit-lbl50130
lbl50130:

	dbw bsrj,paddletest-VramBase
	dbb bcci,noplayerpaddlehit-lbl28645
lbl28645:
	dbw bsrj,cpuscores-VramBase		;cs=hit


noplayerpaddlehit:
	dbbw mov16x,r6_addr16,cpupaddle

	dbbbb cmpx,zeropg_imm8,r5,18*4+1
	
	dbb bnei,nocpupaddlehit-lbl7460
lbl7460:
	dbw bsrj,paddletest-VramBase
	dbb bcci,nocpupaddlehit-lbl16183
lbl16183:
	dbw bsrj,playerscores-VramBase

	
nocpupaddlehit:
	dbbb addx,zeropg_r3,r5
	dbb  addx,r4_r2		;update ball ypos
	dbbb cmpx,r4_imm8,1*4			;hit top wall
	dbb bnei,lbl5063-lbl23676
lbl23676:
	dbw bsrj,flipy-VramBase
lbl5063:
	dbbb cmpx,r4_imm8,16*4	;hit bottom wall
	dbb bnei,lbl16101-lbl21583
lbl21583:
	dbw bsrj,flipy-VramBase
lbl16101:
 	dbbw sto16x,r4_addr16,ballpos		;Old cursor pos
 	dbbw sto16x,r2_addr16,ballmove	
	db rtsb

paddletest:	;carry=missed paddle
	dbb movx,r0_r4
	dbb cmpz,r6
	dbb bcsi,paddlemiss-lbl22097
lbl22097:
	dbb subi,3*4
	dbb cmpz,r6
	dbb bcci,paddlemiss-lbl59932
lbl59932:
	dbw bsrj,flipx-VramBase

	dbbwb movx,addr16_imm8,soundbyte,0b01000000
	dbb orrz,r0	;clear carry
	db rtsb

paddlemiss:
	dbbwb movx,addr16_imm8,soundbyte,0b01110000
	dbbb movx,rf_imm8,3
	db rtsb

cpuscores:
	dbbw incx,addr16_r0,cpuscore
	dbw bsrj,rezeroball-VramBase
	dbw bsrj,ShowScores-VramBase							;ShowScores
	db rtsb

playerscores:
	dbbw incx,addr16_r0,playerscore
	dbw bsrj,ShowScores-VramBase							;ShowScores

rezeroball:
	dbbw mov16x,r4_imm16,0x0a08*4

flipx:
	dbb negz,r3
	db rtsb

flipy:
	dbb negz,r2
	db rtsb
	

processpaddle:
	dbb mov16x,r6_r4

	dbbw mov16x,r4_imm16,0x010e*4
	dbb movx,r0_r6
		advcall ajoyaxis
		advcall arangelimit
	dbb movx,r6_r0
	db rtsb

readmask:
	dbbbb movx,zeropg_imm8,r5,0
	dbb movx,r4_r0
	dbbw add16x,r4_imm16,masks-VramBase
	dbb movx,r0_atr4
	db rtsb
	
ShowScores:
	db ph4b
		dbbw mov16x,r4_imm16,0x0011
		dbbw movx,r0_addr16,playerscore
		advcall ashowdecimal+regRR

		dbbw mov16x,r4_imm16,0x1111
		dbbw movx,r0_addr16,cpuscore
		advcall ashowdecimal+regRR
	db pl4b
	db rtsb
;Speed masks for ball and AI	
Masks:	.byte 0b00000111,0b00000011,0b00000001,0b00000000


strGameOver:.byte "Game Over",255
strStart:	.byte "Sprong - Sprite Pong!!",253,255

strSpeed:	.byte 253,"Speed:",255
strAi:		.byte 253,"AI:",255


strWall:	.byte 0xB3,"-"
			.byte 253
			.byte 0xF1	;253=Newline (Xpos=0) 0xF1= Ypos=17
			 .byte 0xB3,"-"
			 .byte 255		;0xB3=18 char H strip

strPaddle: 	 	 .byte 0xC2,"X",255 ;0xC2=3 char V strip
strBlankPaddle:  .byte 0xC2," ",255

vm_traps: 	.word ProgramLaunch
			.word 0
			
SpriteArrayRam:
SpriteArrayTT:
	.byte 3		;Count	
	.word 0x7080
		.byte 2,0;SpriteData_Bat1	;XXYY,Sprite
	.word 0x9080
		.byte 3,0;dc.w SpriteData_Bat2	;XXYY,Sprite
	.word 0x8080
		.byte 4,0;dc.w SpriteData_Ball	;XXYY,Sprite
	.align 4

.ifdef BuildROS
	.ifdef ROS_GreyScale16
InitPalette:
		.word 0x0000 ;0  -GRB
		.word 0x0111 ;0  -GRB
		.word 0x0222 ;0  -GRB
		.word 0x0333 ;0  -GRB
		.word 0x0444 ;0  -GRB
		.word 0x0555 ;0  -GRB
		.word 0x0666 ;0  -GRB
		.word 0x0777 ;0  -GRB
		.word 0x0888 ;0  -GRB
		.word 0x0999 ;0  -GRB
		.word 0x0AAA ;0  -GRB
		.word 0x0BBB ;0  -GRB
		.word 0x0CCC ;0  -GRB
		.word 0x0DDD ;0  -GRB
		.word 0x0EEE ;0  -GRB
		.word 0x0FFF ;0  -GRB
		
	.else
InitPalette:
	    .word 0x0000 ;0  -GRB
		.word 0x0080 ;1  -GRB
		.word 0x0800 ;2  -GRB
		.word 0x0880 ;3  -GRB
		.word 0x0008 ;4  -GRB
		.word 0x0088 ;5  -GRB
		.word 0x0808 ;6  -GRB
		.word 0x0CCC ;7  -GRB
		.word 0x0888 ;8  -GRB
		.word 0x00F0 ;9  -GRB
		.word 0x0F00 ;10  -GRB
		.word 0x0FF0 ;11  -GRB
		.word 0x000F ;12  -GRB
		.word 0x00FF ;13  -GRB
		.word 0x0F0F ;14  -GRB
		.word 0x0FFF ;15  -GRB
	.endif
.endif
	
	.align 4
VM_Program_End:
	.ifdef BuildROS
		.ifdef ROS_256Color
			.include "\SrcROS\V1_Quadtree256.asm"
		.else
			.include "\SrcROS\V1_Quadtree16.asm"
		.endif 
		
	.endif 
	.ifdef BuildNDS
		.include "\SrcNDS\V1_Quadtree.asm"
	.endif 
	.ifdef BuildGBA
		.include "\SrcNDS\V1_Quadtree.asm"	;Also works for GBA!
	.endif 

ROS_16_256ColorPalette:	;For 16 color video on 256 color screens
	.byte 0,5,32,36,128,132,40,252,47,23,99,119,136,159,235,255
	

	
NDS_QuadTree256Palette:	
    .word 0b1000000000000000; ;0  %-BBBBBGGGGGRRRRR
    .word 0b1000000000010000; ;1  %-BBBBBGGGGGRRRRR
    .word 0b1000001000000000; ;2  %-BBBBBGGGGGRRRRR
    .word 0b1000001000010000; ;3  %-BBBBBGGGGGRRRRR
    .word 0b1100000000000000; ;4  %-BBBBBGGGGGRRRRR
    .word 0b1100000000010000; ;5  %-BBBBBGGGGGRRRRR
    .word 0b1100001000000000; ;6  %-BBBBBGGGGGRRRRR
    .word 0b1110001100011000; ;7  %-BBBBBGGGGGRRRRR
    .word 0b1100001000010000; ;8  %-BBBBBGGGGGRRRRR
    .word 0b1000000000011111; ;9  %-BBBBBGGGGGRRRRR
    .word 0b1000001111100000; ;10  %-BBBBBGGGGGRRRRR
    .word 0b1000001111111111; ;11  %-BBBBBGGGGGRRRRR
    .word 0b1111110000000000; ;12  %-BBBBBGGGGGRRRRR
    .word 0b1111110000011111; ;13  %-BBBBBGGGGGRRRRR
    .word 0b1111111111100000; ;14  %-BBBBBGGGGGRRRRR
    .word 0b1111111111111111; ;15  %-BBBBBGGGGGRRRRR
    .word 0b1000000000000000; ;16  %-BBBBBGGGGGRRRRR
    .word 0b1000010000100001; ;17  %-BBBBBGGGGGRRRRR
    .word 0b1000100001000010; ;18  %-BBBBBGGGGGRRRRR
    .word 0b1000110001100011; ;19  %-BBBBBGGGGGRRRRR
    .word 0b1001000010000100; ;20  %-BBBBBGGGGGRRRRR
    .word 0b1001010010100101; ;21  %-BBBBBGGGGGRRRRR
    .word 0b1001100011000110; ;22  %-BBBBBGGGGGRRRRR
    .word 0b1001110011100111; ;23  %-BBBBBGGGGGRRRRR
    .word 0b1010000100001000; ;24  %-BBBBBGGGGGRRRRR
    .word 0b1010010100101001; ;25  %-BBBBBGGGGGRRRRR
    .word 0b1010100101001010; ;26  %-BBBBBGGGGGRRRRR
    .word 0b1010110101101011; ;27  %-BBBBBGGGGGRRRRR
    .word 0b1011000110001100; ;28  %-BBBBBGGGGGRRRRR
    .word 0b1011010110101101; ;29  %-BBBBBGGGGGRRRRR
    .word 0b1011100111001110; ;30  %-BBBBBGGGGGRRRRR
    .word 0b1011110111101111; ;31  %-BBBBBGGGGGRRRRR
    .word 0b1100001000010000; ;32  %-BBBBBGGGGGRRRRR
    .word 0b1100011000110001; ;33  %-BBBBBGGGGGRRRRR
    .word 0b1100101001010010; ;34  %-BBBBBGGGGGRRRRR
    .word 0b1100111001110011; ;35  %-BBBBBGGGGGRRRRR
    .word 0b1101001010010100; ;36  %-BBBBBGGGGGRRRRR
    .word 0b1101011010110101; ;37  %-BBBBBGGGGGRRRRR
    .word 0b1101101011010110; ;38  %-BBBBBGGGGGRRRRR
    .word 0b1101111011110111; ;39  %-BBBBBGGGGGRRRRR
    .word 0b1110001100011000; ;40  %-BBBBBGGGGGRRRRR
    .word 0b1110011100111001; ;41  %-BBBBBGGGGGRRRRR
    .word 0b1110101101011010; ;42  %-BBBBBGGGGGRRRRR
    .word 0b1110111101111011; ;43  %-BBBBBGGGGGRRRRR
    .word 0b1111001110011100; ;44  %-BBBBBGGGGGRRRRR
    .word 0b1111011110111101; ;45  %-BBBBBGGGGGRRRRR
    .word 0b1111101111011110; ;46  %-BBBBBGGGGGRRRRR
    .word 0b1111111111111111; ;47  %-BBBBBGGGGGRRRRR
    .word 0b1000010001100101; ;48  %-BBBBBGGGGGRRRRR
    .word 0b1000100010101000; ;49  %-BBBBBGGGGGRRRRR
    .word 0b1000110011001001; ;50  %-BBBBBGGGGGRRRRR
    .word 0b1001000100001101; ;51  %-BBBBBGGGGGRRRRR
    .word 0b1010000100001011; ;52  %-BBBBBGGGGGRRRRR
    .word 0b1010110101110000; ;53  %-BBBBBGGGGGRRRRR
    .word 0b1010010110010100; ;54  %-BBBBBGGGGGRRRRR
    .word 0b1011111000010100; ;55  %-BBBBBGGGGGRRRRR
    .word 0b1010001000011000; ;56  %-BBBBBGGGGGRRRRR
    .word 0b1011001001011000; ;57  %-BBBBBGGGGGRRRRR
    .word 0b1101001010010110; ;58  %-BBBBBGGGGGRRRRR
    .word 0b1101011011011001; ;59  %-BBBBBGGGGGRRRRR
    .word 0b1011001010011100; ;60  %-BBBBBGGGGGRRRRR
    .word 0b1011101100011100; ;61  %-BBBBBGGGGGRRRRR
    .word 0b1101001100011101; ;62  %-BBBBBGGGGGRRRRR
    .word 0b1101101101011110; ;63  %-BBBBBGGGGGRRRRR
    .word 0b1000000000000000; ;64  %-BBBBBGGGGGRRRRR
    .word 0b1000110000000000; ;65  %-BBBBBGGGGGRRRRR
    .word 0b1001110000000000; ;66  %-BBBBBGGGGGRRRRR
    .word 0b1010100000000000; ;67  %-BBBBBGGGGGRRRRR
    .word 0b1000000001000000; ;68  %-BBBBBGGGGGRRRRR
    .word 0b1000110001000000; ;69  %-BBBBBGGGGGRRRRR
    .word 0b1001110001000000; ;70  %-BBBBBGGGGGRRRRR
    .word 0b1010100001000000; ;71  %-BBBBBGGGGGRRRRR
    .word 0b1000000010000000; ;72  %-BBBBBGGGGGRRRRR
    .word 0b1000110010000000; ;73  %-BBBBBGGGGGRRRRR
    .word 0b1001110010000000; ;74  %-BBBBBGGGGGRRRRR
    .word 0b1010100010000000; ;75  %-BBBBBGGGGGRRRRR
    .word 0b1000000011000000; ;76  %-BBBBBGGGGGRRRRR
    .word 0b1000110011000000; ;77  %-BBBBBGGGGGRRRRR
    .word 0b1001110011000000; ;78  %-BBBBBGGGGGRRRRR
    .word 0b1010100011000000; ;79  %-BBBBBGGGGGRRRRR
    .word 0b1000000000000011; ;80  %-BBBBBGGGGGRRRRR
    .word 0b1000110000000011; ;81  %-BBBBBGGGGGRRRRR
    .word 0b1001110000000011; ;82  %-BBBBBGGGGGRRRRR
    .word 0b1010100000000011; ;83  %-BBBBBGGGGGRRRRR
    .word 0b1000000001000011; ;84  %-BBBBBGGGGGRRRRR
    .word 0b1000110001000011; ;85  %-BBBBBGGGGGRRRRR
    .word 0b1001110001000011; ;86  %-BBBBBGGGGGRRRRR
    .word 0b1010100001000011; ;87  %-BBBBBGGGGGRRRRR
    .word 0b1000000010000011; ;88  %-BBBBBGGGGGRRRRR
    .word 0b1000110010000011; ;89  %-BBBBBGGGGGRRRRR
    .word 0b1001110010000011; ;90  %-BBBBBGGGGGRRRRR
    .word 0b1010100010000011; ;91  %-BBBBBGGGGGRRRRR
    .word 0b1000000011000011; ;92  %-BBBBBGGGGGRRRRR
    .word 0b1000110011000011; ;93  %-BBBBBGGGGGRRRRR
    .word 0b1001110011000011; ;94  %-BBBBBGGGGGRRRRR
    .word 0b1010100011000011; ;95  %-BBBBBGGGGGRRRRR
    .word 0b1000000000000111; ;96  %-BBBBBGGGGGRRRRR
    .word 0b1000110000000111; ;97  %-BBBBBGGGGGRRRRR
    .word 0b1001110000000111; ;98  %-BBBBBGGGGGRRRRR
    .word 0b1010100000000111; ;99  %-BBBBBGGGGGRRRRR
    .word 0b1000000001000111; ;100  %-BBBBBGGGGGRRRRR
    .word 0b1000110001000111; ;101  %-BBBBBGGGGGRRRRR
    .word 0b1001110001000111; ;102  %-BBBBBGGGGGRRRRR
    .word 0b1010100001000111; ;103  %-BBBBBGGGGGRRRRR
    .word 0b1000000010000111; ;104  %-BBBBBGGGGGRRRRR
    .word 0b1000110010000111; ;105  %-BBBBBGGGGGRRRRR
    .word 0b1001110010000111; ;106  %-BBBBBGGGGGRRRRR
    .word 0b1010100010000111; ;107  %-BBBBBGGGGGRRRRR
    .word 0b1000000011000111; ;108  %-BBBBBGGGGGRRRRR
    .word 0b1000110011000111; ;109  %-BBBBBGGGGGRRRRR
    .word 0b1001110011000111; ;110  %-BBBBBGGGGGRRRRR
    .word 0b1010100011000111; ;111  %-BBBBBGGGGGRRRRR
    .word 0b1000000000001010; ;112  %-BBBBBGGGGGRRRRR
    .word 0b1000110000001010; ;113  %-BBBBBGGGGGRRRRR
    .word 0b1001110000001010; ;114  %-BBBBBGGGGGRRRRR
    .word 0b1010100000001010; ;115  %-BBBBBGGGGGRRRRR
    .word 0b1000000001001010; ;116  %-BBBBBGGGGGRRRRR
    .word 0b1000110001001010; ;117  %-BBBBBGGGGGRRRRR
    .word 0b1001110001001010; ;118  %-BBBBBGGGGGRRRRR
    .word 0b1010100001001010; ;119  %-BBBBBGGGGGRRRRR
    .word 0b1000000010001010; ;120  %-BBBBBGGGGGRRRRR
    .word 0b1000110010001010; ;121  %-BBBBBGGGGGRRRRR
    .word 0b1001110010001010; ;122  %-BBBBBGGGGGRRRRR
    .word 0b1010100010001010; ;123  %-BBBBBGGGGGRRRRR
    .word 0b1000000011001010; ;124  %-BBBBBGGGGGRRRRR
    .word 0b1000110011001010; ;125  %-BBBBBGGGGGRRRRR
    .word 0b1001110011001010; ;126  %-BBBBBGGGGGRRRRR
    .word 0b1010100011001010; ;127  %-BBBBBGGGGGRRRRR
    .word 0b1000000000000000; ;128  %-BBBBBGGGGGRRRRR
    .word 0b1001110000000000; ;129  %-BBBBBGGGGGRRRRR
    .word 0b1011100000000000; ;130  %-BBBBBGGGGGRRRRR
    .word 0b1101010000000000; ;131  %-BBBBBGGGGGRRRRR
    .word 0b1000000010100000; ;132  %-BBBBBGGGGGRRRRR
    .word 0b1001110010100000; ;133  %-BBBBBGGGGGRRRRR
    .word 0b1011100010100000; ;134  %-BBBBBGGGGGRRRRR
    .word 0b1101010010100000; ;135  %-BBBBBGGGGGRRRRR
    .word 0b1000000101000000; ;136  %-BBBBBGGGGGRRRRR
    .word 0b1001110101000000; ;137  %-BBBBBGGGGGRRRRR
    .word 0b1011100101000000; ;138  %-BBBBBGGGGGRRRRR
    .word 0b1101010101000000; ;139  %-BBBBBGGGGGRRRRR
    .word 0b1000000111100000; ;140  %-BBBBBGGGGGRRRRR
    .word 0b1001110111100000; ;141  %-BBBBBGGGGGRRRRR
    .word 0b1011100111100000; ;142  %-BBBBBGGGGGRRRRR
    .word 0b1101010111100000; ;143  %-BBBBBGGGGGRRRRR
    .word 0b1000000000000111; ;144  %-BBBBBGGGGGRRRRR
    .word 0b1001110000000111; ;145  %-BBBBBGGGGGRRRRR
    .word 0b1011100000000111; ;146  %-BBBBBGGGGGRRRRR
    .word 0b1101010000000111; ;147  %-BBBBBGGGGGRRRRR
    .word 0b1000000010100111; ;148  %-BBBBBGGGGGRRRRR
    .word 0b1001110010100111; ;149  %-BBBBBGGGGGRRRRR
    .word 0b1011100010100111; ;150  %-BBBBBGGGGGRRRRR
    .word 0b1101010010100111; ;151  %-BBBBBGGGGGRRRRR
    .word 0b1000000101000111; ;152  %-BBBBBGGGGGRRRRR
    .word 0b1001110101000111; ;153  %-BBBBBGGGGGRRRRR
    .word 0b1011100101000111; ;154  %-BBBBBGGGGGRRRRR
    .word 0b1101010101000111; ;155  %-BBBBBGGGGGRRRRR
    .word 0b1000000111100111; ;156  %-BBBBBGGGGGRRRRR
    .word 0b1001110111100111; ;157  %-BBBBBGGGGGRRRRR
    .word 0b1011100111100111; ;158  %-BBBBBGGGGGRRRRR
    .word 0b1101010111100111; ;159  %-BBBBBGGGGGRRRRR
    .word 0b1000000000001110; ;160  %-BBBBBGGGGGRRRRR
    .word 0b1001110000001110; ;161  %-BBBBBGGGGGRRRRR
    .word 0b1011100000001110; ;162  %-BBBBBGGGGGRRRRR
    .word 0b1101010000001110; ;163  %-BBBBBGGGGGRRRRR
    .word 0b1000000010101110; ;164  %-BBBBBGGGGGRRRRR
    .word 0b1001110010101110; ;165  %-BBBBBGGGGGRRRRR
    .word 0b1011100010101110; ;166  %-BBBBBGGGGGRRRRR
    .word 0b1101010010101110; ;167  %-BBBBBGGGGGRRRRR
    .word 0b1000000101001110; ;168  %-BBBBBGGGGGRRRRR
    .word 0b1001110101001110; ;169  %-BBBBBGGGGGRRRRR
    .word 0b1011100101001110; ;170  %-BBBBBGGGGGRRRRR
    .word 0b1101010101001110; ;171  %-BBBBBGGGGGRRRRR
    .word 0b1000000111101110; ;172  %-BBBBBGGGGGRRRRR
    .word 0b1001110111101110; ;173  %-BBBBBGGGGGRRRRR
    .word 0b1011100111101110; ;174  %-BBBBBGGGGGRRRRR
    .word 0b1101010111101110; ;175  %-BBBBBGGGGGRRRRR
    .word 0b1000000000010101; ;176  %-BBBBBGGGGGRRRRR
    .word 0b1001110000010101; ;177  %-BBBBBGGGGGRRRRR
    .word 0b1011100000010101; ;178  %-BBBBBGGGGGRRRRR
    .word 0b1101010000010101; ;179  %-BBBBBGGGGGRRRRR
    .word 0b1000000010110101; ;180  %-BBBBBGGGGGRRRRR
    .word 0b1001110010110101; ;181  %-BBBBBGGGGGRRRRR
    .word 0b1011100010110101; ;182  %-BBBBBGGGGGRRRRR
    .word 0b1101010010110101; ;183  %-BBBBBGGGGGRRRRR
    .word 0b1000000101010101; ;184  %-BBBBBGGGGGRRRRR
    .word 0b1001110101010101; ;185  %-BBBBBGGGGGRRRRR
    .word 0b1011100101010101; ;186  %-BBBBBGGGGGRRRRR
    .word 0b1101010101010101; ;187  %-BBBBBGGGGGRRRRR
    .word 0b1000000111110101; ;188  %-BBBBBGGGGGRRRRR
    .word 0b1001110111110101; ;189  %-BBBBBGGGGGRRRRR
    .word 0b1011100111110101; ;190  %-BBBBBGGGGGRRRRR
    .word 0b1101010111110101; ;191  %-BBBBBGGGGGRRRRR
    .word 0b1000000000000000; ;192  %-BBBBBGGGGGRRRRR
    .word 0b1010100000000000; ;193  %-BBBBBGGGGGRRRRR
    .word 0b1101010000000000; ;194  %-BBBBBGGGGGRRRRR
    .word 0b1111110000000000; ;195  %-BBBBBGGGGGRRRRR
    .word 0b1000000101000000; ;196  %-BBBBBGGGGGRRRRR
    .word 0b1010100101000000; ;197  %-BBBBBGGGGGRRRRR
    .word 0b1101010101000000; ;198  %-BBBBBGGGGGRRRRR
    .word 0b1111110101000000; ;199  %-BBBBBGGGGGRRRRR
    .word 0b1000001010100000; ;200  %-BBBBBGGGGGRRRRR
    .word 0b1010101010100000; ;201  %-BBBBBGGGGGRRRRR
    .word 0b1101011010100000; ;202  %-BBBBBGGGGGRRRRR
    .word 0b1111111010100000; ;203  %-BBBBBGGGGGRRRRR
    .word 0b1000001111100000; ;204  %-BBBBBGGGGGRRRRR
    .word 0b1010101111100000; ;205  %-BBBBBGGGGGRRRRR
    .word 0b1101011111100000; ;206  %-BBBBBGGGGGRRRRR
    .word 0b1111111111100000; ;207  %-BBBBBGGGGGRRRRR
    .word 0b1000000000001010; ;208  %-BBBBBGGGGGRRRRR
    .word 0b1010100000001010; ;209  %-BBBBBGGGGGRRRRR
    .word 0b1101010000001010; ;210  %-BBBBBGGGGGRRRRR
    .word 0b1111110000001010; ;211  %-BBBBBGGGGGRRRRR
    .word 0b1000000101001010; ;212  %-BBBBBGGGGGRRRRR
    .word 0b1010100101001010; ;213  %-BBBBBGGGGGRRRRR
    .word 0b1101010101001010; ;214  %-BBBBBGGGGGRRRRR
    .word 0b1111110101001010; ;215  %-BBBBBGGGGGRRRRR
    .word 0b1000001010101010; ;216  %-BBBBBGGGGGRRRRR
    .word 0b1010101010101010; ;217  %-BBBBBGGGGGRRRRR
    .word 0b1101011010101010; ;218  %-BBBBBGGGGGRRRRR
    .word 0b1111111010101010; ;219  %-BBBBBGGGGGRRRRR
    .word 0b1000001111101010; ;220  %-BBBBBGGGGGRRRRR
    .word 0b1010101111101010; ;221  %-BBBBBGGGGGRRRRR
    .word 0b1101011111101010; ;222  %-BBBBBGGGGGRRRRR
    .word 0b1111111111101010; ;223  %-BBBBBGGGGGRRRRR
    .word 0b1000000000010101; ;224  %-BBBBBGGGGGRRRRR
    .word 0b1010100000010101; ;225  %-BBBBBGGGGGRRRRR
    .word 0b1101010000010101; ;226  %-BBBBBGGGGGRRRRR
    .word 0b1111110000010101; ;227  %-BBBBBGGGGGRRRRR
    .word 0b1000000101010101; ;228  %-BBBBBGGGGGRRRRR
    .word 0b1010100101010101; ;229  %-BBBBBGGGGGRRRRR
    .word 0b1101010101010101; ;230  %-BBBBBGGGGGRRRRR
    .word 0b1111110101010101; ;231  %-BBBBBGGGGGRRRRR
    .word 0b1000001010110101; ;232  %-BBBBBGGGGGRRRRR
    .word 0b1010101010110101; ;233  %-BBBBBGGGGGRRRRR
    .word 0b1101011010110101; ;234  %-BBBBBGGGGGRRRRR
    .word 0b1111111010110101; ;235  %-BBBBBGGGGGRRRRR
    .word 0b1000001111110101; ;236  %-BBBBBGGGGGRRRRR
    .word 0b1010101111110101; ;237  %-BBBBBGGGGGRRRRR
    .word 0b1101011111110101; ;238  %-BBBBBGGGGGRRRRR
    .word 0b1111111111110101; ;239  %-BBBBBGGGGGRRRRR
    .word 0b1000000000011111; ;240  %-BBBBBGGGGGRRRRR
    .word 0b1010100000011111; ;241  %-BBBBBGGGGGRRRRR
    .word 0b1101010000011111; ;242  %-BBBBBGGGGGRRRRR
    .word 0b1111110000011111; ;243  %-BBBBBGGGGGRRRRR
    .word 0b1000000101011111; ;244  %-BBBBBGGGGGRRRRR
    .word 0b1010100101011111; ;245  %-BBBBBGGGGGRRRRR
    .word 0b1101010101011111; ;246  %-BBBBBGGGGGRRRRR
    .word 0b1111110101011111; ;247  %-BBBBBGGGGGRRRRR
    .word 0b1000001010111111; ;248  %-BBBBBGGGGGRRRRR
    .word 0b1010101010111111; ;249  %-BBBBBGGGGGRRRRR
    .word 0b1101011010111111; ;250  %-BBBBBGGGGGRRRRR
    .word 0b1111111010111111; ;251  %-BBBBBGGGGGRRRRR
    .word 0b1000001111111111; ;252  %-BBBBBGGGGGRRRRR
    .word 0b1010101111111111; ;253  %-BBBBBGGGGGRRRRR
    .word 0b1101011111111111; ;254  %-BBBBBGGGGGRRRRR
    .word 0b1111111111111111; ;255  %-BBBBBGGGGGRRRRR


	
GBA_SpritePalettes:
    .word 0b0000000000000000; ;0  0b-BBBBBGGGGGRRRRR
    .word 0b0111110000010000; ;1  0b-BBBBBGGGGGRRRRR
    .word 0b0111111111100000; ;2  0b-BBBBBGGGGGRRRRR
    .word 0b0111111111111111; ;3  0b-BBBBBGGGGGRRRRR
    .word 0b0100000000000000; ;4  0b-BBBBBGGGGGRRRRR
    .word 0b0100000000010000; ;5  0b-BBBBBGGGGGRRRRR
    .word 0b0100001000000000; ;6  0b-BBBBBGGGGGRRRRR
    .word 0b0110001100011000; ;7  0b-BBBBBGGGGGRRRRR
    .word 0b0100001000010000; ;8  0b-BBBBBGGGGGRRRRR
    .word 0b0000000000011111; ;9  0b-BBBBBGGGGGRRRRR
    .word 0b0000001111100000; ;10  0b-BBBBBGGGGGRRRRR
    .word 0b0000001111111111; ;11  0b-BBBBBGGGGGRRRRR
    .word 0b0111110000000000; ;12  0b-BBBBBGGGGGRRRRR
    .word 0b0111110000011111; ;13  0b-BBBBBGGGGGRRRRR
    .word 0b0111111111100000; ;14  0b-BBBBBGGGGGRRRRR
    .word 0b0111111111111111; ;15  0b-BBBBBGGGGGRRRRR

SpritePatterns:		;16 color 8x8 sprite patterns
	.incbin "\ResALL\ChibiVM\Sprong_Sprites_GBA.raw"
SpritePatterns_End:	

	.align 4
	
vm_AddressRemapTable:
	.long SpritePatterns	;0
	.long SpriteArrayRam 	;1
	.long SpriteData_Bat1	;2
	.long SpriteData_Bat2	;3
	.long SpriteData_Ball	;4
	.long 0;SpriteArray 	;5
	.long 0;SpriteData_Magnify ;6

SpriteArray:
	.long 3		;Count	
	.long 0x70,0x80
		.long SpriteData_Bat1	;XXYY,Sprite
	.long 0x90,0x80
		.long SpriteData_Bat2	;XXYY,Sprite
	.long 0x80,0x80
		.long SpriteData_Ball	;XXYY,Sprite
	
	
	.ifdef BuildROS
	
		.align 4
SpriteData_Bat2:	
SpriteData_Bat1:
		.long 1,3		;W,H
		.long 0,1,2

	
SpriteData_Ball:
		.long 1,1		;W,H
		.long 3
	
	.endif
	
	.ifndef SpriteData_Bat1
	
		.align 4
SpriteData_Bat2:	
SpriteData_Bat1:
		.byte 1,3		;W,H
		.word 0x0000 ; SSCMTTDRYYYYYYYY
		.word 0x0000 ; SSVHRRRXXXXXXXXX
		.word 0 ; CCCCPPTTTTTTTTTT		;Attribs
		.word 0,1,2
	
SpriteData_Ball:
		.byte 1,1		;W,H
		.word 0,0,0		;Attribs
		.word 3
	
	.endif
	
	.align 4  ;*** WARNING - COUNT WILL MEAN ARRAY is ODD ALIGNED! ***
	
	
	
ramareaAddress:
	.long ramarea
		
HelloWorldAddress:
	.long HelloWorld			;Pointer to Hello message
	
HelloWorld:
	.byte "Hello",254,"World",0xa0+4,"-",0xc0+4,"|",251,5,4,'!',1,255
	.align 4
		
	.include "V1_Monitor.asm"
	
	.include "core.asm"
	
	.include "\srcALL\ChibiVm_CPU.asm"
	.include "ChibiVM_Host.asm"
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
	
	.align 16
	
	.ifdef QuadtreeFxColor16
BitStream:
		.incbin "\ResALL\QuadTree\col16\Quad._Stream.raw"	
		.align 4
PixelBlock:
		.incbin "\ResALL\QuadTree\col16\Quad._Pixels.raw"
		.align 4	
	
		.include "\ResALL\QuadTree\col16\Quad._FrameDefs.asm"
		.align 4
Sequence:
		.include "\ResALL\QuadTree\col16\Quad._FrameList.asm"
		.align 4	
	.endif
	
	.ifdef QuadtreeFxColor256
		.ifdef BuildROS
		BitStream:
			.incbin "\ResALL\QuadTree\ros256\Quad_Stream.raw"	
			.align 4
PixelBlock:
			.incbin "\ResALL\QuadTree\ros256\Quad_Pixels.raw"
			.align 4	
	
			.include "\ResALL\QuadTree\ros256\Quad_FrameDefs.asm"
			.align 4
Sequence:
			.include "\ResALL\QuadTree\ros256\Quad_FrameList.asm"
			.align 4
		.else
BitStream:
			.incbin "\ResALL\QuadTree\col256\Quad._Stream.raw"	
			.align 4
PixelBlock:
			.incbin "\ResALL\QuadTree\col256\Quad._Pixels.raw"
			.align 4	
	
			.include "\ResALL\QuadTree\col256\Quad._FrameDefs.asm"
			.align 4
Sequence:
			.include "\ResALL\QuadTree\col256\Quad._FrameList.asm"
			.align 4
		.endif
	.endif
	
	.ifdef QuadtreeFxColor
BitStream:
		.incbin "\ResALL\QuadTree\col\Quad_Stream.raw"	
		.align 4
PixelBlock:
		.incbin "\ResALL\QuadTree\col\Quad_Pixels.raw"
		.align 4	
	
		.include "\ResALL\QuadTree\col\Quad_FrameDefs.asm"
		.align 4
Sequence:
		.include "\ResALL\QuadTree\col\Quad_FrameList.asm"
		.align 4
	.endif
	
	.ifdef QuadtreeLowQuality
BitStream:
		.incbin "\ResALL\QuadTree\LQ\Quad._Stream.raw"	
		.align 4
PixelBlock:
		.incbin "\ResALL\QuadTree\LQ\Quad._Pixels.raw"
		.align 4	
	
		.include "\ResALL\QuadTree\LQ\Quad._FrameDefs.asm"
		.align 4
Sequence:
		.include "\ResALL\QuadTree\LQ\Quad._FrameList.asm"
		.align 4
	.endif
	.ifdef QuadtreeHighQuality
BitStream:
		.incbin "\ResALL\QuadTree\HQ\Quad._Stream.raw"	
		.align 4
PixelBlock:
		.incbin "\ResALL\QuadTree\HQ\Quad._Pixels.raw"
		.align 4	
	
		.include "\ResALL\QuadTree\HQ\Quad._FrameDefs.asm"
		.align 4
Sequence:
		.include "\ResALL\QuadTree\HQ\Quad._FrameList.asm"
		.align 4
	.endif
	
	
	.ifdef BuildGBA
		.include "GBA_Footer.asm"
	.endif
	.ifdef BuildNDS
		.include "NDS_Footer.asm"
	.endif
	.ifdef BuildROS
		.include "ROS_Footer.asm"
	.endif