	.ifdef BuildROS
;.equ ROS_256Color,1	;Use 256 color sprites
	.endif

.equ VM_ProgLoadAddr,0x400	

.equ VscreenMinX,64		;Top left of visible screen in logical co-ordinates
.equ VscreenMinY,80

.equ VscreenWid,128		;Visible Screen Size in logical units
.equ VscreenHei,96


.equ GBA_SpritePatternCount,128

	.ifdef BuildROS
.equ VM_RamBase,0x10000
	.else
.equ VM_RamBase,ramarea+65536
	.endif

	.include "\srcALL\ChibiVm_InstSet.asm"

	.ifdef BuildGBA
		.include "GBA_Header.asm"
	.endif
	.ifdef BuildNDS
		.include "NDS_Header.asm"
	.endif
	.ifdef BuildROS
		.include "ROS_Header.asm"
	.endif
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
.equ HspriteCount,ramarea+32

	;adrl r6,SpritePatterns
	;bl NativeSpr_Init

	;adrl r6,SpriteArray
	
	;bl NativeSpr_DrawArray
	
	;bl NativeSpr_HideAll
	
	
	;mov r0,#0x00	;Sprite Num
	;mov r1,#64		;Xpos
	;mov r4,#80		;Ypos
	;adrl r5,SpriteData_Bat1
	;bl NativeSpr_Draw
	
	; mov r2,#2	;Xpos
	; mov r5,#5	;Ypos

	 ;ldr r3,HelloWorldAddress	;Address of Hello World Message
	 ;bl PrintSeq				;Show Message
	 
	; bl NewLine
	
	; bl ReadJoystick
	
	; bl monitor				;Show Regs
	
	; bl NewLine
		
	; adr	r0,HelloWorld		;Address
	; mov r1,#2				;Lines
	; bl MemDump				;Dump to screen
	

	; bl NewLine
	
	; bl ReadJoystick
	
	; bl monitor				;Show Regs
	
	; bl NewLine
		
	; adr	r0,HelloWorld		;Address
	; mov r1,#2				;Lines
	; bl MemDump				;Dump to screen
	
	; bl NewLine
	; .macro StoreLE src,dest
		; mov r12,\src
		; strb r12,[\dest]
		; mov r12,r12,lsr #8
		; strb r12,[\dest,#1]
	; .endm 
	
	; .macro LoadLE src,dest
		; adrl r11,Mask16bit
		; ldr r11,[r11]
		
		; and \dest,\dest,r11
		; ldrb r12,[\src,#1]
		; mov r12,r12,lsl #8
		; ldrb r11,[\src]
		; add \dest,\dest,r11
		; add \dest,\dest,r12
	; .endm 
	
	; .macro loadLEA0 off,dest
		; adrl r11,Mask16bit
		; ldr r11,[r11]
		; and \dest,\dest,r11
		
		; ldrb r12,[r10,#\off+1]
		; mov r12,r12,lsl #8
		; ldrb r11,[r10,#\off]
		; add \dest,\dest,r11
		; add \dest,\dest,r12
	; .endm
	
	
	; adrl r10,HelloWorld
	
	; adrl r11,Mask16bit
	; ldr r0,[r11]
	; loadLEA0 3,r0
	
	; ldr	r10,ramareaAddress		;Address
	
	; StoreLE r0,r10
	
	
	bl ChibiVM_Init

	
	;mov r0,#0x0800				;Prog Start
	
	;adrl r10,vm_rambaseAddr		;Address
	;ldr r10,[r10]
	;StoreLEA0 r0,vm_rpc
	
	
	;mov r0,#0x0200				;Stack
	;StoreLEA0 r0,vm_rsp
	
	; mov r0,#0x0000
	; StoreLEA0 r0,vm_rBank0
	; mov r0,#0x4000
	; StoreLEA0 r0,vm_rBank1
	; mov r0,#0x8000
	; StoreLEA0 r0,vm_rBank2
	; mov r0,#0xC000
	; StoreLEA0 r0,vm_rBank3
	
;Copy our program to VM Ram
	; adrl r10,vm_rambaseAddr		;Address
	; ldr r2,[r10]
	; ldr r10,[r10]
	; LoadLEA0 vm_rpc,r2
	
	; adrl r3,VM_Program
	; mov r1,#VM_Program_End-VM_Program
	
; ProgramCopyAgain:	
	; ldrb r0,[r3],#1
	; strb r0,[r2],#1

	; subs r1,r1,#1
	; bne ProgramCopyAgain
	
	
	
;use this to skip part of the test program	
	; mov r1,#140
; ProgSkip:
	; bl VM_Tick
	; subs r1,r1,#1
	; bne ProgSkip
	
InfLoop:	
	mov r2,#0	;Xpos
	mov r5,#0	;Ypos
	; bl monitor				;Show Regs

	adrl r0,vm_rambaseAddr		;Address
	ldr r0,[r0]
	mov r1,#4				;Lines
	bl MemDump				;Dump to screen
	
	
	
	adrl r10,vm_rambaseAddr		;Address
	ldr r0,[r10]
	add r0,r0,#0x0200				;Stack
	sub r0,r0,#8+4
	;ldr r10,[r10]
	;LoadLEA0 vm_rsp,r0
	;sub r0,r0,#12
	mov r1,#2				;Lines
	bl MemDump				;Dump to screen
	
	
	adrl r10,vm_rambaseAddr		;Address
	ldr r0,[r10]
	ldr r10,[r10]
	LoadLEA0 vm_rpc,r0
	mov r1,#3				;Lines
	bl MemDump				;Dump to screen

InfLoop2:	
	bl VM_Tick
	b InfLoop2



    b InfLoop					;Halt
	
vm_rambaseAddr: .long VM_RamBase;ramarea+65536


TestSysCall1:
	mov r0,#0xE4
	adrl r10,vm_rambaseAddr
	ldr r10,[r10]
	strb r0,[r10,#VM_rR1]
	
	
	
	ldr lr,[sp],#4			;Pop return address (command)
	mov pc,lr
	
vm_trap_TableAddr: .long  VM_RamBase + 0x800+(vm_Traps-VM_Program)


	.ifdef BuildGBA
		.include "\SrcGBA\V1_NativeSprite.asm"	;MUST come before Adventure Engine!
	.endif
	.ifdef BuildNDS
		.include "\SrcGBA\V1_NativeSprite.asm"	;MUST come before Adventure Engine!
	.endif
	.ifdef BuildROS
		.include "\SrcROS\V1_NativeSprite.asm"	;MUST come before Adventure Engine!
	.endif
		
		
	.include "ChibiVM_AdventureEngine.asm"
	.include "\SrcALL\V1_ChibiSound.asm"

; SlowDown:			;This exists for systems that run too fast (Like SMS)
	; ret
	
; DoLddr:
	; lddr			;For gameboy compatibility
	; ret	
	.align 16
VM_Program_Zero:	
	.space 0x400
VM_Program:	
	.byte "!!!!Chibi/VM!!!!"			;Magic key - must be on a $xxxxxx00 boundary
	.byte "Your product name here          "		;Software Name - 32 bytes

	;rorg $10000+VM_ProgLoadAddr+$30
	.byte 0			;Header Version
	.byte 0b00000011	; config {COpy Vectors to $100}
	.byte 0b00111111	;Requirements {adv} {reikou} {maxtile} {QTV} {NS} {memmapper} {ChibiTracks}
	.byte 0			;Spare
	.byte 0			;Spare
	.byte 0			;Cpu Requirements
	.byte 0			;Ram Requirements
	.byte 0 			;Vector Requorements {Vblank}
	.byte 0 			;SysCall Requirements {VmMonitor}{VmControl}{ChipExt}
	.byte 0 			;SysCall Requirements
	.byte 0			;ChipExt Requirements ???
	.byte 0			;ChipExt Requirements ???
	.byte 0x11		;Bitmap Modes 0-7 {NS / Maxtile} 0=ZXS 1=CPC 2=GBC 3=SMS 4=SAM 5=VGA 6=GBA 7=RGBA
	.byte 0x01		;Bitmap Modes 0-7 {AdvFont / QTV } 0=ZXS 1=CPC 2=GBC 3=SMS 4=SAM 5=VGA 6=GBA 7=RGBA
	.byte 0			;Bitmap modes (spare)
	.byte 0			;Bitmap modes (spare)
	
	;rorg $10000+VM_ProgLoadAddr+$40
	.long 0x400		;Rom Load Address
	.long 0x200		;StackPointer
	.long 0x100		;Trap table Ram address (0=none)
	.long 0x0000		;Memmap 1
	.long 0x4000		;Memmap 2
	.long 0x8000		;Memmap 3
	.long 0xC000		;Memmap 4

	.byte 0,0,0,0
	.byte 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	;rorg $10000+VM_ProgLoadAddr+$70
	.long (vm_traps-VM_Program)	;Vector table (0=none)
	.long 0x2000		;Address remap table (0=none)
	.long 0			;VMAssets (Palette,Font etc)
	.long 0			;???

VM_Program_Hend:
	.space 0x800-(VM_Program_Hend-VM_Program_Zero)	;Program load address

	
.equ VramBase,0
.equ ballpos,64+16
.equ ballmove,64+18
.equ PlayerPaddle,64+20
.equ CpuPaddle,64+22
.equ PlayerScore,64+24
.equ CpuScore,64+25
.equ GameTick,64+26
.equ GameSpeed,64+27		
.equ GameAI,64+28
.equ SoundByte,64+29 

ProgramLaunch:

	dbbw mov16x,r6_imm16,0;SpritePatterns		;Sprite patterns
	;dbbw mov16x,r2_imm16,4*SpritePatternSize	;ByteCount
	NSCall nsInit 
	
	
	
	;dbbw mov16x,r6_imm16,SpriteArrayRam	;Ram
	;NSCall nsDrawArray+regRR 			;SpriteArray
	
	dbbw mov16x,r6_imm16,1;5	;Ram
	NSCall nsDrawArray+regRR 			;SpriteArray
		
	; ld hl,SpritePatterns		;Sprite patterns
	; ld bc,4*SpritePatternSize	;ByteCount
	; call NativeSpr_Init
	
	
	
;                                     

;                                     newgame:
newgame:
	NSCall nsHideAll+regNO
	
	;db hltb
	
	;dbbw mov16x,r6_imm16,SpriteArrayRam	;Ram
	;NSCall nsDrawArray+regRR 			;SpriteArray

;                                     	advcall acls
	advcall acls
;                                     	mov16x r6,#0x0000		;speed - ai
	dbbw mov16x,r6_imm16,0x0000
;                                     titlescreen:

titlescreen:
;                                     	advcall apause50
	advcall apause50
;                                     	mov16x r4,#0x0000		;cursorpos
	dbbw mov16x,r4_imm16,0x0000
;                                     	ph6
	db ph6b
;                                     		mov16x r6,#strstart
	dbbw mov16x,r6_imm16,strstart-VramBase
;                                     		advcall aprintseq
	advcall aprintseq
;                                     		mov16x r6,#strspeed
	dbbw mov16x,r6_imm16,strspeed-VramBase
;                                     		advcall aprintseq
	advcall aprintseq
;                                     	pl6
	db pl6b
;                                     	movx r0,r7
	dbbb movx,r0_zeropg,r7
;                                     	advcall ashowdecimal
	advcall ashowdecimal
;                                     	ph6
	db ph6b
;                                     		mov16x r6,#strai
	dbbw mov16x,r6_imm16,strai-VramBase
;                                     		advcall aprintseq
	advcall aprintseq
;                                     	pl6
	db pl6b
;                                     	movx r0,r6
	dbb movx,r0_r6
;                                     	advcall ashowdecimal
	advcall ashowdecimal
;                                     

;                                     	advcall areadjoystick	;0b---frldu
	advcall areadjoystick
;                                     	movx r2,r0
	dbb movx,r2_r0
;                                     

;                                     	mov16x r4,#0x0004		;cursorpos
	dbbw mov16x,r4_imm16,0x0004
;                                     

;                                     	movx r0,r6
	dbb movx,r0_r6
;                                     	advcall ajoyaxis		;ud
	advcall ajoyaxis
;                                     	advcall arangelimit
	advcall arangelimit
;                                     	movx r6,r0
	dbb movx,r6_r0
;                                     

;                                     	movx r0,r7
	dbbb movx,r0_zeropg,r7
;                                     	advcall ajoyaxis		;lr
	advcall ajoyaxis
;                                     	advcall arangelimit
	advcall arangelimit
;                                     	movx r7,r0
	dbbb movx,zeropg_r0,r7
;                                     

;                                     	tstx r2,#1			;fire?
	dbbb tstx,r2_imm8,1
;                                     	bnei titlescreen
	dbb bnei,titlescreen-lbl35419
lbl35419:



	dbbb movx,r0_zeropg,r7
	dbw bsrj,readmask-VramBase
	dbbw stox,r0_addr16,gamespeed

	dbb movx,r0_r6
	dbw bsrj,readmask-VramBase
	dbbw stox,r0_addr16,gameai

	dbw bsrj,rezeroball-VramBase

 	dbbw sto16x,r4_addr16,ballpos

	dbbww mov16x,addr16_imm16,ballmove,0xffff	;ball pos -1 = facing player

	dbbwb movx,addr16_imm8,playerpaddle,6*4		;ypos
	dbbwb movx,addr16_imm8,cpupaddle,6*4

	dbbw clrx,addr16_r0,cpuscore
	dbbw clrx,addr16_r0,playerscore

	dbbwb movx,addr16_imm8,playerpaddle+1,0*4	;Xpos
	dbbwb movx,addr16_imm8,cpupaddle+1,19*4

	advcall acls
	dbbw mov16x,r6_imm16,strwall-VramBase				;Draw Walls
	advcall aprintseq
	
	dbw bsrj,ShowScores-VramBase							;ShowScores

gameloop:

	dbbw mov16x,r4_addr16,ballpos
	db ph4b
		
	dbbbb addx,zeropg_imm8,r4,VscreenMinY
	dbbbb addx,zeropg_imm8,r5,VscreenMinX
	
	dbbw sto16x,r4_addr16,SpriteArrayRam+9
	
	dbw bsrj,getplayerpaddlede-VramBase
	
	dbbbb addx,zeropg_imm8,r4,VscreenMinY
	dbbbb addx,zeropg_imm8,r5,VscreenMinX
	
	dbbw sto16x,r4_addr16,SpriteArrayRam+1
		
	dbw bsrj,getcpupaddlede-VramBase
		
	dbbbb addx,zeropg_imm8,r4,VscreenMinY
	dbbbb addx,zeropg_imm8,r5,VscreenMinX
	
	dbbw sto16x,r4_addr16,SpriteArrayRam+5
		
	dbbw mov16x,r6_imm16,SpriteArrayRam	;Ram
	NSCall nsDrawArray+regRR 			;SpriteArray

	dbbw mov16x,r6_imm16,SpriteArrayRam	;Ram
	NSCall nsDrawArray+regRR 			;SpriteArray
	
	;dbw bsrj,drawpaddle

	

	dbbw movx,r0_addr16,soundbyte
	advcall achibisound+regRR
	dbbw clrx,addr16_r0,soundbyte
	
	dbb movi,1
	advcall apausea
	
	db pl4b

	;db ph4b
	;dbb movi,' '
	;advcall aprintchar
	;db pl4b

	
	
	
	dbbw movx,r0_addr16,gametick
	db incb
	dbbw stox,r0_addr16,gametick

	dbbw andx,r0_addr16,gamespeed

	dbb bnei,noballmove-lbl65191
lbl65191:
	dbbw mov16x,r2_addr16,ballmove
	dbw bsrj,moveball-VramBase
noballmove:

	dbw bsrj,getplayerpaddlede-VramBase

	advcall areadjoystick
	dbb movx,r2_r0
	dbw bsrj,processpaddle-VramBase

 	dbbw sto16x,r6_addr16,playerpaddle
	dbw bsrj,getcpupaddlede-VramBase

	dbbw movx,r0_addr16,gametick
	dbbw andx,r0_addr16,gameai

	dbb bnei,cpudecided-lbl61257
lbl61257:

	dbbb movx,r2_imm8,0b11111111	;nomove
	dbbw movx,r0_addr16,ballpos
	dbb subi,1
	dbb cmpz,r4
	dbb beqi,cpudecided-lbl43064
lbl43064:
	dbb bcsi,cpuup-lbl27499
lbl27499:
	dbbb movx,r2_imm8,0b11111101
	dbb brai,cpudecided-lbl36249
lbl36249:

cpuup:
	dbbb movx,r2_imm8,0b11111110

cpudecided:
	dbw bsrj,processpaddle-VramBase

	dbbw mov16x,addr16_r6,cpupaddle

	dbbw movx,r0_addr16,cpuscore
	dbbw orrx,r0_addr16,playerscore
	dbb cmpi,8
	dbw bcsj,gameloop-VramBase
	
	
	
	dbbw mov16x,r6_imm16,strgameover-VramBase
	dbbw mov16x,r4_imm16,0x0608
	advcall aprintseq
	advcall awaitforfire
	dbw braj,newgame-VramBase

	
getplayerpaddlede:
	dbbw mov16x,r4_addr16,playerpaddle
	db rtsb

getcpupaddlede:
	dbbw mov16x,r4_addr16,cpupaddle
	db rtsb

	
moveball:
	dbbwb movx,addr16_imm8,soundbyte,0b10100000
	dbbw mov16x,r6_addr16,playerpaddle
	
	;dbbb movx,r0_zeropg,r5
	;dbb cmpi,1*4
	dbbbb cmpx,zeropg_imm8,r5,1*4-1
	
	dbb bnei,noplayerpaddlehit-lbl50130
lbl50130:

	dbw bsrj,paddletest-VramBase
	dbb bcci,noplayerpaddlehit-lbl28645
lbl28645:
	dbw bsrj,cpuscores-VramBase		;cs=hit


noplayerpaddlehit:
	dbbw mov16x,r6_addr16,cpupaddle

	dbbbb cmpx,zeropg_imm8,r5,18*4+1
	
	dbb bnei,nocpupaddlehit-lbl7460
lbl7460:
	dbw bsrj,paddletest-VramBase
	dbb bcci,nocpupaddlehit-lbl16183
lbl16183:
	dbw bsrj,playerscores-VramBase

	
nocpupaddlehit:
	dbbb addx,zeropg_r3,r5
	dbb  addx,r4_r2		;update ball ypos
	dbbb cmpx,r4_imm8,1*4			;hit top wall
	dbb bnei,lbl5063-lbl23676
lbl23676:
	dbw bsrj,flipy-VramBase
lbl5063:
	dbbb cmpx,r4_imm8,16*4	;hit bottom wall
	dbb bnei,lbl16101-lbl21583
lbl21583:
	dbw bsrj,flipy-VramBase
lbl16101:
 	dbbw sto16x,r4_addr16,ballpos		;Old cursor pos
 	dbbw sto16x,r2_addr16,ballmove	
	db rtsb

paddletest:	;carry=missed paddle
	dbb movx,r0_r4
	dbb cmpz,r6
	dbb bcsi,paddlemiss-lbl22097
lbl22097:
	dbb subi,3*4
	dbb cmpz,r6
	dbb bcci,paddlemiss-lbl59932
lbl59932:
	dbw bsrj,flipx-VramBase

	dbbwb movx,addr16_imm8,soundbyte,0b01000000
	dbb orrz,r0	;clear carry
	db rtsb

paddlemiss:
	dbbwb movx,addr16_imm8,soundbyte,0b01110000
	dbbb movx,rf_imm8,3
	db rtsb

cpuscores:
	dbbw incx,addr16_r0,cpuscore
	dbw bsrj,rezeroball-VramBase
	dbw bsrj,ShowScores-VramBase							;ShowScores
	db rtsb

playerscores:
	dbbw incx,addr16_r0,playerscore
	dbw bsrj,ShowScores-VramBase							;ShowScores

rezeroball:
	dbbw mov16x,r4_imm16,0x0a08*4

flipx:
	dbb negz,r3
	db rtsb

flipy:
	dbb negz,r2
	db rtsb
	

processpaddle:
	dbb mov16x,r6_r4

	dbbw mov16x,r4_imm16,0x010e*4
	dbb movx,r0_r6
		advcall ajoyaxis
		advcall arangelimit
	dbb movx,r6_r0
	db rtsb

readmask:
	dbbbb movx,zeropg_imm8,r5,0
	dbb movx,r4_r0
	dbbw add16x,r4_imm16,masks-VramBase
	dbb movx,r0_atr4
	db rtsb
	
ShowScores:
	db ph4b
		dbbw mov16x,r4_imm16,0x0011
		dbbw movx,r0_addr16,playerscore
		advcall ashowdecimal+regRR

		dbbw mov16x,r4_imm16,0x1111
		dbbw movx,r0_addr16,cpuscore
		advcall ashowdecimal+regRR
	db pl4b
	db rtsb
;Speed masks for ball and AI	
Masks:	.byte 0b00000111,0b00000011,0b00000001,0b00000000


strGameOver:.byte "Game Over",255
strStart:	.byte "Sprong - Sprite Pong!!",253,255

strSpeed:	.byte 253,"Speed:",255
strAi:		.byte 253,"AI:",255


strWall:	.byte 0xB3,"-"
			.byte 253
			.byte 0xF1	;253=Newline (Xpos=0) 0xF1= Ypos=17
			 .byte 0xB3,"-"
			 .byte 255		;0xB3=18 char H strip

strPaddle: 	 	 .byte 0xC2,"X",255 ;0xC2=3 char V strip
strBlankPaddle:  .byte 0xC2," ",255

vm_traps: 	.word ProgramLaunch
			.word 0
			
SpriteArrayRam:
SpriteArrayTT:
	.byte 3		;Count	
	.word 0x7080
		.byte 2,0;SpriteData_Bat1	;XXYY,Sprite
	.word 0x9080
		.byte 3,0;dc.w SpriteData_Bat2	;XXYY,Sprite
	.word 0x8080
		.byte 4,0;dc.w SpriteData_Ball	;XXYY,Sprite
	.align 4


	
	.align 4
VM_Program_End:
	
	
GBA_SpritePalettes:
    .word 0b0000000000000000; ;0  0b-BBBBBGGGGGRRRRR
    .word 0b0111110000010000; ;1  0b-BBBBBGGGGGRRRRR
    .word 0b0111111111100000; ;2  0b-BBBBBGGGGGRRRRR
    .word 0b0111111111111111; ;3  0b-BBBBBGGGGGRRRRR
    .word 0b0100000000000000; ;4  0b-BBBBBGGGGGRRRRR
    .word 0b0100000000010000; ;5  0b-BBBBBGGGGGRRRRR
    .word 0b0100001000000000; ;6  0b-BBBBBGGGGGRRRRR
    .word 0b0110001100011000; ;7  0b-BBBBBGGGGGRRRRR
    .word 0b0100001000010000; ;8  0b-BBBBBGGGGGRRRRR
    .word 0b0000000000011111; ;9  0b-BBBBBGGGGGRRRRR
    .word 0b0000001111100000; ;10  0b-BBBBBGGGGGRRRRR
    .word 0b0000001111111111; ;11  0b-BBBBBGGGGGRRRRR
    .word 0b0111110000000000; ;12  0b-BBBBBGGGGGRRRRR
    .word 0b0111110000011111; ;13  0b-BBBBBGGGGGRRRRR
    .word 0b0111111111100000; ;14  0b-BBBBBGGGGGRRRRR
    .word 0b0111111111111111; ;15  0b-BBBBBGGGGGRRRRR

SpritePatterns:	
	.ifdef ROS_256Color
		.incbin "\ResALL\ChibiVM\Sprong_Sprites_ROS256.raw" ;256 color
	.else
		;NDS , GBA and ROS 16 color sprites
		.incbin "\ResALL\ChibiVM\Sprong_Sprites_GBA.raw" ;16 color
								
	.endif
SpritePatterns_End:	

	;align 8192 ;$2000
	
	.align 4
		
vm_AddressRemapTable:
	.long SpritePatterns	;0
	.long SpriteArrayRam 	;1
	.long SpriteData_Bat1	;2
	.long SpriteData_Bat2	;3
	.long SpriteData_Ball	;4
	.long 0;SpriteArray 	;5
	.long 0;SpriteData_Magnify ;6

SpriteArray:
	.long 3		;Count	
	.long 0x70,0x80
		.long SpriteData_Bat1	;XXYY,Sprite
	.long 0x90,0x80
		.long SpriteData_Bat2	;XXYY,Sprite
	.long 0x80,0x80
		.long SpriteData_Ball	;XXYY,Sprite
	
	
	.ifdef BuildROS		;Generix Xor format
		.align 4
SpriteData_Bat2:	
SpriteData_Bat1:
		.long 1,3		;Width,Height
		.long 0,1,2		;Tile pattern numbers
	
SpriteData_Ball:
		.long 1,1		;Width,Height
		.long 3			;Tile pattern numbers
	.endif
	
	
	.ifndef SpriteData_Bat1	 ;NDS and GBA
	
		.align 4
SpriteData_Bat2:	
SpriteData_Bat1:
		.byte 1,3		;W,H
		.word 0x0000 ; SSCMTTDRyyyyyyyy		;Shared Attribs (y set later)
		.word 0x0000 ; SSVHRRRxxxxxxxxx     ;Shared Attribs (x set later)
		.word 0 	 ; CCCCPPtttttttttt		;Shared Attribs (t set below!)
		.word 0,1,2	 ; ------TTTTTTTTTT     ;Tile numbers
	
SpriteData_Ball:
		.byte 1,1		;W,H
		.word 0,0,0		;Attribs
		.word 3			;Tiles
	
	.endif
	
	.align 4  ;*** WARNING - COUNT WILL MEAN ARRAY is ODD ALIGNED! ***
	
	
	
ramareaAddress:
	.long ramarea
		
HelloWorldAddress:
	.long HelloWorld			;Pointer to Hello message
	
HelloWorld:
	.byte "Hello",254,"World",0xa0+4,"-",0xc0+4,"|",251,5,4,'!',1,255
	.align 4
		
	.include "V1_Monitor.asm"
	
	.include "core.asm"
	
	.include "\srcALL\ChibiVm_CPU.asm"
	.include "ChibiVM_Host.asm"
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
	
	.ifdef BuildGBA
		.include "GBA_Footer.asm"
	.endif
	.ifdef BuildNDS
		.include "NDS_Footer.asm"
	.endif
	.ifdef BuildROS
		.include "ROS_Footer.asm"
	.endif