	.ifdef BuildROS
.equ VM_RamBase,0x10000
	.else
.equ VM_RamBase,ramarea+65536
	.endif

	.include "\srcALL\ChibiVm_InstSet.asm"

	.ifdef BuildGBA
		.include "GBA_Header.asm"
	.endif
	.ifdef BuildNDS
		.include "NDS_Header.asm"
	.endif
	.ifdef BuildROS
		.include "ROS_Header.asm"
	.endif
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	

	; mov r2,#2	;Xpos
	; mov r5,#5	;Ypos

	 ;ldr r3,HelloWorldAddress	;Address of Hello World Message
	 ;bl PrintSeq				;Show Message
	 
	; bl NewLine
	
	; bl ReadJoystick
	
	; bl monitor				;Show Regs
	
	; bl NewLine
		
	; adr	r0,HelloWorld		;Address
	; mov r1,#2				;Lines
	; bl MemDump				;Dump to screen
	

	; bl NewLine
	
	; bl ReadJoystick
	
	; bl monitor				;Show Regs
	
	; bl NewLine
		
	; adr	r0,HelloWorld		;Address
	; mov r1,#2				;Lines
	; bl MemDump				;Dump to screen
	
	; bl NewLine
	; .macro StoreLE src,dest
		; mov r12,\src
		; strb r12,[\dest]
		; mov r12,r12,lsr #8
		; strb r12,[\dest,#1]
	; .endm 
	
	; .macro LoadLE src,dest
		; adrl r11,Mask16bit
		; ldr r11,[r11]
		
		; and \dest,\dest,r11
		; ldrb r12,[\src,#1]
		; mov r12,r12,lsl #8
		; ldrb r11,[\src]
		; add \dest,\dest,r11
		; add \dest,\dest,r12
	; .endm 
	
	; .macro loadLEA0 off,dest
		; adrl r11,Mask16bit
		; ldr r11,[r11]
		; and \dest,\dest,r11
		
		; ldrb r12,[r10,#\off+1]
		; mov r12,r12,lsl #8
		; ldrb r11,[r10,#\off]
		; add \dest,\dest,r11
		; add \dest,\dest,r12
	; .endm
	
	
	; adrl r10,HelloWorld
	
	; adrl r11,Mask16bit
	; ldr r0,[r11]
	; loadLEA0 3,r0
	
	; ldr	r10,ramareaAddress		;Address
	
	; StoreLE r0,r10
	
	
	
	
	mov r0,#0x0800				;Prog Start
	
	adrl r10,vm_rambaseAddr		;Address
	ldr r10,[r10]
	StoreLEA0 r0,vm_rpc
	
	
	mov r0,#0x0200				;Stack
	StoreLEA0 r0,vm_rsp
	
	mov r0,#0x0000
	StoreLEA0 r0,vm_rBank0
	mov r0,#0x4000
	StoreLEA0 r0,vm_rBank1
	mov r0,#0x8000
	StoreLEA0 r0,vm_rBank2
	mov r0,#0xC000
	StoreLEA0 r0,vm_rBank3
	
;Copy our program to VM Ram
	adrl r10,vm_rambaseAddr		;Address
	ldr r2,[r10]
	ldr r10,[r10]
	LoadLEA0 vm_rpc,r2
	
	adrl r3,VM_Program
	mov r1,#VM_Program_End-VM_Program
	
ProgramCopyAgain:	
	ldrb r0,[r3],#1
	strb r0,[r2],#1

	subs r1,r1,#1
	bne ProgramCopyAgain
	
	
	
;;use this to skip part of the test program	
	mov r1,#140
ProgSkip:
	bl VM_Tick
	subs r1,r1,#1
	bne ProgSkip
	
InfLoop:	
	mov r2,#0	;Xpos
	mov r5,#0	;Ypos
	; bl monitor				;Show Regs

	adrl r0,vm_rambaseAddr		;Address
	ldr r0,[r0]
	mov r1,#4				;Lines
	bl MemDump				;Dump to screen
	
	
	
	adrl r10,vm_rambaseAddr		;Address
	ldr r0,[r10]
	add r0,r0,#0x0200				;Stack
	sub r0,r0,#8+4
	;ldr r10,[r10]
	;LoadLEA0 vm_rsp,r0
	;sub r0,r0,#12
	mov r1,#2				;Lines
	bl MemDump				;Dump to screen
	
	
	adrl r10,vm_rambaseAddr		;Address
	ldr r0,[r10]
	ldr r10,[r10]
	LoadLEA0 vm_rpc,r0
	mov r1,#3				;Lines
	bl MemDump				;Dump to screen
	
	bl VM_Tick
	
	; bl ReadJoystick
	
	; mov r2,#128
	; mov r5,#192
	; bl RangedRandom
	
	
	; mov r2,#0	;Xpos
	; mov r5,#0	;Ypos
	; bl monitor				;Show Regs
	
	
	
	

	; mov r0,#1
	; cmp r0,#0			;Carry Set
	

	; add r10,r10,#1

	; mov r2,#0	;Xpos
	; mov r5,#20	;Ypos
	
	;;mov r0,#234
	;;bl ShowDecimal
	
	
	;bl WaitForFire


    b InfLoop					;Halt
	
vm_rambaseAddr: .long VM_RamBase;ramarea+65536


vm_syscalls:
	.long 0
	.long TestSysCall1
	
TestSysCall1:
	mov r0,#0xE4
	adrl r10,vm_rambaseAddr
	ldr r10,[r10]
	strb r0,[r10,#VM_rR1]
	
	
	
	ldr lr,[sp],#4			;Pop return address (command)
	mov pc,lr
	
vm_trap_TableAddr: .long  VM_RamBase + 0x800+(vm_Traps-VM_Program)


; SlowDown:			;This exists for systems that run too fast (Like SMS)
	; ret
	
; DoLddr:
	; lddr			;For gameboy compatibility
	; ret	
	.align 16
	.space 0x800	;Program load address
VM_Program:
		;dbw braj,TestTrapSys
	
	
;Test 1 - Flags
	dbw mov16i,0x0100						;Move 0x0100 R0
	.byte mov16x,RF_R0						;move 0x01 into FU
	.byte phfb									;Push F onto stack
	.byte pl4b									;Pop into R4
	.byte ph4b
	.byte pl2b										;PUSHPOP
	dbbw cmp16x,R2_imm16,0x0100
	dbw bnej,ProgramFailed

TestAdd:
; Test 2 - ADD
	.byte movx,ZeroPg_imm8,vm_RFU,0x02
	
	.byte movi,0xFE
	.byte addi,1									;ADD
	.byte cmpx,RF_imm8,0x00
	dbw bnej,ProgramFailed
	.byte addi,1
	.byte cmpx,RF_imm8,0x03							;Carry+Z
	dbw bnej,ProgramFailed

	
; Test 3 - SUB
	.byte movx,ZeroPg_imm8,vm_RFU,0x03
	
	.byte addi,1
	
	.byte subi,1									;SUB
	.byte cmpx,RF_imm8,0x02
	dbw bnej,ProgramFailed
	.byte subi,1
	.byte cmpx,RF_imm8,0x01							;Carry+Z
	dbw bnej,ProgramFailed
	
TestIncDec:
; Test 4 - INC DEC
	.byte movx,ZeroPg_imm8,vm_RFU,0x04
	dbw mov16i,0xFF01
	
	.byte incz,0									;INC
	.byte incz,0
	dbw beqj,ProgramFailed
	.byte incz,0
	
	.byte decz,1									;DEC
	.byte decz,1
	dbw beqj,ProgramFailed
	.byte decz,1
	dbbw cmp16x,R0_imm16,0xFC04
	dbw bnej,ProgramFailed

TestSTO:
; Test 5 - STO STO16
	.byte movx,ZeroPg_imm8,vm_RFU,0x05
	dbw mov16i,0x1234
	.byte sto16z,2									;STO16
	.byte stoz,4									;STO
	dbbw cmp16x,R2_imm16,0x1234
	dbw bnej,ProgramFailed
	
	.byte cmpx,R4_imm8,0x34
	dbw bnej,ProgramFailed

	
TestLEA:
; Test 6 - LEA
	.byte movx,ZeroPg_imm8,vm_RFU,0x06
	.byte leaz,2									;LEA
	dbbbw mov16x,ZeroPg_imm16,4,VM_RamBase
	.byte movx,ZeroPg_Imm8,4,0x02
	dbb cmp16x,R0_R4
	dbw bnej,ProgramFailed
	
TestNEG:	
;Test 7 - NEG SWP16
	.byte movx,ZeroPg_imm8,vm_RFU,0x07
	dbw mov16i,0x0000
	.byte incb
	.byte NEGb										;NEG
	dbbw cmp16x,R0_imm16,0x00FF
	dbw bnej,ProgramFailed
	.byte NEGb
	.byte NEGb
	dbw beqj,ProgramFailed
	
	.byte swp16b									;Swp16
	dbbw cmp16x,R2_imm16,0x00FF
	dbw bnej,ProgramFailed
		
TestROL:
;Test 8 - ROL ROR
	.byte movx,ZeroPg_imm8,vm_RFU,0x08
	.byte movx,rF_imm8,3
	dbw mov16i,0x0041	
	.byte rolb										;ROL
	dbbw cmp16x,R0_imm16,0x0083
	dbw bnej,ProgramFailed
	.byte rolb
	.byte rolb
	.byte rolb
	.byte rolb
	.byte rolb
	.byte rolb
	.byte rolb
	.byte rolb
	dbbw cmp16x,R0_imm16,0x0041
	dbw bnej,ProgramFailed
	dbw mov16i,0x0080
	.byte rolb
	dbw bccj,ProgramFailed
	dbw bnej,ProgramFailed
	
	dbw mov16i,0x0041	
	.byte rorb										;ROR
	.byte rorb
	.byte rorb
	.byte rorb
	.byte rorb
	.byte rorb
	.byte rorb
	.byte rorb
	.byte rorb
	dbbw cmp16x,R0_imm16,0x0041
	dbw bnej,ProgramFailed
	
TestASL:
;Test 9 - ASL ASR LSL
	.byte movx,ZeroPg_imm8,vm_RFU,0x09
	dbw mov16i,0x0043	
	.byte aslb										;ASL
	.byte aslb
	.byte aslb
	.byte aslb
	dbbw cmp16x,R0_imm16,0x0030
	dbw bnej,ProgramFailed
	
	dbw mov16i,0x0043	
	.byte lsrb										;LSR
	.byte lsrb
	.byte lsrb
	.byte lsrb
	dbbw cmp16x,R0_imm16,0x0004
	dbw bnej,ProgramFailed
	
	dbw mov16i,0x0083	
	.byte asrb										;ASR
	.byte asrb
	.byte asrb
	.byte asrb
	dbbw cmp16x,R0_imm16,0x00F8
	dbw bnej,ProgramFailed
	
TestLogOps:
;Test 10 A - AND OR XOR
	.byte movx,ZeroPg_imm8,vm_RFU,0x0A
	dbw mov16i,0x0043	
	
	.byte andi,0x0F									;AND
	dbbw cmp16x,R0_imm16,0x0003
	dbw bnej,ProgramFailed
	
	.byte orri,0x7F									;OR
	dbbw cmp16x,R0_imm16,0x007F
	dbw bnej,ProgramFailed
	
	.byte xori,0xF0									;XOR
	dbbw cmp16x,R0_imm16,0x008F
	dbw bnej,ProgramFailed
	
	.byte tsti,0x80									;TST 
	dbw beqj,ProgramFailed
	.byte tsti,0x40
	dbw bnej,ProgramFailed
	

Test16bit:
;Test 11 B - MOV16b INC16b DEC16b ADD16b SUB16b
	.byte movx,ZeroPg_imm8,vm_RFU,0x0B
	dbw mov16i,0x8765
	
	.byte inc16b									;INC 16
	dbbw cmp16x,R0_imm16,0x8766
	dbw bnej,ProgramFailed
	
	.byte dec16b									;DEC 16
	dbbw cmp16x,R0_imm16,0x8765
	dbw bnej,ProgramFailed
	
	dbw add16i,0x8000							;16bit add
	dbw bccj,ProgramFailed
	dbbw cmp16x,R0_imm16,0x0765
	dbw bnej,ProgramFailed
		
	dbw sub16i,0x8000							;16 bit subtract
	dbw bccj,ProgramFailed
	dbbw cmp16x,R0_imm16,0x8765
	dbw bnej,ProgramFailed
	

TestTrapSys:
;Test 12 C - TRPb SYSb BRA2 BSR2
	.byte movx,ZeroPg_imm8,vm_RFU,0x0C
	.byte trpi,1									;Trap Test
	.byte sysi,1									;System Test
	dbbw cmp16x,R0_imm16,0xE4F3
	dbw bnej,ProgramFailed
	
	dbw bsrj,TestSub&0xFFFF							;Sub test
	dbbw cmp16x,R0_imm16,0x7766
	dbw bnej,ProgramFailed
	
	.byte inc16b,nopb								
	.byte bra2										;Skip next 2 bytes
	.byte inc16b,nopb
	.byte inc16b,nopb
	dbbw cmp16x,R0_imm16,0x7768
	dbw bnej,ProgramFailed
	
	.byte brai,4									;Skip next 4 bytes
	.byte inc16b,nopb
	.byte inc16b,nopb
	
	dbbw cmp16x,R0_imm16,0x7768
	dbw bnej,ProgramFailed

	dbw bsr16i,(TestSub-AddressCalc1)&0xFFFF			;16 bit Relative Sub test
AddressCalc1:
	dbbw cmp16x,R0_imm16,0x7766
	dbw bnej,ProgramFailed
	
	dbbw mov16x,r6_imm16,TestSub2
	.byte bsrh										;branch to sub in R6/7
	dbbw cmp16x,R0_imm16,0x8877
	dbw bnej,ProgramFailed
	
TestAddressing:
;Test 13 D - Addressing Modes
	.byte movx,ZeroPg_imm8,vm_RFU,0x0D	
	
	dbbw mov16x,R0_Addr16,TestLoadAddress		;Store to address
	dbbw cmp16x,R0_imm16,0xC0C1
	dbw bnej,ProgramFailed
	
	dbbw mov16x,R6_imm16,(TestLoadAddress+2)&0xFFFF
	dbb movx,R0_AtR6							;Indirection
	dbbb cmpx,R0_imm8,0xC3
	dbw bnej,ProgramFailed
	
	dbbw mov16x,R2_imm16,(VM_RamBase+16)&0xFFFF
	dbb movx,AtR2inc_AtR6						;Autoinc
	dbb movx,AtR2inc_AtR6
	dbb movx,AtR2inc_AtR6
	dbb movx,AtR2inc_AtR6
	dbb movx,AtR2inc_AtR6
	dbbwb cmpx,Addr16_imm8,(VM_RamBase+16+4)&0xFFFF,0xC3	
	dbw bnej,ProgramFailed
	
	dbbw mov16x,R4_imm16,TestLoadAddress
	dbbb mov16x,R0_AtR4PlIm,4					;Base+Offset
	dbbb cmpx,r0_imm8,0xC5
	dbw bnej,ProgramFailed
	
	dbbw mov16x,R6_imm16,0x7770
	.byte ph6b
	dbbw cmp16x,AtSP_imm16,0x7770				;Compare to top of stack
	dbw bnej,ProgramFailed
	
	
	
	.byte mov16i
	.word 'OK'
	.byte HLTb
	
TestSub:	
	dbw mov16i,0x7766
	.byte retb
	
TestSub2:	
	dbw mov16i,0x8877
	.byte retb
	
ProgramFailed:
	.byte mov16i
	.word 'NG'
	.byte HLTb
		

TestLoadAddress:
	.word 0xC0C1
	.word 0xC2C3
	.word 0xC4C5




TestTrap1:
	.byte MOVi,0xF3
	.byte RETb

Trap1:
	.byte MOVi,0xEE	
	.byte RETb
	
Trap2:
	.byte vm_PHF
	;.byte vm_MOV+ParamExtByt,Dest_ZeroPg+Param_ZeroPg,VM_rFs,VM_rF
	;.byte vm_PH0
		.byte vm_ORR+ParamExtByt,Dest_ZeroPg+Param_Imm8,VM_rF,VM_fTrap 

		.byte vm_MOV+vm_aIM,0xDD
	
	;.byte vm_AND+ParamExtByt,Dest_Addr8+Param_Imm8
	;.byte 8,%10111111
	;.byte vm_MOV+ParamExtByt,Dest_ZeroPg+Param_ZeroPg,VM_rF,VM_rFs
	.byte vm_PLF
	.byte vm_RET
	
		

vm_Traps:		
	.word VM_Program
	.word TestTrap1	
	
VM_Program_End:
	
ramareaAddress:
	.long ramarea
		
HelloWorldAddress:
	.long HelloWorld			;Pointer to Hello message
	
HelloWorld:
	.byte "Hello",254,"World",0xa0+4,"-",0xc0+4,"|",251,5,4,'!',1,255
	.align 4
		
	.include "V1_Monitor.asm"
	
	.include "core.asm"
	.include "\SrcALL\V1_ChibiSound.asm"
	
	.include "\srcALL\ChibiVm_CPU.asm"
	


	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
	
	.ifdef BuildGBA
		.include "GBA_Footer.asm"
	.endif
	.ifdef BuildNDS
		.include "NDS_Footer.asm"
	.endif
	.ifdef BuildROS
		.include "ROS_Footer.asm"
	.endif