

NewLine:
	STMFD sp!,{lr}
	
		mov r2,#0		;X
		add r5,r5,#1	;Y
		
		cmp.b r5,#24
		bcs clsb
		LDMFD sp!,{pc}

cls:
	STMFD sp!,{lr}
clsb:
		mov r2,#0
		mov r5,#0
;                                     		ld hl,&2000
		mov r3,#0x20
		mov r6,#0
;                                     		ld bc,&2018
		mov r1,#0x20
		mov r4,#0x18
		bl fillarea
NewLine_Return:
	LDMFD sp!,{pc}
	mov pc,lr	
	
	
ReadJoystick:
	STMFD sp!,{r1-r10, lr}
		mov r9,#255
	
		mov r10,#0b11111110
		mov r1,#255^57		;Key 57=UP (255 xor key)	
		bl Key_TestOne
		
		mov r10,#0b11111101
		mov r1,#255^41		;Key 41=DOWN (255 xor key)	
		bl Key_TestOne
		
		mov r10,#0b11111011
		mov r1,#255^25		;Key 25=LEFT (255 xor key)	
		bl Key_TestOne
		
		mov r10,#0b11110111
		mov r1,#255^121		;Key 25=RIGHT (255 xor key)	
		bl Key_TestOne
		
		
		mov r10,#0b11101111
		mov r1,#255^98		;Key 98=SPACE (255 xor key)	
		bl Key_TestOne
		
		mov r10,#0b11011111
		mov r1,#255^73		;Key 73=ENTER (255 xor key)	
		bl Key_TestOne
		
		mov r0,r9
	LDMFD sp!,{r1-r10, pc}		
	
Key_TestOne:
	STMFD sp!,{r0-r8, lr}
		mov r0,#129			;Test a key
		mov r2,#255			;255=No Wait
		SWI 0x6				;OSByte
		cmp r1,#255			;255=Pressed 0=Unpressed
		andeq r9,r9,r10 
	LDMFD sp!,{r0-r8, pc}		


	
GetVars:
	.long 148	;ScreenStart
	.long 149	;DisplayStart
	.long 150	;TotalScreenSize
	.long -1	;List End

ReturnVars:
AdrScreenBase:	.long 0		;ScreenStart
			.long 0		;DisplayStart
			.long 0		;TotalScreenSize

	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SetPalette:		;R0= Palette Number R1= 0x-----GRB

	STMFD sp!,{r0-r12, lr}	
		mov r11,r0
		
		mov r0,#19	;VDU 19	-Set palette
;VDU 19,logical colour,mode,red,green,blue

		swi 0x00	;print char R0
		
		mov r0,r11	;palette number
		swi 0x00	;print char R0
		
		mov r0,#16	;NoFlash
		swi 0x00	;print char R0
		
		mov r2,r1			;Red
		and r2,r2,#0xF0 	;Nibble Mask
		mov r0,r2			;R (top 4 bit 00-F0)
		swi 0x00			;print char R0
		
		mov r2,r1,ROR #4	;Green
		and r2,r2,#0xF0 	;Nibble Mask
		mov r0,r2			;G (top 4 bit 00-F0)
		swi 0x00			;print char R0
		
		mov r2,r1,LSL #4	;Blue
		and r2,r2,#0xF0 	;Nibble Mask
		mov r0,r2			;B (top 4 bit 00-F0)
		swi 0x00			;print char R0
	LDMFD sp!,{r0-r12, pc}	
	
	
	.ifndef ROS_256Color
	.ifndef InitPalette
InitPalette:
		.word 0x0000 ;0  -GRB
		.word 0x0088 ;1  -GRB
		.word 0x0F0F ;2  -GRB
		.word 0x0FFF ;3  -GRB
		.word 0x0084 ;4  -GRB
		.word 0x0808 ;5  -GRB
		.word 0x088F ;6  -GRB
		.word 0x00F0 ;7  -GRB
		.word 0x0F04 ;8  -GRB
		.word 0x07FC ;9  -GRB
		.word 0x088F ;10  -GRB
		.word 0x000F ;11  -GRB
		.word 0x0800 ;12  -GRB
		.word 0x0EB6 ;13  -GRB
		.word 0x00F8 ;14  -GRB
		.word 0x0FFF ;15  -GRB
	.endif
	.endif
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
PrintNumber:
	add r0,r0,#48
	
PrintChar:
	STMFD sp!,{r0,r1,r3-r12, lr}
		and r2,r2,#255
		and r5,r5,#255
		
		cmp r0,#0
		beq PrintChar_Zero
		
		
		;mov r4,#0
		;mov r7,#0
		
		;mov r3,#CursorX
		;ldrB r4,[r3]			;X pos
		;mov r3,#CursorY
		;ldrB r7,[r3]			;Y pos
		
		adrl r1,AdrScreenBase
		ldr r3,[r1]			;Get Screen Base
		
		;mov r6,#4	
		;mul r12,r2,r6
		.ifdef ROS_256Color
			add r3,r3,r2,asl #3		;Xpos (8 bytes per Char)
		.else
			add r3,r3,r2,asl #2		;Xpos (4 bytes per Char)
		.endif 
		
		
		.ifdef ROS_256Color
			mov r4,#320*8		;Ypos (320 bytes per line - 8 lines per char)
		.else
			mov r4,#160*8		;Ypos (160 bytes per line - 8 lines per char)
		.endif 
		mul r12,r5,r4
		add r3,r3,r12
		
		adrl r4,BitmapFont 	;Address of our font
		sub r0,r0,#32		;No chars <32 (first Char = space)
		cmp r0,#64
		subcs r0,r0,#32		;Convert Lower To Uppercase
		.ifdef ROS_256Color
			add r4,r4,r0,lsl #6 ;Char * 64 - offset to 
		.else
			add r4,r4,r0,lsl #5 ;Char * 32 - offset to 
		.endif 
		
		mov r1,#8 		;Lines
NextFontLine:

		
		.ifdef ROS_256Color
			ldr r0,[r4],#4
			str r0,[r3],#4
			ldr r0,[r4],#4
			str r0,[r3],#320-4
		.else
			ldr r0,[r4],#4
			str r0,[r3],#160;-8
		.endif 
		
		subs r1,r1,#1
		bne NextFontLine		;Repeat for next line
PrintChar_Zero:		
		add r2,r2,#1			;Move across screen
	LDMFD sp!,{r0,r1,r3-r12, pc}

BitmapFont:
	.ifdef ROS_256Color
		.space 64
	         .long 0xFF000000,0x00000000,0xEF000000,0x000000FF,0xEF000000,0x000000EF,0xEF000000,0x000000EF,0xEF000000,0x000000EF,0x00000000,0x00000000,0x8F000000,0x000000EF,0x00000000,0x00000000     ;  0  - Ofst:&0
        .long 0x00FF0000,0x000000FF,0x00FFEF00,0x0000EFFF,0x00EF0000,0x000000EF,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000     ;  1  - Ofst:&40
        .long 0x00000000,0x00000000,0x00FF0000,0x000000FF,0xEFEFEF00,0x0000EFEF,0x00EF0000,0x000000EF,0x8FEF8F00,0x00008FEF,0x008F0000,0x0000008F,0x00000000,0x00000000,0x00000000,0x00000000     ;  2  - Ofst:&80
        .long 0xFF000000,0x000000FF,0xEFFF0000,0x00FFEFFF,0x0000EF00,0x000000EF,0xEFEF0000,0x0000EFEF,0xEF000000,0x00EF0000,0x8FEF8F00,0x00008FEF,0x8F000000,0x0000008F,0x00000000,0x00000000     ;  3  - Ofst:&C0
        .long 0x00000000,0x00FF0000,0x0000EFFF,0x0000EF00,0x0000EFEF,0x000000EF,0xEF000000,0x00000000,0x00EF0000,0x00000000,0x00008F00,0x00EF8F00,0x0000008F,0x008F8F00,0x00000000,0x00000000     ;  4  - Ofst:&100
        .long 0xFF000000,0x00000000,0x00FF0000,0x000000FF,0x00EF0000,0x000000EF,0xEFEFEF00,0x00EF0000,0xEF0000EF,0x0000EF00,0x000000EF,0x00008FEF,0x8F8F8F00,0x008F0000,0x00000000,0x00000000     ;  5  - Ofst:&140
        .long 0x00000000,0x0000FFFF,0xEF000000,0x0000EFFF,0xEFEF0000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000     ;  6  - Ofst:&180
        .long 0xFF000000,0x000000FF,0xEF000000,0x000000FF,0xEFEF0000,0x00000000,0xEFEF0000,0x00000000,0xEFEF0000,0x00000000,0x8F000000,0x000000EF,0x8F000000,0x0000008F,0x00000000,0x00000000     ;  7  - Ofst:&1C0
        .long 0xFF000000,0x000000FF,0xEF000000,0x000000FF,0x00000000,0x0000EFEF,0x00000000,0x0000EFEF,0x00000000,0x0000EFEF,0x8F000000,0x000000EF,0x8F000000,0x0000008F,0x00000000,0x00000000     ;  8  - Ofst:&200
        .long 0x00000000,0x000000FF,0x0000FF00,0xFF0000EF,0x00EF0000,0x00EF00EF,0xEF000000,0x0000EFEF,0xEF000000,0x0000EF00,0x00EF0000,0x00EF0000,0x00008F00,0x8F000000,0x00000000,0x00000000     ;  9  - Ofst:&240
        .long 0x00000000,0x00000000,0xEF000000,0x000000FF,0xEF000000,0x000000EF,0xEFEFEF00,0x00EFEFEF,0xEF000000,0x000000EF,0x8F000000,0x000000EF,0x00000000,0x00000000,0x00000000,0x00000000     ; 10  - Ofst:&280
        .long 0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x8F000000,0x000000EF,0x8F000000,0x0000008F,0x8F8F0000,0x00000000     ; 11  - Ofst:&2C0
        .long 0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0xEFEFEF00,0x00EFEFEF,0x8F8F8F00,0x008F8F8F,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000     ; 12  - Ofst:&300
        .long 0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x8F000000,0x000000EF,0x8F000000,0x0000008F,0x00000000,0x00000000     ; 13  - Ofst:&340
        .long 0x00000000,0x00FF0000,0x00000000,0x0000EF00,0x00000000,0x000000EF,0xEF000000,0x00000000,0x00EF0000,0x00000000,0x00008F00,0x00000000,0x0000008F,0x00000000,0x00000000,0x00000000     ; 14  - Ofst:&380
        .long 0xFFFFFF00,0x0000FFFF,0x0000EFFF,0x00FFEF00,0xEF00EFEF,0x00EFEF00,0xEF00EFEF,0x00EFEF00,0x8F00EF8F,0x008FEF00,0x00008F8F,0x008F8F00,0x8F8F8F00,0x00008F8F,0x00000000,0x00000000     ; 15  - Ofst:&3C0
        .long 0xFF000000,0x00000000,0xEF000000,0x000000FF,0xEF000000,0x000000EF,0xEF000000,0x000000EF,0xEF000000,0x000000EF,0x8F000000,0x000000EF,0x00000000,0x0000008F,0x00000000,0x00000000     ; 16  - Ofst:&400
        .long 0xFFFF0000,0x0000FFFF,0xEFFFEF00,0x00FFEFFF,0x00000000,0x00EFEF00,0xEFEF0000,0x0000EFEF,0x00EFEF00,0x00000000,0x8FEF8F00,0x00EF8FEF,0x8F8F0000,0x00008F8F,0x00000000,0x00000000     ; 17  - Ofst:&440
        .long 0xFFFF0000,0x0000FFFF,0xEFFFEF00,0x00FFEFFF,0x00000000,0x00EFEF00,0xEF000000,0x0000EFEF,0x00000000,0x00EFEF00,0x8FEF8F00,0x00EF8FEF,0x8F8F0000,0x00008F8F,0x00000000,0x00000000     ; 18  - Ofst:&480
        .long 0xFF000000,0x000000FF,0xEFFF0000,0x0000EFFF,0x00EFEF00,0x0000EF00,0x0000EFEF,0x0000EFEF,0xEFEFEF00,0x0000EFEF,0x00000000,0x00008FEF,0x00000000,0x0000008F,0x00000000,0x00000000     ; 19  - Ofst:&4C0
        .long 0xFFFF0000,0x0000FFFF,0xEFFFEF00,0x00FFEFFF,0x00EFEF00,0x00000000,0xEFEFEF00,0x0000EFEF,0x00000000,0x00EFEF00,0x8FEF8F00,0x00EF8FEF,0x8F8F0000,0x008F8F8F,0x00000000,0x00000000     ; 20  - Ofst:&500
        .long 0xFFFF0000,0x0000FFFF,0xEFFFEF00,0x00FFEFFF,0x00EFEF00,0x00000000,0xEFEFEF00,0x0000EFEF,0x00EFEF00,0x00EFEF00,0x00EF8F00,0x00EF8F00,0x8F8F0000,0x00008F8F,0x00000000,0x00000000     ; 21  - Ofst:&540
        .long 0xFFFF0000,0x0000FFFF,0xEFFFEF00,0x00FFEFFF,0x00000000,0x00EFEF00,0x00000000,0x0000EFEF,0xEF000000,0x000000EF,0x8F000000,0x000000EF,0x8F000000,0x00000000,0x00000000,0x00000000     ; 22  - Ofst:&580
        .long 0xFFFF0000,0x0000FFFF,0x00FFEF00,0x00FFEF00,0x00EFEF00,0x00EFEF00,0xEFEF0000,0x0000EFEF,0x00EFEF00,0x00EFEF00,0x00EF8F00,0x00EF8F00,0x8F8F0000,0x00008F8F,0x00000000,0x00000000     ; 23  - Ofst:&5C0
        .long 0xFFFF0000,0x0000FFFF,0x00FFEF00,0x00FFEF00,0x00EFEF00,0x00EFEF00,0xEFEF0000,0x00EFEFEF,0x00000000,0x00EFEF00,0x8FEF8F00,0x00EF8FEF,0x8F8F0000,0x00008F8F,0x00000000,0x00000000     ; 24  - Ofst:&600
        .long 0x00000000,0x00000000,0x00000000,0x00000000,0xFF000000,0x000000FF,0xEF000000,0x000000EF,0x00000000,0x00000000,0x8F000000,0x000000EF,0x8F000000,0x0000008F,0x00000000,0x00000000     ; 25  - Ofst:&640
        .long 0x00000000,0x00000000,0x00000000,0x00000000,0xFF000000,0x000000FF,0xEF000000,0x000000EF,0x00000000,0x00000000,0x8F000000,0x000000EF,0x8F000000,0x0000008F,0x8F8F0000,0x00000000     ; 26  - Ofst:&680
        .long 0x00000000,0x0000FFFF,0xEF000000,0x0000EFFF,0xEFEF0000,0x000000EF,0x00EFEF00,0x00000000,0xEFEF0000,0x000000EF,0x8F000000,0x00008FEF,0x00000000,0x00008F8F,0x00000000,0x00000000     ; 27  - Ofst:&6C0
        .long 0x00000000,0x00000000,0x00000000,0x00000000,0xEFFFEF00,0x00FFEFFF,0x00000000,0x00000000,0x00000000,0x00000000,0x8FEF8F00,0x00EF8FEF,0x00000000,0x00000000,0x00000000,0x00000000     ; 28  - Ofst:&700
        .long 0x00FFFF00,0x00000000,0xEFFFEF00,0x00000000,0xEFEF0000,0x000000EF,0x00000000,0x0000EFEF,0xEFEF0000,0x000000EF,0x8FEF8F00,0x00000000,0x008F8F00,0x00000000,0x00000000,0x00000000     ; 29  - Ofst:&740
        .long 0xFFFF0000,0x0000FFFF,0xEFFFEF00,0x00FFEF00,0x00000000,0x00EFEF00,0xEF000000,0x0000EFEF,0x00000000,0x00000000,0xEF000000,0x0000008F,0x8F000000,0x0000008F,0x00000000,0x00000000     ; 30  - Ofst:&780
        .long 0xFFFFFF00,0x0000FFFF,0x0000EFFF,0x00FFEFEF,0x00EF00EF,0x00EFEF00,0xEFEF00EF,0x00EFEF00,0x0000EFEF,0x008FEF00,0x8FEF8FEF,0x00000000,0x8F8F8F00,0x00008F8F,0x00000000,0x00000000     ; 31  - Ofst:&7C0
        .long 0xFF000000,0x000000FF,0xEFFF0000,0x0000EFFF,0x00EFEF00,0x00EFEF00,0x00EFEF00,0x00EFEF00,0xEFEFEF00,0x00EFEFEF,0x00EF8F00,0x00EF8F00,0x008F0000,0x00008F00,0x00000000,0x00000000     ; 32  - Ofst:&800
        .long 0xFFFF0000,0x0000FFFF,0x00FFEF00,0x00FFEF00,0x00EFEF00,0x00EFEF00,0xEFEFEF00,0x0000EFEF,0x00EFEF00,0x00EFEF00,0x00EF8F00,0x00EF8F00,0x8F8F0000,0x00008F8F,0x00000000,0x00000000     ; 33  - Ofst:&840
        .long 0xFFFF0000,0x000000FF,0xEFFFEF00,0x0000EFFF,0x0000EFEF,0x00000000,0x0000EFEF,0x00000000,0x0000EFEF,0x00000000,0x8FEF8F00,0x00008FEF,0x8F8F0000,0x0000008F,0x00000000,0x00000000     ; 34  - Ofst:&880
        .long 0xFFFF0000,0x0000FFFF,0x00FFEF00,0x0000EF00,0x00EFEF00,0x00EFEF00,0x00EFEF00,0x00EFEF00,0x00EFEF00,0x00EFEF00,0x00EF8F00,0x00008F00,0x8F8F0000,0x0000008F,0x00000000,0x00000000     ; 35  - Ofst:&8C0
        .long 0xFFFF0000,0x0000FFFF,0xEFFFEF00,0x00FFEFFF,0x00EFEF00,0x00000000,0xEFEFEF00,0x000000EF,0x00EFEF00,0x00000000,0x8FEF8F00,0x00EF8FEF,0x8F8F0000,0x00008F8F,0x00000000,0x00000000     ; 36  - Ofst:&900
        .long 0xFFFF0000,0x000000FF,0xEFFFEF00,0x0000EFFF,0x00EFEF00,0x00000000,0xEFEFEF00,0x000000EF,0x00EFEF00,0x00000000,0x00EF8F00,0x00000000,0x008F0000,0x00000000,0x00000000,0x00000000     ; 37  - Ofst:&940
        .long 0xFFFF0000,0x0000FFFF,0x00FFEF00,0x00FFEF00,0x0000EFEF,0x00000000,0x0000EFEF,0x00000000,0x0000EFEF,0x0000EFEF,0x00EF8F00,0x00EF8F00,0x8F8F0000,0x00008F8F,0x00000000,0x00000000     ; 38  - Ofst:&980
        .long 0x00FF0000,0x0000FF00,0x00FFEF00,0x00FFEF00,0x00EFEF00,0x00EFEF00,0xEFEFEF00,0x00EFEFEF,0x00EFEF00,0x00EFEF00,0x00EF8F00,0x00EF8F00,0x008F0000,0x00008F00,0x00000000,0x00000000     ; 39  - Ofst:&9C0
        .long 0xFF000000,0x00000000,0xEF000000,0x000000FF,0xEF000000,0x000000EF,0xEF000000,0x000000EF,0xEF000000,0x000000EF,0x8F000000,0x000000EF,0x00000000,0x0000008F,0x00000000,0x00000000     ; 40  - Ofst:&A00
        .long 0x00000000,0x000000FF,0x00000000,0x0000EFFF,0x00000000,0x0000EFEF,0x00000000,0x0000EFEF,0x0000EF00,0x0000EFEF,0x8FEF8FEF,0x00008FEF,0x8F8F8F00,0x0000008F,0x00000000,0x00000000     ; 41  - Ofst:&A40
        .long 0x00FF0000,0x0000FF00,0x00FFEF00,0x00FFEF00,0x00EFEF00,0x0000EFEF,0xEFEFEF00,0x000000EF,0x00EFEF00,0x0000EFEF,0x00EF8F00,0x00EF8F00,0x008F0000,0x00008F00,0x00000000,0x00000000     ; 42  - Ofst:&A80
        .long 0x00FF0000,0x00000000,0x00FFEF00,0x00000000,0x00EFEF00,0x00000000,0x00EFEF00,0x00000000,0x00EFEF00,0x00000000,0x8FEF8F00,0x00EF8FEF,0x8F8F0000,0x008F8F8F,0x00000000,0x00000000     ; 43  - Ofst:&AC0
        .long 0x0000FF00,0x0000FF00,0x00FFEFFF,0x00FFEFFF,0xEFEFEFEF,0x00EFEFEF,0xEF00EFEF,0x00EFEF00,0xEF00EFEF,0x00EFEF00,0xEF008FEF,0x00EF8F00,0x00008F00,0x00008F00,0x00000000,0x00000000     ; 44  - Ofst:&B00
        .long 0x0000FF00,0x0000FF00,0x00FFEFFF,0x00FFEF00,0xEFEFEFEF,0x00EFEF00,0xEF00EFEF,0x00EFEFEF,0x0000EFEF,0x00EFEFEF,0x00008FEF,0x00EF8F00,0x00008F00,0x00008F00,0x00000000,0x00000000     ; 45  - Ofst:&B40
        .long 0xFFFF0000,0x000000FF,0x00FFEF00,0x0000EFFF,0x0000EFEF,0x00EFEF00,0x0000EFEF,0x00EFEF00,0x0000EFEF,0x00EFEF00,0x00EF8F00,0x00008FEF,0x8F8F0000,0x0000008F,0x00000000,0x00000000     ; 46  - Ofst:&B80
        .long 0xFFFF0000,0x000000FF,0x00FFEF00,0x0000EFEF,0x00EFEF00,0x0000EF00,0xEFEFEF00,0x0000EFEF,0x00EFEF00,0x00000000,0x00EF8F00,0x00000000,0x008F0000,0x00000000,0x00000000,0x00000000     ; 47  - Ofst:&BC0
        .long 0xFFFF0000,0x000000FF,0x00FFEF00,0x0000EFFF,0x0000EFEF,0x00EFEF00,0x0000EFEF,0x00EFEF00,0x0000EFEF,0x00EF00EF,0x8F8F8F00,0x00008F00,0x8F8F0000,0x008F008F,0x00000000,0x00000000     ; 48  - Ofst:&C00
        .long 0xFFFF0000,0x0000FFFF,0x00FFEF00,0x00FFEF00,0x00EFEF00,0x00EFEF00,0xEFEFEF00,0x0000EFEF,0x00EFEF00,0x0000EFEF,0x00EF8F00,0x00EF8F00,0x008F0000,0x008F8F00,0x00000000,0x00000000     ; 49  - Ofst:&C40
        .long 0xFFFF0000,0x0000FFFF,0xEFFFEF00,0x00FFEFEF,0x00EFEF00,0x00000000,0xEFEF0000,0x0000EFEF,0x00000000,0x00EFEF00,0x8FEF8F00,0x00EF8FEF,0x8F8F0000,0x00008F8F,0x00000000,0x00000000     ; 50  - Ofst:&C80
        .long 0xFFFF0000,0x0000FFFF,0xEFFFEF00,0x00FFEFFF,0xEF000000,0x000000EF,0xEF000000,0x000000EF,0xEF000000,0x000000EF,0x8F000000,0x000000EF,0x00000000,0x0000008F,0x00000000,0x00000000     ; 51  - Ofst:&CC0
        .long 0x00FF0000,0x0000FF00,0x00FFEF00,0x00FFEF00,0x00EFEF00,0x00EFEF00,0x00EFEF00,0x00EFEF00,0x00EFEF00,0x00EFEF00,0x00EF8F00,0x00EF8F00,0x8F8F0000,0x00008F8F,0x00000000,0x00000000     ; 52  - Ofst:&D00
        .long 0x00FF0000,0x0000FF00,0x00FFEF00,0x00FFEF00,0x00EFEF00,0x00EFEF00,0x00EFEF00,0x00EFEF00,0x00EFEF00,0x00EFEF00,0x8FEF0000,0x00008FEF,0x8F000000,0x0000008F,0x00000000,0x00000000     ; 53  - Ofst:&D40
        .long 0x0000FF00,0x0000FF00,0x0000EFFF,0x00FFEF00,0xEF00EFEF,0x00EFEF00,0xEF00EFEF,0x00EFEF00,0xEFEFEFEF,0x00EFEFEF,0x008FEF8F,0x008FEF8F,0x00008F00,0x00008F00,0x00000000,0x00000000     ; 54  - Ofst:&D80
        .long 0x0000FFFF,0x00FFFF00,0x00FFEF00,0x0000EFFF,0xEFEF0000,0x000000EF,0xEFEF0000,0x000000EF,0x00EFEF00,0x0000EFEF,0x00008FEF,0x00EF8F00,0x00008F00,0x00008F00,0x00000000,0x00000000     ; 55  - Ofst:&DC0
        .long 0x00FF0000,0x0000FF00,0x00FFEF00,0x00FFEF00,0x00EFEF00,0x00EFEF00,0xEFEF0000,0x0000EFEF,0xEF000000,0x000000EF,0x8F000000,0x000000EF,0x00000000,0x0000008F,0x00000000,0x00000000     ; 56  - Ofst:&E00
        .long 0xFFFFFF00,0x0000FFFF,0xEFFFEFFF,0x0000EFFF,0x00000000,0x0000EFEF,0xEF000000,0x000000EF,0xEFEF0000,0x00000000,0x8FEF8F00,0x00EF8FEF,0x8F8F8F00,0x00008F8F,0x00000000,0x00000000     ; 57  - Ofst:&E40
        .long 0xFF000000,0x0000FFFF,0xEFFF0000,0x00000000,0xEFEF0000,0x00000000,0xEFEF0000,0x00000000,0xEFEF0000,0x00000000,0x8FEF0000,0x00000000,0x8F000000,0x00008F8F,0x00000000,0x00000000     ; 58  - Ofst:&E80
        .long 0x000000FF,0x00000000,0x0000EF00,0x00000000,0x00EF0000,0x00000000,0xEF000000,0x00000000,0x00000000,0x000000EF,0x00000000,0x00008F00,0x00000000,0x008F0000,0x00000000,0x00000000     ; 59  - Ofst:&EC0
        .long 0xFFFF0000,0x000000FF,0x00000000,0x0000EFFF,0x00000000,0x0000EFEF,0x00000000,0x0000EFEF,0x00000000,0x0000EFEF,0x00000000,0x00008FEF,0x8F8F0000,0x0000008F,0x00000000,0x00000000     ; 60  - Ofst:&F00
        .long 0xFF000000,0x000000FF,0xEFFF0000,0x0000EFFF,0xEFEFEF00,0x00EFEFEF,0xEF000000,0x000000EF,0xEF000000,0x000000EF,0x8F000000,0x000000EF,0x8F000000,0x0000008F,0x00000000,0x00000000     ; 61  - Ofst:&F40
        .long 0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x8F8F8F8F,0x8F8F8F8F,0x8F8F8F8F,0x8F8F8F8F     ; 62  - Ofst:&F80
        .long 0xFFFF0000,0x00000000,0xEF000000,0x000000FF,0x00000000,0x0000EFEF,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000     ; 63  - Ofst:&FC0

	.else	;16 color 
		.long 0,0,0,0,0,0,0,0
        .long 0x00003000,0x00032000,0x00022000,0x00022000,0x00022000,0x00000000,0x00021000,0x00000000     ;  0  - Ofst:&0
        .long 0x00030300,0x00230320,0x00020200,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000     ;  1  - Ofst:&20
        .long 0x00000000,0x00030300,0x00222220,0x00020200,0x00121210,0x00010100,0x00000000,0x00000000     ;  2  - Ofst:&40
        .long 0x00033000,0x03232300,0x00020020,0x00222200,0x02002000,0x00121210,0x00011000,0x00000000     ;  3  - Ofst:&60
        .long 0x03000000,0x00200023,0x00020022,0x00002000,0x00000200,0x02100010,0x01100001,0x00000000     ;  4  - Ofst:&80
        .long 0x00003000,0x00030300,0x00020200,0x02002220,0x00202002,0x00120002,0x01001110,0x00000000     ;  5  - Ofst:&A0
        .long 0x00330000,0x00232000,0x00002200,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000     ;  6  - Ofst:&C0
        .long 0x00033000,0x00032000,0x00002200,0x00002200,0x00002200,0x00021000,0x00011000,0x00000000     ;  7  - Ofst:&E0
        .long 0x00033000,0x00032000,0x00220000,0x00220000,0x00220000,0x00021000,0x00011000,0x00000000     ;  8  - Ofst:&100
        .long 0x00030000,0x30020030,0x02020200,0x00222000,0x00202000,0x02000200,0x10000010,0x00000000     ;  9  - Ofst:&120
        .long 0x00000000,0x00032000,0x00022000,0x02222220,0x00022000,0x00021000,0x00000000,0x00000000     ; 10  - Ofst:&140
        .long 0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00021000,0x00011000,0x00001100     ; 11  - Ofst:&160
        .long 0x00000000,0x00000000,0x00000000,0x02222220,0x01111110,0x00000000,0x00000000,0x00000000     ; 12  - Ofst:&180
        .long 0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00021000,0x00011000,0x00000000     ; 13  - Ofst:&1A0
        .long 0x03000000,0x00200000,0x00020000,0x00002000,0x00000200,0x00000010,0x00000001,0x00000000     ; 14  - Ofst:&1C0
        .long 0x00333330,0x03200023,0x02202022,0x02202022,0x01201021,0x01100011,0x00111110,0x00000000     ; 15  - Ofst:&1E0
        .long 0x00003000,0x00032000,0x00022000,0x00022000,0x00022000,0x00021000,0x00010000,0x00000000     ; 16  - Ofst:&200
        .long 0x00333300,0x03232320,0x02200000,0x00222200,0x00000220,0x02121210,0x00111100,0x00000000     ; 17  - Ofst:&220
        .long 0x00333300,0x03232320,0x02200000,0x00222000,0x02200000,0x02121210,0x00111100,0x00000000     ; 18  - Ofst:&240
        .long 0x00033000,0x00232300,0x00200220,0x00220022,0x00222220,0x00120000,0x00010000,0x00000000     ; 19  - Ofst:&260
        .long 0x00333300,0x03232320,0x00000220,0x00222220,0x02200000,0x02121210,0x01111100,0x00000000     ; 20  - Ofst:&280
        .long 0x00333300,0x03232320,0x00000220,0x00222220,0x02200220,0x02100210,0x00111100,0x00000000     ; 21  - Ofst:&2A0
        .long 0x00333300,0x03232320,0x02200000,0x00220000,0x00022000,0x00021000,0x00001000,0x00000000     ; 22  - Ofst:&2C0
        .long 0x00333300,0x03200320,0x02200220,0x00222200,0x02200220,0x02100210,0x00111100,0x00000000     ; 23  - Ofst:&2E0
        .long 0x00333300,0x03200320,0x02200220,0x02222200,0x02200000,0x02121210,0x00111100,0x00000000     ; 24  - Ofst:&300
        .long 0x00000000,0x00000000,0x00033000,0x00022000,0x00000000,0x00021000,0x00011000,0x00000000     ; 25  - Ofst:&320
        .long 0x00000000,0x00000000,0x00033000,0x00022000,0x00000000,0x00021000,0x00011000,0x00001100     ; 26  - Ofst:&340
        .long 0x00330000,0x00232000,0x00022200,0x00000220,0x00022200,0x00121000,0x00110000,0x00000000     ; 27  - Ofst:&360
        .long 0x00000000,0x00000000,0x03232320,0x00000000,0x00000000,0x02121210,0x00000000,0x00000000     ; 28  - Ofst:&380
        .long 0x00000330,0x00002320,0x00022200,0x00220000,0x00022200,0x00001210,0x00000110,0x00000000     ; 29  - Ofst:&3A0
        .long 0x00333300,0x03202320,0x02200000,0x00222000,0x00000000,0x00012000,0x00011000,0x00000000     ; 30  - Ofst:&3C0
        .long 0x00333330,0x03220023,0x02200202,0x02202202,0x01200022,0x00001212,0x00111110,0x00000000     ; 31  - Ofst:&3E0
        .long 0x00033000,0x00232300,0x02200220,0x02200220,0x02222220,0x02100210,0x00100100,0x00000000     ; 32  - Ofst:&400
        .long 0x00333300,0x03200320,0x02200220,0x00222220,0x02200220,0x02100210,0x00111100,0x00000000     ; 33  - Ofst:&420
        .long 0x00033300,0x00232320,0x00000022,0x00000022,0x00000022,0x00121210,0x00011100,0x00000000     ; 34  - Ofst:&440
        .long 0x00333300,0x00200320,0x02200220,0x02200220,0x02200220,0x00100210,0x00011100,0x00000000     ; 35  - Ofst:&460
        .long 0x00333300,0x03232320,0x00000220,0x00022220,0x00000220,0x02121210,0x00111100,0x00000000     ; 36  - Ofst:&480
        .long 0x00033300,0x00232320,0x00000220,0x00022220,0x00000220,0x00000210,0x00000100,0x00000000     ; 37  - Ofst:&4A0
        .long 0x00333300,0x03200320,0x00000022,0x00000022,0x00220022,0x02100210,0x00111100,0x00000000     ; 38  - Ofst:&4C0
        .long 0x00300300,0x03200320,0x02200220,0x02222220,0x02200220,0x02100210,0x00100100,0x00000000     ; 39  - Ofst:&4E0
        .long 0x00003000,0x00032000,0x00022000,0x00022000,0x00022000,0x00021000,0x00010000,0x00000000     ; 40  - Ofst:&500
        .long 0x00030000,0x00230000,0x00220000,0x00220000,0x00220020,0x00121212,0x00011110,0x00000000     ; 41  - Ofst:&520
        .long 0x00300300,0x03200320,0x00220220,0x00022220,0x00220220,0x02100210,0x00100100,0x00000000     ; 42  - Ofst:&540
        .long 0x00000300,0x00000320,0x00000220,0x00000220,0x00000220,0x02121210,0x01111100,0x00000000     ; 43  - Ofst:&560
        .long 0x00300030,0x03230323,0x02222222,0x02202022,0x02202022,0x02102012,0x00100010,0x00000000     ; 44  - Ofst:&580
        .long 0x00300030,0x03200323,0x02202222,0x02222022,0x02220022,0x02100012,0x00100010,0x00000000     ; 45  - Ofst:&5A0
        .long 0x00033300,0x00230320,0x02200022,0x02200022,0x02200022,0x00120210,0x00011100,0x00000000     ; 46  - Ofst:&5C0
        .long 0x00033300,0x00220320,0x00200220,0x00222220,0x00000220,0x00000210,0x00000100,0x00000000     ; 47  - Ofst:&5E0
        .long 0x00033300,0x00230320,0x02200022,0x02200022,0x02020022,0x00101110,0x01011100,0x00000000     ; 48  - Ofst:&600
        .long 0x00333300,0x03200320,0x02200220,0x00222220,0x00220220,0x02100210,0x01100100,0x00000000     ; 49  - Ofst:&620
        .long 0x00333300,0x03222320,0x00000220,0x00222200,0x02200000,0x02121210,0x00111100,0x00000000     ; 50  - Ofst:&640
        .long 0x00333300,0x03232320,0x00022000,0x00022000,0x00022000,0x00021000,0x00010000,0x00000000     ; 51  - Ofst:&660
        .long 0x00300300,0x03200320,0x02200220,0x02200220,0x02200220,0x02100210,0x00111100,0x00000000     ; 52  - Ofst:&680
        .long 0x00300300,0x03200320,0x02200220,0x02200220,0x02200220,0x00121200,0x00011000,0x00000000     ; 53  - Ofst:&6A0
        .long 0x00300030,0x03200023,0x02202022,0x02202022,0x02222222,0x01210121,0x00100010,0x00000000     ; 54  - Ofst:&6C0
        .long 0x03300033,0x00230320,0x00022200,0x00022200,0x00220220,0x02100012,0x00100010,0x00000000     ; 55  - Ofst:&6E0
        .long 0x00300300,0x03200320,0x02200220,0x00222200,0x00022000,0x00021000,0x00010000,0x00000000     ; 56  - Ofst:&700
        .long 0x00333330,0x00232323,0x00220000,0x00022000,0x00002200,0x02121210,0x00111110,0x00000000     ; 57  - Ofst:&720
        .long 0x00333000,0x00002300,0x00002200,0x00002200,0x00002200,0x00001200,0x00111000,0x00000000     ; 58  - Ofst:&740
        .long 0x00000003,0x00000020,0x00000200,0x00002000,0x00020000,0x00100000,0x01000000,0x00000000     ; 59  - Ofst:&760
        .long 0x00033300,0x00230000,0x00220000,0x00220000,0x00220000,0x00120000,0x00011100,0x00000000     ; 60  - Ofst:&780
        .long 0x00033000,0x00232300,0x02222220,0x00022000,0x00022000,0x00021000,0x00011000,0x00000000     ; 61  - Ofst:&7A0
        .long 0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x11111111,0x11111111     ; 62  - Ofst:&7C0
        .long 0x00003300,0x00032000,0x00220000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000     ; 63  - Ofst:&7E0
        ; .long 0x00000000,0x00000000,0x00022200,0x00220000,0x00222220,0x00120012,0x00011110,0x00000000     ; 64  - Ofst:&800
        ; .long 0x00000300,0x00000320,0x00332220,0x02200220,0x02200220,0x02100210,0x00111100,0x00000000     ; 65  - Ofst:&820
        ; .long 0x00000000,0x00000000,0x00333300,0x03200230,0x00000220,0x02100210,0x00111100,0x00000000     ; 66  - Ofst:&840
        ; .long 0x00030000,0x00230000,0x00223330,0x00220022,0x00220022,0x00120012,0x00011110,0x00000000     ; 67  - Ofst:&860
        ; .long 0x00000000,0x00000000,0x00333300,0x03200230,0x02222220,0x00000210,0x00111100,0x00000000     ; 68  - Ofst:&880
        ; .long 0x00333000,0x03202300,0x00002200,0x00022200,0x00002200,0x00001200,0x00001000,0x00000000     ; 69  - Ofst:&8A0
        ; .long 0x00000000,0x00000000,0x00333300,0x03200230,0x02200220,0x02121200,0x01100000,0x00111100     ; 70  - Ofst:&8C0
        ; .long 0x00000300,0x00000320,0x00330220,0x03203220,0x02200220,0x02100210,0x00100100,0x00000000     ; 71  - Ofst:&8E0
        ; .long 0x00033000,0x00000000,0x00022000,0x00022000,0x00022000,0x00021000,0x00010000,0x00000000     ; 72  - Ofst:&900
        ; .long 0x03300000,0x00000000,0x00300000,0x02200000,0x02200000,0x02100200,0x01100110,0x00111100     ; 73  - Ofst:&920
        ; .long 0x00000300,0x00000330,0x03300220,0x00220220,0x00022220,0x00120210,0x01100100,0x00000000     ; 74  - Ofst:&940
        ; .long 0x00003000,0x00032000,0x00022000,0x00022000,0x00022000,0x00021000,0x00010000,0x00000000     ; 75  - Ofst:&960
        ; .long 0x00000000,0x00000000,0x00330330,0x03223223,0x02202022,0x02101012,0x01100011,0x00000000     ; 76  - Ofst:&980
        ; .long 0x00000000,0x00000000,0x00333300,0x03200230,0x02200220,0x02100210,0x00100100,0x00000000     ; 77  - Ofst:&9A0
        ; .long 0x00000000,0x00000000,0x00333300,0x03200230,0x02200220,0x02100210,0x00111100,0x00000000     ; 78  - Ofst:&9C0
        ; .long 0x00000000,0x00000000,0x00333300,0x03200230,0x02200220,0x00121210,0x00000110,0x00000100     ; 79  - Ofst:&9E0
        ; .long 0x00000000,0x00000000,0x00033330,0x00320032,0x00220022,0x00121210,0x00110000,0x00010000     ; 80  - Ofst:&A00
        ; .long 0x00000000,0x00000000,0x00033300,0x00323230,0x00000220,0x00000210,0x00000100,0x00000000     ; 81  - Ofst:&A20
        ; .long 0x00000000,0x00000000,0x00333300,0x00000230,0x00222200,0x02100000,0x00111110,0x00000000     ; 82  - Ofst:&A40
        ; .long 0x00003000,0x00002300,0x00222200,0x00002200,0x00002200,0x02121200,0x00111000,0x00000000     ; 83  - Ofst:&A60
        ; .long 0x00000000,0x00000000,0x00300300,0x02200220,0x02200220,0x02100210,0x00111100,0x00000000     ; 84  - Ofst:&A80
        ; .long 0x00000000,0x00000000,0x00300300,0x02200220,0x02200220,0x00121200,0x00011000,0x00000000     ; 85  - Ofst:&AA0
        ; .long 0x00000000,0x00000000,0x00300030,0x03203023,0x02202022,0x02121212,0x00110110,0x00000000     ; 86  - Ofst:&AC0
        ; .long 0x00000000,0x00000000,0x03300033,0x00230320,0x00022200,0x00120210,0x01100011,0x00000000     ; 87  - Ofst:&AE0
        ; .long 0x00000000,0x00000000,0x00300300,0x02200220,0x02200220,0x02121200,0x01100000,0x00111110     ; 88  - Ofst:&B00
        ; .long 0x00000000,0x00000000,0x03333330,0x00320000,0x00022000,0x00001200,0x01111110,0x00000000     ; 89  - Ofst:&B20
        ; .long 0x00030000,0x00020000,0x00020000,0x00010000,0x03303030,0x30202020,0x12202020,0x00101110     ; 90  - Ofst:&B40
        ; .long 0x00033000,0x00200000,0x00020000,0x00111000,0x03303030,0x30202020,0x12202020,0x00101110     ; 91  - Ofst:&B60
        ; .long 0x00000000,0x00000000,0x00000000,0x00000000,0x01333210,0x03322220,0x21111112,0x22222222     ; 92  - Ofst:&B80
        ; .long 0x00033000,0x00322200,0x00022000,0x00011000,0x00022000,0x00022000,0x03222210,0x32222221     ; 93  - Ofst:&BA0
        ; .long 0x03000300,0x32303230,0x22232220,0x12222210,0x01222100,0x00121000,0x00010000,0x00000000     ; 94  - Ofst:&BC0
        ; .long 0x00333300,0x03222230,0x20120123,0x21121123,0x22222210,0x02020200,0x00202010,0x00111100     ; 95  - Ofst:&BE0
	.endif 