
NewLine:
	STMFD sp!,{lr}
	
		mov r2,#0		;X
		add r5,r5,#1	;Y
		
		cmp.b r5,#24
		bcs clsb
		LDMFD sp!,{pc}

cls:
	STMFD sp!,{lr}
clsb:
		mov r2,#0
		mov r5,#0
;                                     		ld hl,&2000
		mov r3,#0x20
		mov r6,#0
;                                     		ld bc,&2018
		mov r1,#0x20
		mov r4,#0x18
		bl fillarea
NewLine_Return:
	LDMFD sp!,{pc}
	mov pc,lr	
	
	
ReadJoystick:
	STMFD sp!,{r1-r10, lr}
		mov r9,#255
	
		mov r10,#0b11111110
		mov r1,#255^57		;Key 57=UP (255 xor key)	
		bl Key_TestOne
		
		mov r10,#0b11111101
		mov r1,#255^41		;Key 41=DOWN (255 xor key)	
		bl Key_TestOne
		
		mov r10,#0b11111011
		mov r1,#255^25		;Key 25=LEFT (255 xor key)	
		bl Key_TestOne
		
		mov r10,#0b11110111
		mov r1,#255^121		;Key 25=RIGHT (255 xor key)	
		bl Key_TestOne
		
		
		mov r10,#0b11101111
		mov r1,#255^98		;Key 98=SPACE (255 xor key)	
		bl Key_TestOne
		
		mov r10,#0b11011111
		mov r1,#255^73		;Key 73=ENTER (255 xor key)	
		bl Key_TestOne
		
		mov r0,r9
	LDMFD sp!,{r1-r10, pc}		
	
Key_TestOne:
	STMFD sp!,{r0-r8, lr}
		mov r0,#129			;Test a key
		mov r2,#255			;255=No Wait
		SWI 0x6				;OSByte
		cmp r1,#255			;255=Pressed 0=Unpressed
		andeq r9,r9,r10 
	LDMFD sp!,{r0-r8, pc}		


ScreenInit:
	STMFD sp!,{r0-r12, lr}  
		mov r0,#22			;VDU 22 - Selects screen mode 
		swi 0x00			;print char R0
		
		mov r0,#9			;Screen mode 9 = 320 × 256 @ 16 colors
							;Screen mode 13 = 320 × 256 @ 256 colors
		swi 0x00			;print char R0
	  	  
		SWI 0x36 			;Remove Cursor
	  
		adrl r0,GetVars		;Vars We want
		adrl r1,ReturnVars	;Area to store returned data
		swi 0x31			;OS_ReadVduVariables
			
		adr r10,InitPalette	;Source Palette
		mov r0,#0
InitPaletteAgain:
		ldr r1,[r10],#2
		bl SetPalette		;Palette Conversion
		add r0,r0,#1
		cmp r0,#16
		bne InitPaletteAgain
	LDMFD sp!,{r0-r12, pc}	

	
GetVars:
	.long 148	;ScreenStart
	.long 149	;DisplayStart
	.long 150	;TotalScreenSize
	.long -1	;List End

ReturnVars:
ScreenBase:	.long 0		;ScreenStart
			.long 0		;DisplayStart
			.long 0		;TotalScreenSize

	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SetPalette:		;R0= Palette Number R1= 0x-----GRB

	STMFD sp!,{r0-r12, lr}	
		mov r11,r0
		
		mov r0,#19	;VDU 19	-Set palette
;VDU 19,logical colour,mode,red,green,blue

		swi 0x00	;print char R0
		
		mov r0,r11	;palette number
		swi 0x00	;print char R0
		
		mov r0,#16	;NoFlash
		swi 0x00	;print char R0
		
		mov r2,r1			;Red
		and r2,r2,#0xF0 	;Nibble Mask
		mov r0,r2			;R (top 4 bit 00-F0)
		swi 0x00			;print char R0
		
		mov r2,r1,ROR #4	;Green
		and r2,r2,#0xF0 	;Nibble Mask
		mov r0,r2			;G (top 4 bit 00-F0)
		swi 0x00			;print char R0
		
		mov r2,r1,LSL #4	;Blue
		and r2,r2,#0xF0 	;Nibble Mask
		mov r0,r2			;B (top 4 bit 00-F0)
		swi 0x00			;print char R0
	LDMFD sp!,{r0-r12, pc}	
	

			
InitPalette:
    .word 0x0000 ;0  -GRB
    .word 0x0088 ;1  -GRB
    .word 0x0F0F ;2  -GRB
    .word 0x0FFF ;3  -GRB
    .word 0x0084 ;4  -GRB
    .word 0x0808 ;5  -GRB
    .word 0x088F ;6  -GRB
    .word 0x00F0 ;7  -GRB
    .word 0x0F04 ;8  -GRB
    .word 0x07FC ;9  -GRB
    .word 0x088F ;10  -GRB
    .word 0x000F ;11  -GRB
    .word 0x0800 ;12  -GRB
    .word 0x0EB6 ;13  -GRB
    .word 0x00F8 ;14  -GRB
    .word 0x0FFF ;15  -GRB

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
PrintNumber:
	add r0,r0,#48
	
PrintChar:
	STMFD sp!,{r0,r1,r3-r12, lr}
		and r2,r2,#255
		and r5,r5,#255
		
		cmp r0,#0
		beq PrintChar_Zero
		
		
		;mov r4,#0
		;mov r7,#0
		
		;mov r3,#CursorX
		;ldrB r4,[r3]			;X pos
		;mov r3,#CursorY
		;ldrB r7,[r3]			;Y pos
		
		adrl r1,ScreenBase
		ldr r3,[r1]			;Get Screen Base
		
		;mov r6,#4			;Xpos (4 bytes per Char)
		;mul r12,r2,r6
		add r3,r3,r2,asl #2
		
		mov r4,#160*8		;Ypos (160 bytes per line - 8 lines per char)
		mul r12,r5,r4
		add r3,r3,r12
		
		adrl r4,BitmapFont 	;Address of our font
		sub r0,r0,#32		;No chars <32 (first Char = space)
		add r4,r4,r0,asl #3 ;Char * 8 - offset to 
		
		mov r1,#8 ; 48 bytes per row = 12 words
NextFontLine:

		mov r9,#0b00000001
		ldrb r8,[r4]	;Load line of 1bpp font
		add r4,r4,#1
		
		mov r12,#0
		;We're going to move a bit into each nibble of r12
		
		and r10,r9,r8			;-------X
		orr r12,r12,r10
		
		and r10,r9,r8,ror #1	;------X-
		orr r12,r12,r10,ror #4*1
		
		and r10,r9,r8,ror #2	;-----X--
		orr r12,r12,r10,ror #4*2
		
		and r10,r9,r8,ror #3	;----X---
		orr r12,r12,r10,ror #4*3
		
		and r10,r9,r8,ror #4	;---X----
		orr r12,r12,r10,ror #4*4
		
		and r10,r9,r8,ror #5	;--X-----
		orr r12,r12,r10,ror #4*5
		
		and r10,r9,r8,ror #6	;-X------
		orr r12,r12,r10,ror #4*6
		
		and r10,r9,r8,ror #7	;X-------
		orr r12,r12,r10,ror #4*7
		
		mov r7,r12
		orr r7,r7,r12,asl #1		;Duplicate bit into all 4 bits of nibble
		orr r7,r7,r12,asl #2			;Color 1 -> Color 15
		orr r7,r7,r12,asl #3
		
		str r7,[r3]				;Store the complete font (in color 15)
		
		add r3,r3,#160;-8
		
		subs r1,r1,#1
		bne NextFontLine		;Repeat for next line
PrintChar_Zero:		
		add r2,r2,#1			;Move across screen
	LDMFD sp!,{r0,r1,r3-r12, pc}

BitmapFont:
        .byte 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00     ;  0
        .byte 0x10,0x18,0x18,0x18,0x18,0x00,0x18,0x00     ;  1
        .byte 0x28,0x6C,0x28,0x00,0x00,0x00,0x00,0x00     ;  2
        .byte 0x00,0x28,0x7C,0x28,0x7C,0x28,0x00,0x00     ;  3
        .byte 0x18,0x3E,0x48,0x3C,0x12,0x7C,0x18,0x00     ;  4
        .byte 0x02,0xC4,0xC8,0x10,0x20,0x46,0x86,0x00     ;  5
        .byte 0x10,0x28,0x28,0x72,0x94,0x8C,0x72,0x00     ;  6
        .byte 0x0C,0x1C,0x30,0x00,0x00,0x00,0x00,0x00     ;  7
        .byte 0x18,0x18,0x30,0x30,0x30,0x18,0x18,0x00     ;  8
        .byte 0x18,0x18,0x0C,0x0C,0x0C,0x18,0x18,0x00     ;  9
        .byte 0x08,0x49,0x2A,0x1C,0x14,0x22,0x41,0x00     ; 10
        .byte 0x00,0x18,0x18,0x7E,0x18,0x18,0x00,0x00     ; 11
        .byte 0x00,0x00,0x00,0x00,0x00,0x18,0x18,0x30     ; 12
        .byte 0x00,0x00,0x00,0x7E,0x7E,0x00,0x00,0x00     ; 13
        .byte 0x00,0x00,0x00,0x00,0x00,0x18,0x18,0x00     ; 14
        .byte 0x02,0x04,0x08,0x10,0x20,0x40,0x80,0x00     ; 15
        .byte 0x7C,0xC6,0xD6,0xD6,0xD6,0xC6,0x7C,0x00     ; 16
        .byte 0x10,0x18,0x18,0x18,0x18,0x18,0x08,0x00     ; 17
        .byte 0x3C,0x7E,0x06,0x3C,0x60,0x7E,0x3C,0x00     ; 18
        .byte 0x3C,0x7E,0x06,0x1C,0x06,0x7E,0x3C,0x00     ; 19
        .byte 0x18,0x3C,0x64,0xCC,0x7C,0x0C,0x08,0x00     ; 20
        .byte 0x3C,0x7E,0x60,0x7C,0x06,0x7E,0x3E,0x00     ; 21
        .byte 0x3C,0x7E,0x60,0x7C,0x66,0x66,0x3C,0x00     ; 22
        .byte 0x3C,0x7E,0x06,0x0C,0x18,0x18,0x10,0x00     ; 23
        .byte 0x3C,0x66,0x66,0x3C,0x66,0x66,0x3C,0x00     ; 24
        .byte 0x3C,0x66,0x66,0x3E,0x06,0x7E,0x3C,0x00     ; 25
        .byte 0x00,0x00,0x18,0x18,0x00,0x18,0x18,0x00     ; 26
        .byte 0x00,0x00,0x18,0x18,0x00,0x18,0x18,0x30     ; 27
        .byte 0x0C,0x1C,0x38,0x60,0x38,0x1C,0x0C,0x00     ; 28
        .byte 0x00,0x00,0x7E,0x00,0x00,0x7E,0x00,0x00     ; 29
        .byte 0x60,0x70,0x38,0x0C,0x38,0x70,0x60,0x00     ; 30
        .byte 0x3C,0x76,0x06,0x1C,0x00,0x18,0x18,0x00     ; 31
        .byte 0x7C,0xCE,0xA6,0xB6,0xC6,0xF0,0x7C,0x00     ; 32
        .byte 0x18,0x3C,0x66,0x66,0x7E,0x66,0x24,0x00     ; 33
        .byte 0x3C,0x66,0x66,0x7C,0x66,0x66,0x3C,0x00     ; 34
        .byte 0x38,0x7C,0xC0,0xC0,0xC0,0x7C,0x38,0x00     ; 35
        .byte 0x3C,0x64,0x66,0x66,0x66,0x64,0x38,0x00     ; 36
        .byte 0x3C,0x7E,0x60,0x78,0x60,0x7E,0x3C,0x00     ; 37
        .byte 0x38,0x7C,0x60,0x78,0x60,0x60,0x20,0x00     ; 38
        .byte 0x3C,0x66,0xC0,0xC0,0xCC,0x66,0x3C,0x00     ; 39
        .byte 0x24,0x66,0x66,0x7E,0x66,0x66,0x24,0x00     ; 40
        .byte 0x10,0x18,0x18,0x18,0x18,0x18,0x08,0x00     ; 41
        .byte 0x08,0x0C,0x0C,0x0C,0x4C,0xFC,0x78,0x00     ; 42
        .byte 0x24,0x66,0x6C,0x78,0x6C,0x66,0x24,0x00     ; 43
        .byte 0x20,0x60,0x60,0x60,0x60,0x7E,0x3E,0x00     ; 44
        .byte 0x44,0xEE,0xFE,0xD6,0xD6,0xD6,0x44,0x00     ; 45
        .byte 0x44,0xE6,0xF6,0xDE,0xCE,0xC6,0x44,0x00     ; 46
        .byte 0x38,0x6C,0xC6,0xC6,0xC6,0x6C,0x38,0x00     ; 47
        .byte 0x38,0x6C,0x64,0x7C,0x60,0x60,0x20,0x00     ; 48
        .byte 0x38,0x6C,0xC6,0xC6,0xCA,0x74,0x3A,0x00     ; 49
        .byte 0x3C,0x66,0x66,0x7C,0x6C,0x66,0x26,0x00     ; 50
        .byte 0x3C,0x7E,0x60,0x3C,0x06,0x7E,0x3C,0x00     ; 51
        .byte 0x3C,0x7E,0x18,0x18,0x18,0x18,0x08,0x00     ; 52
        .byte 0x24,0x66,0x66,0x66,0x66,0x66,0x3C,0x00     ; 53
        .byte 0x24,0x66,0x66,0x66,0x66,0x3C,0x18,0x00     ; 54
        .byte 0x44,0xC6,0xD6,0xD6,0xFE,0xEE,0x44,0x00     ; 55
        .byte 0xC6,0x6C,0x38,0x38,0x6C,0xC6,0x44,0x00     ; 56
        .byte 0x24,0x66,0x66,0x3C,0x18,0x18,0x08,0x00     ; 57
        .byte 0x7C,0xFC,0x0C,0x18,0x30,0x7E,0x7C,0x00     ; 58
        .byte 0x1C,0x30,0x30,0x30,0x30,0x30,0x1C,0x00     ; 59
        .byte 0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x00     ; 60
        .byte 0x38,0x0C,0x0C,0x0C,0x0C,0x0C,0x38,0x00     ; 61
        .byte 0x18,0x18,0x18,0x18,0x7E,0x7E,0x18,0x18     ; 62
        .byte 0x18,0x18,0x18,0x18,0x3C,0x3C,0x18,0x18     ; 63
        .byte 0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18     ; 64
        .byte 0x00,0x00,0x38,0x0C,0x7C,0xCC,0x78,0x00     ; 65
        .byte 0x20,0x60,0x7C,0x66,0x66,0x66,0x3C,0x00     ; 66
        .byte 0x00,0x00,0x3C,0x66,0x60,0x66,0x3C,0x00     ; 67
        .byte 0x08,0x0C,0x7C,0xCC,0xCC,0xCC,0x78,0x00     ; 68
        .byte 0x00,0x00,0x3C,0x66,0x7E,0x60,0x3C,0x00     ; 69
        .byte 0x1C,0x36,0x30,0x38,0x30,0x30,0x10,0x00     ; 70
        .byte 0x00,0x00,0x3C,0x66,0x66,0x3E,0x06,0x3C     ; 71
        .byte 0x20,0x60,0x6C,0x76,0x66,0x66,0x24,0x00     ; 72
        .byte 0x18,0x00,0x18,0x18,0x18,0x18,0x08,0x00     ; 73
        .byte 0x06,0x00,0x04,0x06,0x06,0x26,0x66,0x3C     ; 74
        .byte 0x20,0x60,0x66,0x6C,0x78,0x6C,0x26,0x00     ; 75
        .byte 0x10,0x18,0x18,0x18,0x18,0x18,0x08,0x00     ; 76
        .byte 0x00,0x00,0x6C,0xFE,0xD6,0xD6,0xC6,0x00     ; 77
        .byte 0x00,0x00,0x3C,0x66,0x66,0x66,0x24,0x00     ; 78
        .byte 0x00,0x00,0x3C,0x66,0x66,0x66,0x3C,0x00     ; 79
        .byte 0x00,0x00,0x3C,0x66,0x66,0x7C,0x60,0x20     ; 80
        .byte 0x00,0x00,0x78,0xCC,0xCC,0x7C,0x0C,0x08     ; 81
        .byte 0x00,0x00,0x38,0x7C,0x60,0x60,0x20,0x00     ; 82
        .byte 0x00,0x00,0x3C,0x60,0x3C,0x06,0x7C,0x00     ; 83
        .byte 0x10,0x30,0x3C,0x30,0x30,0x3E,0x1C,0x00     ; 84
        .byte 0x00,0x00,0x24,0x66,0x66,0x66,0x3C,0x00     ; 85
        .byte 0x00,0x00,0x24,0x66,0x66,0x3C,0x18,0x00     ; 86
        .byte 0x00,0x00,0x44,0xD6,0xD6,0xFE,0x6C,0x00     ; 87
        .byte 0x00,0x00,0xC6,0x6C,0x38,0x6C,0xC6,0x00     ; 88
        .byte 0x00,0x00,0x24,0x66,0x66,0x3E,0x06,0x7C     ; 89
        .byte 0x00,0x00,0x7E,0x0C,0x18,0x30,0x7E,0x00     ; 90
        .byte 0x08,0x08,0x08,0x08,0x56,0x55,0x57,0x74     ; 91
        .byte 0x18,0x04,0x08,0x1C,0x56,0x55,0x57,0x74     ; 92
        .byte 0x00,0x00,0x00,0x00,0x7E,0x7E,0xFF,0xFF     ; 93
        .byte 0x18,0x3C,0x18,0x18,0x18,0x18,0x7E,0xFF     ; 94
        .byte 0x22,0x77,0x7F,0x7F,0x3E,0x1C,0x08,0x00     ; 95
