;.equ ROS_256color,1 - Support 256 color mode: NOTE, colors are not as configurable as we may want, 
; as only 64 colors can be set, each have 4 possible 'tints'

	.org  0x08000 			;Program Start
    
	b RiscOS_Start
	
	.align 4
	.space 256-16			;Space for the stack
Stack:
	
							;Ram Area
ramarea:
	.space 65536*2			;128k ram

adrAdrScreenBase: .long AdrScreenBase	
adrGetVars: .long GetVars
RiscOS_Start:
	adrl sp,stack			;Load the stack pointer 
			
	mov r0,#22			;VDU 22 - Selects screen mode 
	swi 0x00			;print char R0
	
	.ifdef ROS_256Color
		mov r0,#13			;Screen mode 13 = 320 × 256 @ 256 colors
	.else
		mov r0,#9			;Screen mode 9 = 320 × 256 @ 16 colors
	.endif
	
						
	swi 0x00			;print char R0
	  
	SWI 0x36 			;Remove Cursor
  
	adrl r0,adrGetVars		;Vars We want
	ldr r0,[r0]
	adrl r1,adrAdrScreenBase	;Area to store returned data
	
	ldr r1,[r1]
	swi 0x31			;OS_ReadVduVariables
		
	.ifndef ROS_256Color
		adr r10,InitPalette	;Source Palette
		mov r0,#0
InitPaletteAgain:
		ldr r1,[r10],#2
		bl SetPalette		;Palette Conversion
		add r0,r0,#1
		cmp r0,#16
		bne InitPaletteAgain
	.endif
	
	bl ClearRam					;Clear Screen