;R0	 A        D0
;R1	 B        D1
;R2  D        D2
;R3  H        D3
;R4	 C  BC A1 D4
;R5	 E  DE A2 D5
;R6  L  HL A3 D6
;R7     IX A5
;R8     IY A6
;R9		      D7
;R10	   A0 
;R11
;R12


	

	
WaitForFire:				;Pause for a fire press
	STMFD sp!,{lr}
	bl WaitForRelease		;Wait for fire to be released
WaitForFire2:
	bl DoRandom				;Re-seed the random generator
	bl ReadJoystick			;Read from the joystick
		    ; SSBARLDU
	tst r0,#0b00010000		;Test Fire
	bne WaitForFire2		;Not Preseed? Then repeat
	LDMFD sp!,{pc}

	
WaitForRelease:	
	STMFD sp!,{lr}
WaitForReleaseB:	
		bl ReadJoystick
				;  SSBARLDU
		cmpb r0,#0b11111111
		bne WaitForReleaseB	;Repeat until fire released
	LDMFD sp!,{pc}
	
	
	
joyaxis:		;r0=val r4=joypresses
	mov r1,r0			;Backup Val
	
	tst r4,#0b00000001	;up or left
	bne notupleft
		sub r0,r0,#1	;-1
notupleft:

	tst r4,#0b00000010	;down or right
	bne notdownright
		add r0,r0,#1	;+1
notdownright:

	mov r4,r4,lsr #2	;skip 2 direction bits
	mov pc,lr
	
	
SlowDown:	
Pause50:
	mov r0,#50				;Wait for 50
	
PauseA:						;Wait for R0
	.ifdef BuildROS
		mov r0,r0,lsl #17
	.endif
	.ifdef BuildGBA
		mov r0,r0,lsl #10
	.endif
	.ifdef BuildNDS
		mov r0,r0,lsl #16
	.endif
	
PauseAAgain:
	.ifdef BuildROS
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
	.endif
	.ifdef BuildNDS
		nop
		nop
	.endif
	subs r0,r0,#1
	bne PauseAAgain
	
	mov pc,lr
	
	
	

ShowDecimal:	
	STMFD sp!,{r1,r3-r4,r6-r10, lr}
		mov r6,#100
		bl DivideAbyH			;Digit 1 (100s)
		
		mov r6,#10
		mov r0,r1
		bl DivideAbyH			;Digit 2 ;010s)
		
		mov r0,r1	
		bl PrintNumber			;Digit 3 ;001s)
	LDMFD sp!,{r1,r3-r4,r6-r10, pc}	
	
	
	
DivideAbyH:		;Divide R0 (A) by R6 (H)
	STMFD sp!,{r3-r4,r6-r10, lr}
		mov r4,#0			;C=Count
	
DivideBbyHagain:
		cmpb r6,r0
		bcs DivideBbyH_LessThan	;Still R6>=R0
	
		add r4,r4,#1		;Yes! Count+1
		sub r0,r0,r6		;-R6
		b DivideBbyHagain
	
DivideBbyH_LessThan:
		mov r1,r0			;Remainder
		mov r0,r4			;Count
	
		bl PrintNumber		;Print R0 as a digit
	LDMFD sp!,{r3-r4,r6-r10, pc}	
	
	
RangeTest: ;ensure R0 (A) is between R2 (D) and R5 (E) (>=D <E)
	STMFD sp!,{r0-r10, lr}
		and r0,r0,#255
		and r2,r2,#255
		and r5,r5,#255
		
		cmp	r0,r2
		blt RangeTest_OutOfRange		;Below R1
		cmp	r0,r5
		bge RangeTest_OutOfRange		;Above R4

		mov r0,#1
		cmp r0,#2			;Carry Clear (In Range)
	LDMFD sp!,{r0-r10, pc}	
		
RangeTest_OutOfRange:
		mov r0,#1
		cmp r0,#0			;Carry Set (Our of range)
	LDMFD sp!,{r0-r10, pc}	
	
	
	
rangelimit:		;reset R0=R1 if over range R2-R5
	STMFD sp!,{r1-r10, lr}
		bl rangetest			;Set carry if out of range
		bcc lbl60376
			and r1,r1,#255
			mov r0,r1			;Reset R0
lbl60376:
	LDMFD sp!,{r1-r10, pc}	
		
	
	
	
PrintString:
	STMFD sp!,{r0,r1,r3-r12, lr}
PrintStringAgain:
		ldrB r0,[r1],#1
		cmps r0,#255
		beq PrintStringDone
		bl printchar 
		b PrintStringAgain
PrintStringDone:
	LDMFD sp!,{r0,r1,r3-r12, pc}
	
	
; dorangedrandom:		;return a value in R0 between R1 and R4
	; STMFD sp!,{lr}
; dorangedrandomB:			
		; bl dorandom
		; cmp	r0,r1
		; blt dorangedrandomB		;Below R1
		; cmp	r0,r4
		; bgt dorangedrandomB		;Above R4
	; LDMFD sp!,{pc}
	
	



.equ RandomSeed,ramarea	;2 Byte seed

DoRandom:				;Return a random byte in R0
	STMFD sp!,{r1-r10, lr}
		mov r10,#RandomSeed	
		mov r1,#0
		mov r2,#0
		mov r3,#0
		
		ldrb r1,[r10,#0]	;Work in bytes because LRDH doesn't exist
		ldrb r2,[r10,#1]	;  on some RISC os
		
		movb r3,r1
		orr r3,r3,r2,lsl #8
		
		add r3,r3,#1		;INC Seed
		
		movb r1,r3
		movb r2,r3,lsr #8
				
		strb r1,[r10,#0]
		strb r2,[r10,#1]
		
		eor r0,r1,r2		;EOR two seeds together
				
		eor r0,r0,r4
		eor r0,r0,r5
		eor r0,r0,r6
		eor r0,r0,r7
		eor r0,r0,r8
		eor r0,r0,r9
				
		eor r0,r0,r4,lsr #8
		eor r0,r0,r5,lsr #8
		eor r0,r0,r6,lsr #8
		eor r0,r0,r7,lsr #8
		eor r0,r0,r8,lsr #8
		eor r0,r0,r9,lsr #8
		
		and r0,r0,#255		;Limit to 1 byte
	LDMFD sp!,{r1-r10, pc}	


	
RangedRandom: 		;Return a value between R2 and R5 (>=R2 <R5)
	STMFD sp!,{r1-r10, lr}
RangedRandom_again: 
		bl DoRandom
		bl RangeTest
		bcs RangedRandom_again	;Out of range
		
RangedRandomDone: 
	LDMFD sp!,{r1-r10, pc}	
	
	
ClearRam:
	mov r0,#0
	mov r1,#512			;Clear 512 bytes
	mov r2,#ramarea
ClearRamb:	
	strb r0,[r2],#1
	subs r1,r1,#1
	bne ClearRamb
	b cls				;Clear screen
	
	
DoLdir:		;Copy R1 bytes from [R3] to [R2] ascending
	ldrb r0,[r3],#1	
	strb r0,[r2],#1	
	subs r1,r1,#1
	bne DoLdir
	mov pc,lr

	
DoLddr:		;Copy R1 bytes from [R3] to [R2] descending
	ldrb r0,[r3],#-1
	strb r0,[r2],#-1
	subs r1,r1,#1
	bne DoLddr
	mov pc,lr
	

	
printseqNC:
	mov r5,r4			;restore ypos
	add r2,r2,#1		;inc xpos
	b printseq

printseqNL:
	mov r2,r1			;restore xpos
	add r5,r5,#1		;inc ypos

;print seq r3 (hl) at location r2,r5 (de)
printseq:				
	and r2,r2,#255
	and r5,r5,#255
	mov r1,r2
	mov r4,r5

;&00     = empty (nothing drawn)
printseqb:
	ldrB r0,[r3],#1			;get a char
	cmp r0,#0
	beq doprintchar			;0=empty char
	cmp r0,#32
	bcc xposchange			;&01-&1f = new absolute xpos (use nl for xpos=0)
	cmp r0,#0xe0
	bcs yposchange			;&e0-&f8 = new absolute ypos

	cmp r0,#0xa0
	bcs sequenceh			;&a0-&bf = horizontal sequence of one char
doprintchar:
	STMFD sp!,{lr}
		bl printchar		;&20-&9f = character
	LDMFD sp!,{lr}	
	b printseqb

	
sequenceH:
	STMFD sp!,{r1,r4}
		cmp r0,#0xc0
		bcs sequencev		;&c0-&df = vertical sequence of one char
		and r0,r0,#0x1f
		add r1,r0,#1		
		ldrB r0,[r3],#1		;get a char

sequenceh2:
		STMFD sp!,{lr}
			bl printchar
		LDMFD sp!,{lr}	
		subs r1,r1,#1
		bne sequenceh2

printseq_poprep:
	LDMFD sp!,{r1,r4}
	b printseqb

sequenceV:
	and r0,r0,#0x1f
	add r1,r0,#1
	ldrB r0,[r3],#1			;get a char

sequencev2:
	STMFD sp!,{r2,r5,lr}
		bl printchar
	LDMFD sp!,{r2,r5,lr}
	add r5,r5,#1			;Down one Char
	subs r1,r1,#1
	bne sequencev2
	b printseq_poprep

	
xposchange:
	mov r2,r0 			;NewXpos
	b printseq

yposchange:
	cmp r0,#251
	beq printseqfill	;&fb	 = fill area (w,h,char,inc)
	cmp r0,#252
	beq printseqnc		;&fc 	 = new column (vertical)
	cmp r0,#253
	beq printseqcrnl	;&fd     = new line (true)
	cmp r0,#254
	beq printseqnl		;&fe     = new line (horizontal)
	cmp r0,#255			;&ff     = end of list
	bne lbl22306		;yes? then return
	mov pc,lr
	
lbl22306:
	mov r2,r1
	and r0,r0,#0x1f		;new ypos
	mov r5,r0
	b printseqb
	
	
printseqfill:
	STMFD sp!,{r1,r4}
		ldrb r1,[r3],#1		;Width
		ldrb r4,[r3],#1		;Height
		ldrb r0,[r3],#1		;Char
		STMFD sp!,{r3,r6,lr}
			ldrb r6,[r3],#1	;CharInc
			mov r3,r0
			bl fillarea
		ldMFD sp!,{r3,r6,lr}
		add r3,r3,#1
	b printseq_poprep

	
printseqcrNL:
	STMFD sp!,{lr}
			bl newline 		;zero x, move down a line
	LDMFD sp!,{lr}	
	b printseq
	
	
;R3/H=Char R6/L=Char increment R2,R5/DE=X,Ypos R1,R4/BC=Wid,Hei	
FillArea:
	STMFD sp!,{r2,r5,lr}
	
FillAreaY:
		STMFD sp!,{r1,r2,r4,r5}
FillAreaX:
			mov r0,r3			;Get Char to print
			bl PrintChar
			add r0,r0,r6		;Inc Char
			mov r3,r0
			sub r1,r1,#1
			cmpb r1,#0
			bne FillAreaX		;Xloop
		LDMFD sp!,{r1,r2,r4,r5}
		add r5,r5,#1			;Down one line
		sub r4,r4,#1
		cmpb r4,#0
		bne FillAreaY			;Yloop
	LDMFD sp!,{r2,r5,pc}
	mov pc,lr
	

	
ChibiSoundBeep:	
	bl ChibiSound
	bl Pause50
	mov r0,#0
	b ChibiSound
	
	