
	.include "\SrcALL\V1_Header.asm"
	bl ScreenInit

	ldr r1,TestVal
	
	bl MonitorR0R1			
	bl NewLine
	
	bl ShowBCD				;Show BCD in R1
	
	bl NewLine
	bl NewLine
	
	mov r2,#0x00001199		;1199 in BCD
	
	bl AddBCD
	bl MonitorR0R1
	
	mov r2,#0x00001199		;1199 in BCD
	bl SUBBCD
	bl MonitorR0R1
	
	b infloop
	
TestVal:
	.long 0x12345678
		
	
	;BCD   Show R1
ShowBCD:			
	STMFD sp!,{r0-r4, lr}		
		mov r4,#8				;Char count
ShowBCDb:	
		and r0,r1,#0xF0000000	;Get a char
		mov r1,r1,lsl #4		;Remove it from R1
		
		mov r0,r0,lsr #28		;Shift char to -------X
		add r0,r0,#48			;Convrt to ascii +'0'
		bl PrintChar
	
		subs r4,r4,#1			
		bne ShowBCDb			;Repeat
		
	LDMFD sp!,{r0-r4, pc}		
	
	;BCD   R1=R1+R2	
AddBCD:
	STMFD sp!,{r2-r12, lr}		
		mov r0,#0				;Buildup
		mov r6,#0				;Carry
		mov r8,#0				;Rotation
		mov r7,#8				;Char count
		
AddBCDb:	
		and r3,r1,#0x0000000F	;Get A nibble of BCD1
		and r4,r2,#0x0000000F	;Get A nibble of BCD2
		
		add r3,r3,r4			;BCD1=BCD1+BCD2
		add r3,r3,r6			;Carry
		
		cmp r3,#10				;Any Overflow?
		blt AddBCD_NoOverFlow
		add r3,r3,#6			;Correct overflow
AddBCD_NoOverFlow:		

		and r5,r3,#0x00000000F
		orr r0,r0,r5,lsl r8		;OR this digit into result
		
		and r6,r3,#0x0000000F0	;Get the carry
		mov r6,r6,lsr #4		;Shift Carry
		
		mov r1,r1,lsr #4		;Remove nibble of BCD1
		mov r2,r2,lsr #4		;Remove nibble of BCD2
		
		add r8,r8,#4			;Increase Destination nibble
		
		subs r7,r7,#1
		bne AddBCDb				;Repeat
		
		mov r1,r0				;Final Value
	LDMFD sp!,{r2-r12, pc}	
	


	
	
	;BCD   R1=R1-R2
SubBCD:
	STMFD sp!,{r2-r12, lr}	
		mov r0,#0				;Buildup
		mov r6,#0				;Carry
		mov r8,#0				;Rotation
		mov r7,#8				;Char count
		
SubBCDb:	
		and r3,r1,#0x0000000F	;Get A nibble of BCD1
		and r4,r2,#0x0000000F	;Get A nibble of BCD2
		
		sub r3,r3,r4			;BCD1=BCD1+BCD2
		sub r3,r3,r6			;Carry
		
		mov r6,#0				;Zero Carry
		
		cmp r3,#0
		bgt SubBCD_NoOverFlow
		sub r3,r3,#6			;Correct overflow
		and r3,r3,#0x00000000F	
		mov r6,#1				;Set Carry
SubBCD_NoOverFlow:		
		
		orr r0,r0,r3,lsl r8		;OR this digit into result
		
		mov r1,r1,lsr #4		;Remove nibble of BCD1
		mov r2,r2,lsr #4		;Remove nibble of BCD2
		
		add r8,r8,#4			;Increase Destination nibble
		
		subs r7,r7,#1
		bne SubBCDb				;Repeat
		
		mov r1,r0				;Final Value
	LDMFD sp!,{r2-r12, pc}		
	
	
infloop:
	b infloop

.align 4				;We need to make sure we're aligned to a 32 bit boundsry
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ShowTestRam:
	STMFD sp!,{r0-r12, lr}			;Push Regs
		adr	r0,testval		;Address
		mov r1,#1			;Lines
		bl MemDump
	LDMFD SP!,{R0-R12, PC}			;Pop Regs and return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

ShowUserRam:
	STMFD sp!,{r0-r12, lr}			;Push Regs
		mov	r0,#userram
		mov r1,#1			;Lines
		bl MemDump
	LDMFD sp!,{r0-r12, pc}			;Pop Regs and return

		
MonitorR0R1:
	STMFD sp!,{r0-r12, lr}			;Push Regs
		bl MonitorR0
		bl MonitorR1
		.ifdef BuildROS
			bl MonitorR2
		.endif
		bl newline	
	LDMFD sp!,{r0-r12, pc}			;Pop Regs and return
	
MonitorR2:	
	STMFD sp!,{r0-r12, lr}			;Push Regs
		mov r1,#48+2				;Number 2
		b MonitorRn
	LDMFD sp!,{r0-r12, pc}			;Pop Regs and return
	
	
MonitorR1:	
	STMFD sp!,{r0-r12, lr}			;Push Regs
		mov r2,r1
		mov r1,#48+1				;Number 1
		b MonitorRn
	LDMFD sp!,{r0-r12, pc}			;Pop Regs and return
	
	
MonitorR0:
	STMFD sp!,{r0-r12, lr}			;Push Regs
		mov r2,r0
		mov r1,#48+0				;Number 0
MonitorRn:	
		mov r0,#82					;Letter R
		bl PrintChar
		mov r0,r1 					;reg number
		bl PrintChar
		mov r0,#58 					;Ascii :
		bl PrintChar
		
		mov r0,r2
		bl ShowHex32	
		mov r0,#32 					;Ascii Space
		bl PrintChar
	LDMFD sp!,{r0-r12, pc}			;Pop Regs and return
	
	.include "/srcALL/V1_Monitor.asm"
	.include "/srcALL/V1_BitmapMemory.asm"

BitmapFont:
	.incbin "\ResALL\Font96.FNT"
SpriteTest:
	.ifdef BuildROS
		.incbin "\ResALL\SpriteROS.RAW"
	.endif
	.ifdef BuildGBA
		.incbin "\ResALL\SpriteGBA.RAW"
	.endif

	
	.include "/srcALL/V1_Footer.asm"
	