;Text after semicolon is comments, you don't need to type it in

	.org  0x08000000   			;GBA Rom Base
;Header
	b	ProgramStart			;Jump to our program
	.space 178					;Logo (omitted) + Program name
	.byte 0x96					;Fixed value
	.space 49					;Dummy Header 
	
ProgramStart:
	adr r0,ThumbTest			;Address of thumb code
	add r0,r0,#1				;Bit 0 set = THUMB ON!
	bx r0						;Branch and exchange

	.thumb						;We are now in thumb mode
ThumbTest:
	ldr r1,SPAddress			;Init Stack Pointer SP=0x03000000
	mov sp,r1
	
	ldr r4,ScreenRegs  			;0x04000000 DISPCNT -LCD Control
	ldr r2,ScreenSetting   		;0x403 4= Layer 2 on / 3= ScreenMode 3
	str	r2,[r4,#0]         	

	ldr r3,ScreenRam 			;0x06000000 - VRAM Dest
	ldr r4,SpriteAddress 		;Sprite Source Address

	ldr r0,LineSize2			;480-16
	mov r8,r0					;Amount to add per Y-line
	
	mov r6,#8					;8 Y-lines 
Sprite_NextLine:
	mov r7,#8 					;8 pixels per X-line
Sprite_NextByte:
	ldrh r2,[r4,#0]				;Load Pixel 
	strh r2,[r3,#0]				;Yes? then fill pixel

	add r4,r4,#2				;Move to next Src pixel
	add r3,r3,#2				;Move to next VRAM pixel
	sub r7,r7,#1
	bne Sprite_NextByte			;Next Hpixel
		
	add r3,r8 					;Move Down a line (240 pixels *2 bytes) 
	sub r6,r6,#1								;-1 char (16 px)
	bne Sprite_NextLine			;Next Vline
		
InfLoop:
      b InfLoop					;Halt
	  
	.align 4
SPAddress:
	.long 0x03000000			;Stack pointer address
ScreenRegs:
	.long 0x04000000			;Video Register base
ScreenSetting:
	.long 0x403					;4= Layer 2 on / 3= ScreenMode 3
ScreenRam:
	.long 0x06000000			;Vram Base
LineSize2:
	.long 480-16				;pixel width of one line - 1 char
SpriteAddress:
	.long SpriteTest			;Address of Sprite
	
SpriteTest:		;Smiley ABBBBBGGGGGRRRRR - A=Alpha B=Blue G=Green R=Red
	.word 0x8000,0x8000,0x83FF,0x83FF,0x83FF,0x83FF,0x8000,0x8000 ;  0
	.word 0x8000,0x83FF,0x83FF,0x83FF,0x83FF,0x83FF,0x83FF,0x8000 ;  1
	.word 0x83FF,0x83FF,0x801F,0x83FF,0x83FF,0x801F,0x83FF,0x83FF ;  2
	.word 0x83FF,0x83FF,0x83FF,0x83FF,0x83FF,0x83FF,0x83FF,0x83FF ;  3
	.word 0x83FF,0x83FF,0x83FF,0x83FF,0x83FF,0x83FF,0x83FF,0x83FF ;  4
	.word 0x83FF,0x83FF,0xFFE0,0x83FF,0x83FF,0xFFE0,0x83FF,0x83FF ;  5
	.word 0x8000,0x83FF,0x83FF,0xFFE0,0xFFE0,0x83FF,0x83FF,0x8000 ;  6
	.word 0x8000,0x8000,0x83FF,0x83FF,0x83FF,0x83FF,0x8000,0x8000 ;  7

	
	