


	.org 0x02000000-0x8000	;&200 byte header - code starts at offset &8000
HeaderStart:
		;  123456789012
	.ascii "LEARNASM.NET";000h    12    Game Title  (Uppercase ASCII, padded with 00h)
	.ascii "0000"		;00Ch    4     Gamecode    (Uppercase ASCII, NTR-<code>)        (0=homebrew)
	.ascii "00"			;010h    2     Makercode   (Uppercase ASCII, eg. "01"=Nintendo) (0=homebrew)
	.byte 0				;012h    1     Unitcode    (00h=NDS, 02h=NDS+DSi, 03h=DSi) (bit1=DSi)
	.byte 0				;013h    1     Encryption Seed Select (00..07h, usually 00h)
	.byte 0				;014h    1     Devicecapacity         (Chipsize = 128KB SHL nn) (eg. 7 = 16MB)
	.space 7			;015h    7     Reserved    (zero filled)	
	.byte 0				;01Ch    1     Reserved    (zero)                      (except, used on DSi)
	.byte 0				;01Dh    1     NDS Region  (00h=Normal, 80h=China, 40h=Korea) (other on DSi)
	.byte 0				;01Eh    1     ROM Version (usually 00h)
	.byte 4     		;01Fh    1     Autostart (Bit2: Skip "Press Button" after Health and Safety)
	.long Arm9_Start-HeaderStart;  020h    4     ARM9 rom_offset    (4000h and up, align 1000h)
	.long 0x02000000	;024h    4     ARM9 entry_address (2000000h..23BFE00h)
	.long 0x02000000	;028h    4     ARM9 ram_address   (2000000h..23BFE00h)
	.long Arm9_End-Arm9_Start;02Ch    4     ARM9 size          (max 3BFE00h) (3839.5KB)
	.long Arm7_Start-HeaderStart;030h    4     ARM7 rom_offset    (8000h and up)
	.long 0x03800000	;034h    4     ARM7 entry_address (2000000h..23BFE00h, or 37F8000h..3807E00h)
	.long 0x03800000	;038h    4     ARM7 ram_address   (2000000h..23BFE00h, or 37F8000h..3807E00h)
	.long Arm7_End-Arm7_Start;03Ch    4     ARM7 size          (max 3BFE00h, or FE00h) (3839.5KB, 63.5KB)
	.long 0				;040h    4     File Name Table (FNT) offset
	.long 0				;044h    4     File Name Table (FNT) size
	.long 0				;048h    4     File Allocation Table (FAT) offset
	.long 0				;04Ch    4     File Allocation Table (FAT) size
	.long 0				;050h    4     File ARM9 overlay_offset
	.long 0				;054h    4     File ARM9 overlay_size
	.long 0				;058h    4     File ARM7 overlay_offset
	.long 0				;05Ch    4     File ARM7 overlay_size
	.long 0x00586000	;060h    4     Port 40001A4h setting for normal commands (usually 00586000h)
	.long 0x001808F8	;064h    4     Port 40001A4h setting for KEY1 commands   (usually 001808F8h)
	.long 0				;068h    4     Icon/Title offset (0=None) (8000h and up)
	.word 0				;06Ch    2     Secure Area Checksum, CRC-16 of [[020h]..00007FFFh]
	.word 0				;06Eh    2     Secure Area Delay (in 131kHz units) (051Eh=10ms or 0D7Eh=26ms)
	.long 0				;070h    4     ARM9 Auto Load List Hook RAM Address (?) ;\endaddr of auto-load
	.long 0				;074h    4     ARM7 Auto Load List Hook RAM Address (?) ;/functions
	.space 8			;078h    8     Secure Area Disable (by encrypted "NmMdOnly") (usually zero)
	.long 0				;080h    4     Total Used ROM size (remaining/unused bytes usually FFh-padded)
	.long 0x4000		;084h    4     ROM Header Size (4000h)
	.space 0x28			;088h    28h   Reserved (zero filled; except, [88h..93h] used on DSi)
	.space 0x10			;0B0h    10h   Reserved (zero filled; or "DoNotZeroFillMem"=unlaunch fastboot)
;0C0h    9Ch   Nintendo Logo (compressed bitmap, same as in GBA Headers)
	.space 0x9C
	.word 0				;15Ch    2     Nintendo Logo Checksum, CRC-16 of [0C0h-15Bh], fixed CF56h
	.word 0			    ;15Eh    2     Header Checksum, CRC-16 of [000h-15Dh]
	.long 0				;160h    4     Debug rom_offset   (0=none) (8000h and up)       ;only if debug
	.long 0				;164h    4     Debug size         (0=none) (max 3BFE00h)        ;version with
	.long 0				;168h    4     Debug ram_address  (0=none) (2400000h..27BFE00h) ;SIO and 8MB
	.long 0				;16Ch    4     Reserved (zero filled) (transferred, and stored, but not used)
	.space 0x90			;170h    90h   Reserved (zero filled) (transferred, but not stored in RAM)
	.space 0x7E00-4		
	
Arm7_Start:
	b Arm7_Start		;Infloop for ARM 7
Arm7_End:


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 
Arm9_Start:
	mov sp,#0x03000000	;Set up our stack pointer
	
	mov r0, #0x4000000
	add r0, r0, #0x304	;4000304h - NDS9 - POWCNT1 - Graphics Power Control Register (R/W)
	
	mov r1, #0x8003		;2D + Enable
	str r1, [r0]
			
	mov r0, #0x04000000	;4000000h - DISPCNT - LCD Control (Read/Write)
	mov r1, #0x00020000
	str r1, [r0]		;2  Engine A only: VRAM Display (Bitmap from block selected in DISPCNT.18-19)
	
	mov r0, #0x04000000
	add r0, r0, #0x240
	mov r1, #0x80		;Enable
	strb r1, [r0]		;4000240h - NDS9 - VRAMCNT_A - 8bit - VRAM-A (128K) Bank Control (W)

	
	
	mov r8,#10					;Xpos
	mov r9,#10					;Ypos
	
	bl ShowSprite				;Show the sprite starting position
	
InfLoop:
	mov r3,#0x4000130			;Read GBA joypad
	ldrh r0,[r3]		
	            ;------lrDULRSsBA
	and r0,r0,#0b0000000011110000
	cmp r0,#0b0000000011110000
	beq InfLoop
	
	bl ShowSprite				;Remove the old sprite
	         ;------lrDULRSsBA
	tst r0,#0b0000000001000000
	bne JoyNotUp
	cmp.b r9,#0
	beq JoyNotUp
	sub.b r9,r9,#1				;Move Up
JoyNotUp:	
			 ;------lrDULRSsBA
	tst r0,#0b0000000010000000
	bne JoyNotDown
	cmp.b r9,#192-8
	beq JoyNotDown
	add.b r9,r9,#1				;Move Down
JoyNotDown:	
	         ;------lrDULRSsBA
	tst r0,#0b0000000000100000
	bne JoyNotLeft
	cmp.b r8,#0
	beq JoyNotLeft
	sub.b r8,r8,#1				;Move Left
JoyNotLeft:	
			 ;------lrDULRSsBA
	tst r0,#0b0000000000010000
	bne JoyNotRight
	cmp.b r8,#256-8
	beq JoyNotRight
	add.b r8,r8,#1				;Move Right
JoyNotRight:	

	bl ShowSprite				;Show the new sprite position

	mov r0,#0x10000				;Delay Loop
Delay:	
	subs r0,r0,#1
	bne Delay
	b InfLoop					;Repeat.
	
	
;Xor Sprite, drawing twice will remove sprite from screen.
ShowSprite:
	mov r10,#0x06800000 		;VRAM base
	
	mov r1,#2					;2 bytes per pixel
	mul r2,r1,r8
	add r10,r10,r2				;Xpos *2
	
	mov r1,#256*2				;240 pixels per line, 2 bytes per pixel
	mul r2,r1,r9
	add r10,r10,r2				;Ypos * 240*2
	
	ldr r1,SpriteAddress		;Sprite Address
	mov r6,#8					;Height
Sprite_NextLine:	
	mov r5,#8					;Width (in words / pixels)

	STMFD sp!,{r10}
Sprite_NextByte:
		ldrH r3,[r1],#2			;Must write 16/32bit per VRAM write 
		ldrH r2,[r10]
		eor r3,r3,r2			;Eor Word from screen
		strH r3,[r10],#2
		
		subs r5,r5,#1			;X Loop
		bne Sprite_NextByte
	LDMFD sp!,{r10}		
	add r10,r10,#256*2			;240 - 2 bytes per pixel
	subs r6,r6,#1
	bne Sprite_NextLine			;Y loop
	mov pc,lr
	
	
SpriteAddress:
	.long SpriteTest			;Address of Sprite
	
SpriteTest:		;Smiley Sprite ( Color bits: ABBBBBGGGGGRRRRR	A=Alpha)
	.word 0x8000,0x8000,0x83FF,0x83FF,0x83FF,0x83FF,0x8000,0x8000 ;  0
	.word 0x8000,0x83FF,0x83FF,0x83FF,0x83FF,0x83FF,0x83FF,0x8000 ;  1
	.word 0x83FF,0x83FF,0x801F,0x83FF,0x83FF,0x801F,0x83FF,0x83FF ;  2
	.word 0x83FF,0x83FF,0x83FF,0x83FF,0x83FF,0x83FF,0x83FF,0x83FF ;  3
	.word 0x83FF,0x83FF,0x83FF,0x83FF,0x83FF,0x83FF,0x83FF,0x83FF ;  4
	.word 0x83FF,0x83FF,0xFFE0,0x83FF,0x83FF,0xFFE0,0x83FF,0x83FF ;  5
	.word 0x8000,0x83FF,0x83FF,0xFFE0,0xFFE0,0x83FF,0x83FF,0x8000 ;  6
	.word 0x8000,0x8000,0x83FF,0x83FF,0x83FF,0x83FF,0x8000,0x8000 ;  7
	
Arm9_End:

