; A=0
; BC=1/4
; DE=2/5
; HL=3/6

.equ EnemyData,0x02000100	;X,Y,Scale,Sprite
.equ EnemyData_X,0
.equ EnemyData_Y,1
.equ EnemyData_Spr,2
.equ EnemyData_Sca,3

.equ randomseed,0x02000104

;Text after semicolon is comments, you don't need to type it in
	.org  0x08000000  		   	;GBA Rom Base
;Header
	b	ProgramStart			;Jump to our program
	.space 178					;Logo (omitted) + Program name
	.byte 0x96					;Fixed value
	.space 49					;Dummy Header 
	
ProgramStart:
	mov sp,#0x03000000			;Init Stack Pointer
	
	mov r4,#0x04000000  		;DISPCNT -LCD Control
	mov r2,#0x403    			;4= Layer 2 on / 3= ScreenMode 3
	str	r2,[r4]         	

	bl RandomizeEnemy
	
	
	mov r8,#12					;Xpos
	mov r9,#10					;Ypos
	
	STMFD sp!,{r8-r9}
		bl ShowPlayer				;Show the new sprite position
		bl ShowEnemy
	LDMFD sp!,{r8-r9}		
	
InfLoop:
	mov r3,#0x4000130			;Read GBA joypad
	ldrh r0,[r3]		
	            ;------lrDULRSsBA
	and r0,r0,#0b0000000011110000
	cmp r0,#0b0000000011110000
	beq InfLoop
	
	STMFD sp!,{r0,r8-r9}
		bl ShowPlayer				;Show the new sprite position
		bl ShowEnemy
		
	LDMFD sp!,{r0,r8-r9}		
	
	         ;------lrDULRSsBA
	tst r0,#0b0000000001000000
	bne JoyNotUp
	cmp r9,#0
	beq JoyNotUp
	sub r9,r9,#1				;Move Up
JoyNotUp:	
			 ;------lrDULRSsBA
	tst r0,#0b0000000010000000
	bne JoyNotDown
	cmp r9,#160-16
	beq JoyNotDown
	add r9,r9,#1				;Move Down
JoyNotDown:	
	         ;------lrDULRSsBA
	tst r0,#0b0000000000100000
	bne JoyNotLeft
	cmp r8,#0
	beq JoyNotLeft
	sub r8,r8,#1				;Move Left
JoyNotLeft:	
			 ;------lrDULRSsBA
	tst r0,#0b0000000000010000
	bne JoyNotRight
	cmp r8,#240-16
	beq JoyNotRight
	add r8,r8,#1				;Move Right
JoyNotRight:	
	STMFD sp!,{r8-r9}
		bl ShowPlayer				;Show the new sprite position
		

		
		
	LDMFD sp!,{r8-r9}		
	STMFD sp!,{r8-r9}
	
		mov r2,r8
		mov r5,r9
		
		mov r1,#0
		mov r4,#0
		
		mov r11,#EnemyData
		ldrb r1,[r11,#EnemyData_X]
		ldrb r4,[r11,#EnemyData_Y]
		
		
		
		
		mov r3,#8	;Width of Range
		mov r6,#8	;Height of Range
	
		bl rangetest ;See if object XY pos r2,r5 hits object r1,r4 in range r3,r6
		beq NoHit
		
		bl RandomizeEnemy	;Hit object, so re-randomize
		
NoHit:
	bl ShowEnemy	
	LDMFD sp!,{r8-r9}		
	
	
		
	
	mov r0,#0x8FF				;Delay Loop
Delay:	
	subs r0,r0,#1
	bne Delay
	b InfLoop					;Repeat.
	
;Xor Sprite, drawing twice will remove sprite from screen.
ShowEnemy:
	mov r11,#EnemyData
	mov r8,#0
	mov r9,#0
	mov r10,#0
	ldrb r8,[r11,#EnemyData_X]
	ldrb r9,[r11,#EnemyData_Y]
	ldrb r10,[r11,#EnemyData_Spr]
	
	b ShowSprite
ShowPlayer:
	mov r10,#0
ShowSprite:
	

	mov r11,#SpriteInfo
	add r11,r11,r10,lsl #3
	
	mov r0,#0
	ldrb r0,[r11,#4]			;Width
	mov r0,r0,lsr #1
	sub r8,r8,r0
	
	mov r0,#0
	ldrb r0,[r11,#5]			;Height
	mov r0,r0,lsr #1
	sub r9,r9,r0
	
	mov r10,#0x06000000 		;VRAM base
	
	mov r1,#2					;Sprite is 8px, 2 bytes per pixel
	mul r2,r1,r8
	add r10,r10,r2				;Xpos *16
	
	mov r1,#240*2				;240 pixels per line, 2 bytes per pixel
	mul r2,r1,r9
	add r10,r10,r2				;Ypos * 240*8*2
	
	ldr r1,[r11]		;Sprite Address
	
	mov r6,#0
	ldrb r6,[r11,#5]			;Height
Sprite_NextLine:	
	mov r5,#0
	ldrb r5,[r11,#4]			;Width (in words / pixels)

	STMFD sp!,{r10}
Sprite_NextByte:
		ldrH r3,[r1],#2			;Must write 16/32bit per VRAM write 
		ldrH r2,[r10]
		eor r3,r3,r2			;Eor Word from screen
		strH r3,[r10],#2
		
		subs r5,r5,#1			;X Loop
		bne Sprite_NextByte
	LDMFD sp!,{r10}		
	add r10,r10,#240*2			;240 - 2 bytes per pixel
	subs r6,r6,#1
	bne Sprite_NextLine			;Y loop
	mov pc,lr
	
SpriteInfo:
    .long 0x0000*2 + SpriteBase           ;SpriteAddr 0
     .byte 16,16                                    ;XY 
	 .byte 0,0
    .long 0x0100*2 + SpriteBase           ;SpriteAddr 1
     .byte 32,24                                     ;XY 
	 .byte 0,0
    .long 0x0400*2 + SpriteBase           ;SpriteAddr 2
     .byte 32,32                                     ;XY 
	 .byte 0,0
    .long 0x0800*2 + SpriteBase           ;SpriteAddr 3
     .byte 24,16                                     ;XY 
	 .byte 0,0
    .long 0x0980*2 + SpriteBase           ;SpriteAddr 4
     .byte 24,24                                     ;XY 
	 .byte 0,0
    .long 0x0BC0*2 + SpriteBase           ;SpriteAddr 5
     .byte 16,8                                      ;XY 
	 .byte 0,0
    .long 0x0C40*2 + SpriteBase           ;SpriteAddr 6
     .byte 16,16                                     ;XY 
	.byte 0,0
	
SpriteBase: 	;Smiley ( Color bits: ABBBBBGGGGGRRRRR	A=Alpha )
	.incbin "\ResALL\SuckShoot\GBA_SuckShoot.RAW"

	.align 4	
	
dorangedrandom:		;return a value in R0 between R1 and R4
	STMFD sp!,{lr}
dorangedrandomB:			
		bl dorandom
		cmp	r0,r1
		blt dorangedrandomB		;Below R1
		cmp	r0,r4
		bgt dorangedrandomB		;Above R4
	LDMFD sp!,{pc}
	
	
	
	
RandomizeEnemy:	
	STMFD sp!,{lr}
		mov r11,#EnemyData
		mov r1,#16
		mov r4,#240-16
		bl dorangedrandom
	
		strb r0,[r11,#EnemyData_X]
	
		mov r1,#16
		mov r4,#160-16
		bl dorangedrandom
		
		strb r0,[r11,#EnemyData_Y]
		mov r0,#1
		strb r0,[r11,#EnemyData_Spr]
	LDMFD sp!,{pc}
	
	
	
;Random number Lookup tables
Randoms1:
	.byte 0x0A,0x9F,0xF0,0x1B,0x69,0x3D,0xE8,0x52,0xC6,0x41,0xB7,0x74,0x23,0xAC,0x8E,0xD5
Randoms2:
	.byte 0x9C,0xEE,0xB5,0xCA,0xAF,0xF0,0xdb,0x69,0x3D,0x58,0x22,0x06,0x41,0x17,0x74,0x83
	
	.include "\SrcAll\V1_Random.asm"
	
	
	

	
;See if object XY pos R2,R5 hits object R1,R4 in range R3,R6
	;Return R0=1 Collision... R0!=1 means no collision
rangetest:			
	STMFD sp!,{lr}	;X Axis Check
	
		mov r0,r1 			;Pos1 Xpos
		subs r0,r0,r3		;Shift Pos1 by 'range' to the Left
		blt rangetestb		;<0
		cmp r2,r0			;Does it match Pos2?
		blt rangetestoutofrange
		
rangetestb:
		add r0,r0,r3,asl #1	;Shift Pos1 by 'range' to the Right
		cmp r0,#255
		bgt rangetestd		;>255
		cmp r2,r0			;Does it match Pos2?
		bgt rangetestoutofrange
		
rangetestd:			;Y Axis Check

		mov r0,r4 			;Pos1 Ypos
		subs r0,r0,r6		;Shift Pos1 by 'range' Up
		blt rangetestc		;<0
		cmp r5,r0 			;Does it match Pos2?
		blt rangetestoutofrange
		
rangetestc:
		add r0,r0,r6,asl #1	;Shift Pos1 by 'range' Down
		cmp r0,#255
		bgt rangeteste		;>255
		cmp r5,r0			;Does it match Pos2?
		bgt rangetestoutofrange			
rangeteste:
		movs r0,#1			;1=Collided
	LDMFD sp!,{pc}
	
rangetestoutofrange:		
		movs r0,#0			;0=No Collision
	LDMFD sp!,{pc}
	
	