;Changes - Screen size, VRAM base, Ram vars, ChibiSOund driver

; A=0
; BC=1/4
; DE=2/5
; HL=3/6

.equ EnemyData,0x02F00100	
.equ EnemyData_X,0				;Xpos
.equ EnemyData_Y,1				;Ypos
.equ EnemyData_Spr,2			;Frame 0-1
.equ EnemyData_Sca,3			;Scale 16-64
.equ EnemyData_Speed,4			;Speed
.equ EnemyData_SpeedB,5			;time till next move
.equ EnemyData_Tick,6			;time till next frame

.equ CursorX,0x02F00000			;Text Cursor
.equ CursorY,0x02F00001

.equ Score,0x02F00004			;Score BCD
.equ HiScore,0x02F00008			;Hiscore BCD
.equ Lives,0x02F0000C			;Lives
.equ SoundTimeOut,0x02F0000D	;Sound Time

.equ ChibiSoundb,0x02F0000E		;Sound Driver (2 bytes)

.equ randomseed,0x02F00200		;Seed (2 bytes)



	.org 0x02000000-0x8000
HeaderStart:
;  000h    12    Game Title  (Uppercase ASCII, padded with 00h)
		;  123456789012
	.ascii "LEARNASM.NET"
;  00Ch    4     Gamecode    (Uppercase ASCII, NTR-<code>)        (0=homebrew)
	.ascii "0000"
;  010h    2     Makercode   (Uppercase ASCII, eg. "01"=Nintendo) (0=homebrew)
	.ascii "00"
;  012h    1     Unitcode    (00h=NDS, 02h=NDS+DSi, 03h=DSi) (bit1=DSi)
	.byte 0x00
;  013h    1     Encryption Seed Select (00..07h, usually 00h)
	.byte 0x00
;  014h    1     Devicecapacity         (Chipsize = 128KB SHL nn) (eg. 7 = 16MB)
	.byte 0x00
;  015h    7     Reserved    (zero filled)
	.byte 0,0,0,0,0,0,0
;  01Ch    1     Reserved    (zero)                      (except, used on DSi)
	.byte 0x00
;  01Dh    1     NDS Region  (00h=Normal, 80h=China, 40h=Korea) (other on DSi)
	.byte 0x00
;  01Eh    1     ROM Version (usually 00h)
	.byte 0x00
;  01Fh    1     Autostart (Bit2: Skip "Press Button" after Health and Safety)
	.byte 0x04     ;  1
;                (Also skips bootmenu, even in Manual mode & even Start pressed)


;  020h    4     ARM9 rom_offset    (4000h and up, align 1000h)
	.long Arm9_Start-HeaderStart
;  024h    4     ARM9 entry_address (2000000h..23BFE00h)
	.long Arm9_Start
;  028h    4     ARM9 ram_address   (2000000h..23BFE00h)
	.long Arm9_Start
;  02Ch    4     ARM9 size          (max 3BFE00h) (3839.5KB)
	.long Arm9_End-Arm9_Start
	
;  030h    4     ARM7 rom_offset    (8000h and up)
	.long Arm7_Start-HeaderStart
;  034h    4     ARM7 entry_address (2000000h..23BFE00h, or 37F8000h..3807E00h)
	;.long Arm7_Start
	.long 0x03800000
;  038h    4     ARM7 ram_address   (2000000h..23BFE00h, or 37F8000h..3807E00h)
	;.long Arm7_Start
	.long 0x03800000
;  03Ch    4     ARM7 size          (max 3BFE00h, or FE00h) (3839.5KB, 63.5KB)
	.long Arm7_End-Arm7_Start
	
	
;  040h    4     File Name Table (FNT) offset
	.long 0
;  044h    4     File Name Table (FNT) size
	.long 0
;  048h    4     File Allocation Table (FAT) offset
	.long 0
;  04Ch    4     File Allocation Table (FAT) size
	.long 0
;  050h    4     File ARM9 overlay_offset
	.long 0
;  054h    4     File ARM9 overlay_size
	.long 0
;  058h    4     File ARM7 overlay_offset
	.long 0
;  05Ch    4     File ARM7 overlay_size
	.long 0
;  060h    4     Port 40001A4h setting for normal commands (usually 00586000h)
	.long 0x00586000
;  064h    4     Port 40001A4h setting for KEY1 commands   (usually 001808F8h)
	.long 0x001808F8
;  068h    4     Icon/Title offset (0=None) (8000h and up)
	.long 0
;  06Ch    2     Secure Area Checksum, CRC-16 of [[020h]..00007FFFh]
	.byte 0,0
;  06Eh    2     Secure Area Delay (in 131kHz units) (051Eh=10ms or 0D7Eh=26ms)
	.byte 0,0
;  070h    4     ARM9 Auto Load List Hook RAM Address (?) ;\endaddr of auto-load
	.long 0
;  074h    4     ARM7 Auto Load List Hook RAM Address (?) ;/functions
	.long 0
;  078h    8     Secure Area Disable (by encrypted "NmMdOnly") (usually zero)
	.byte 0,0,0,0,0,0,0,0
;  080h    4     Total Used ROM size (remaining/unused bytes usually FFh-padded)
	.long 0
	
        
;  084h    4     ROM Header Size (4000h)
	.long 0x4000
	
;  088h    28h   Reserved (zero filled; except, [88h..93h] used on DSi)
	.byte 0x04,0x13,0x80,0xE5,0x00,0x20,0x80,0xE5     ;  8
	.byte 0x40,0x32,0x80,0xE5,0x1A,0x05,0xA0,0xE3,0x1F,0x10,0xA0,0xE3,0x03,0x29,0xA0,0xE3     ;  9
    .byte 0xB2,0x10,0xC0,0xE0,0x01,0x20,0x52,0xE2,0xFC,0xFF,0xFF,0x1A,0x50,0x41,0x53,0x53     ; A
;  0B0h    10h   Reserved (zero filled; or "DoNotZeroFillMem"=unlaunch fastboot)
	.byte 0xFE,0xFF,0xFF,0xEA,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00     ; B
;  0C0h    9Ch   Nintendo Logo (compressed bitmap, same as in GBA Headers)
	.byte 0xC8,0x60,0x4F,0xE2,0x01,0x70,0x8F,0xE2,0x17,0xFF,0x2F,0xE1,0x12,0x4F,0x11,0x48     ; C
	.byte 0x12,0x4C,0x20,0x60,0x64,0x60,0x7C,0x62,0x30,0x1C,0x39,0x1C,0x10,0x4A,0x00,0xF0     ; D
    .byte 0x14,0xF8,0x30,0x6A,0x80,0x19,0xB1,0x6A,0xF2,0x6A,0x00,0xF0,0x0B,0xF8,0x30,0x6B     ; E
    .byte 0x80,0x19,0xB1,0x6B,0xF2,0x6B,0x00,0xF0,0x08,0xF8,0x70,0x6A,0x77,0x6B,0x07,0x4C     ; F
    .byte 0x60,0x60,0x38,0x47,0x07,0x4B,0xD2,0x18,0x9A,0x43,0x07,0x4B,0x92,0x08,0xD2,0x18     ; 10
    .byte 0x0C,0xDF,0xF7,0x46,0x04,0xF0,0x1F,0xE5,0x00,0xFE,0x7F,0x02,0xF0,0xFF,0x7F,0x02     ; 11
    .byte 0xF0,0x01,0x00,0x00,0xFF,0x01,0x00,0x00,0x00,0x00,0x00,0x04,0x00,0x00,0x00,0x00     ; 12
    .byte 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00     ; 13
    .byte 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00     ; 14
	.byte 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
;  15Ch    2     Nintendo Logo Checksum, CRC-16 of [0C0h-15Bh], fixed CF56h
	.byte 0x1A,0x9E
;  15Eh    2     Header Checksum, CRC-16 of [000h-15Dh]
	.byte 0x7B,0xEB     ; 15
;  160h    4     Debug rom_offset   (0=none) (8000h and up)       ;only if debug
	.long 0
;  164h    4     Debug size         (0=none) (max 3BFE00h)        ;version with
	.long 0
;  168h    4     Debug ram_address  (0=none) (2400000h..27BFE00h) ;SIO and 8MB
	.long 0
;  16Ch    4     Reserved (zero filled) (transferred, and stored, but not used)
	.long 0
;  170h    90h   Reserved (zero filled) (transferred, but not stored in RAM)

	.space 0x90
	;Pad to 0x2000000
	.space 0x7E00
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;	Arm 9
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 
Arm9_Start:
	mov sp,#0x03000000	;Set up our stack pointer
	
	mov r0, #0x4000000
	add r0, r0, #0x304	;4000304h - NDS9 - POWCNT1 - Graphics Power Control Register (R/W)
	
	mov r1, #0x8003		;2D + Enable
	str r1, [r0]
			
	mov r0, #0x04000000	;4000000h - DISPCNT - LCD Control (Read/Write)
	mov r1, #0x00020000
	str r1, [r0]		;2  Engine A only: VRAM Display (Bitmap from block selected in DISPCNT.18-19)
	
	mov r0, #0x04000000
	add r0, r0, #0x240
	mov r1, #0x80		;Enable
	strb r1, [r0]		;4000240h - NDS9 - VRAMCNT_A - 8bit - VRAM-A (128K) Bank Control (W)

	     	
	

ShowTitle:
	bl WaitForRelease			;Wait for Fire to be released

	bl Cls						;Clear Screen
	
	
	
	mov r11,#SoundTimeOut	
	mov r0,#0
	strb r0,[r11]				;Silence sound
	bl ChibiSound
	
	
	
	mov r1,#9
	mov r2,#4
	bl Locate	;Locate X,Y=R1,R2
	ldr r1,atxtSuckShoot
	bl PrintString				;Show Title
	
	mov r1,#11
	mov r2,#15
	bl Locate	;Locate X,Y=R1,R2	
	ldr r1,atxtHiscore
	bl PrintString				;Show Hiscore text
	
	mov r1,#11
	mov r2,#16
	bl Locate	;Locate X,Y=R1,R2	
	mov r11,#HiScore			;Show Hiscore
	ldr r1,[r11]	
	bl BCD_Show					;Show BCD in R1
	
		
	mov r11,#EnemyData
	
	mov r0,#120					;Settings for bat sprite
	strb r0,[r11,#EnemyData_X]
	mov r0,#80
	strb r0,[r11,#EnemyData_Y]
	mov r0,#1
	strb r0,[r11,#EnemyData_Spr]
	mov r0,#48
	strb r0,[r11,#EnemyData_Sca]
		
	
	
TitleScreen:	
	mov r11,#EnemyData
	
	ldrb r0,[r11,#EnemyData_Spr]	
	eor r0,r0,#1				;Toggle bat frame
	strb r0,[r11,#EnemyData_Spr]

	bl ShowEnemy

	mov r0,#0x400000				;Wait a bit!
	bl DoPause
	
	bl ShowEnemy				;Show The Bat
	
	bl ReadJoystick		;Read in the Joystick	%---1UDLR
		    ; SSBARLDU
	tst r0,#0b00010000
	bne TitleScreen				;Repeat until fire pressed
	b Gameplay

atxtSuckShoot:
	.long txtSuckShoot			;Pointers to text strings
atxtHiscore:
	.long txtHiscore

txtSuckShoot:
	 .byte "SUCK SHOOT!",255
txtHiscore:
	 .byte "HISCORE:",255
	
	.align 4
	
Gameplay:
	bl Cls						;Clear Screen
	
	mov r11,#EnemyData
	
	mov r0,#32					;Enemy Speed
	strb r0,[r11,#EnemyData_Speed]
	
	mov r11,#Score
	mov r0,#0
	str r0,[r11]				;Write 4 zeros to score
	
	mov r11,#Lives
	mov r0,#4
	strb r0,[r11]				;Player lives
	
	bl RandomizeEnemy
	
	bl UpdateScore				;Show Score/lives text
	
	mov r8,#12					;Xpos
	mov r9,#10					;Ypos
	
	STMFD sp!,{r8-r9}
		bl ShowPlayer			;Show the new sprite position
		bl ShowEnemy			;Show the enemy sprite
	LDMFD sp!,{r8-r9}		
	
InfLoop:
	mov r10,#SoundTimeOut		;Time till silenced
	ldrb r0,[r10]
	cmp r0,#0
	beq ChibiSoundUpdated
	subs r0,r0,#1
	bne ChibiSoundUpdated
	bl ChibiSound				;Mute Sound
ChibiSoundUpdated:
	strb r0,[r10]
	
	
	
	bl ReadJoystick				;Read in the Joystick	%--21UDLR
	
	STMFD sp!,{r0,r8-r9}
		bl ShowPlayer			;Remove the old player
	LDMFD sp!,{r0,r8-r9}		
	
	mov r7,#2					;Move Speed Slow
	        ; SSBARLDU
	tst r0,#0b00100000			;Fire 2
	bne NoFire2
	mov r7,#4					;Move Speed Fast
NoFire2:	

	        ; SSBARLDU
	tst r0,#0b00000001
	bne JoyNotUp
	cmp r9,#12
	bcc JoyNotUp
	sub r9,r9,r7				;Move Up
JoyNotUp:	
	        ; SSBARLDU
	tst r0,#0b00000010
	bne JoyNotDown
	cmp r9,#192-12
	bcs JoyNotDown
	add r9,r9,r7				;Move Down
JoyNotDown:	
	        ; SSBARLDU
	tst r0,#0b00000100
	bne JoyNotLeft
	cmp r8,#12
	bcc JoyNotLeft
	sub r8,r8,r7				;Move Left
JoyNotLeft:	
	        ; SSBARLDU
	tst r0,#0b00001000
	bne JoyNotRight
	cmp r8,#256-12
	bcs JoyNotRight
	add r8,r8,r7				;Move Right
JoyNotRight:	
	STMFD sp!,{r0,r8-r9}
		bl ShowPlayer			;Show the new sprite position
		bl ShowEnemy			;Remove old enemy
	LDMFD sp!,{r0,r8-r9}		
	
	STMFD sp!,{r8-r9}
			    ; SSBARLDU
		tst r0,#0b00010000
		bne NoFire1				;See if player shot
		
		mov r11,#SoundTimeOut
		ldrb r0,[r11]
		cmp r0,#0
		bne FireNosound			;Done make fire sound if still firing
		
				
		mov r0,#0b11100000
		bl ChibiSound			;Make sound R0

FireNosound:		
	
		mov r11,#SoundTimeOut
		mov r0,#4
		strb r0,[r11]			;Set Sound Time
	
		mov r2,r8
		mov r5,r9
		
		mov r11,#EnemyData
		ldrb r1,[r11,#EnemyData_X]	;XY of enemy
		ldrb r4,[r11,#EnemyData_Y]
				
		mov r3,#8				;Width of Range
		mov r6,#8				;Height of Range
	
		bl rangetest			;See if object XY pos r2,r5 hits 
		beq NoHit				;object r1,r4 in range r3,r6
		
		ldrb r0,[r11,#EnemyData_Speed]
		add r0,r0,#1			;Speed up next enemy
		strb r0,[r11,#EnemyData_Speed]
		
		mov r0,#0b11000001
		bl ChibiSound			;Make sound A
				
		mov r10,#Score
		ldr r1,[r10]			;Get Current Score
		mov r2,#5
		
		bl BCD_Add				;R1=R1+R2
		str r1,[r10]
		
		bl UpdateScore			;Show Score/lives text

		bl RandomizeEnemy		;Hit object, so re-randomize
NoHit:
NoFire1:	

		mov r11,#EnemyData
		ldrb r0,[r11,#EnemyData_Tick]
		add r0,r0,#64			;Update Bat Frame Tick
		strb r0,[r11,#EnemyData_Tick]
		ands r0,r0,#0xF00
		beq NoEnemyHit			;If not overflowed no move yet
		
		mov r11,#EnemyData
		ldrb r0,[r11,#EnemyData_Spr]
		eor r0,r0,#1			;Toggle Bat frame
		strb r0,[r11,#EnemyData_Spr]

		
		
		ldrb r0,[r11,#EnemyData_SpeedB]
		ldrb r1,[r11,#EnemyData_Speed]
		add r0,r0,r1			;Update Bat Time
		strb r0,[r11,#EnemyData_SpeedB]
		
		ands r0,r0,#0x0F00		
		beq NoEnemyHit
		
		ldrb r0,[r11,#EnemyData_Sca]
		adds r0,r0,#8			;Make Bat Bigger
		strb r0,[r11,#EnemyData_Sca]
		
		cmp r0,#64				;Biggest?
		bcc NoEnemyHit
			bl RandomizeEnemy	;Bat bit us!
			
			mov r11,#Lives
			ldrb r0,[r11]	
			subs r0,r0,#1		;Remove 1 life
			strb r0,[r11]	
			beq GameOver		;Player dead?
			
			mov r11,#SoundTimeOut
			mov r0,#4
			strb r0,[r11]		;Set Sound Time
			
			mov r0,#0b01000001
			bl ChibiSound		;Make Bite sound
		
			bl UpdateScore		;Show Score/lives text
NoEnemyHit:		
		bl ShowEnemy			;Show Bat again
	LDMFD sp!,{r8-r9}		
	
	mov r0,#0x80000				;Delay Loop
	bl DoPause
	
	b InfLoop					;Repeat.

	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	

GameOver:
	bl WaitForRelease			;Wait for Fire to be released
	
	mov r0,#0
	bl ChibiSound				;Silence sound

	bl Cls						;Clear Screen
	
	mov r1,#10
	mov r2,#4
	bl Locate	;Locate X,Y=R1,R2	
	ldr r1,atxtGameOver			;Show 'Game Over'
	bl PrintString

	
	mov r10,#Score
	ldr r1,[r10]				;Current Score
	mov r11,#HiScore
	ldr r0,[r11]				;High score
	
	cmp r1,r0
	bls GameOver_NoScore		;New score lower

	str r1,[r11]				;Update the highscore
	
	mov r1,#9
	mov r2,#15
	bl Locate	;Locate X,Y=R1,R2	
	ldr r1,atxtGotHiScore		;Show 'New Highscore'
	bl PrintString
	
GameOver_Wait:
	bl ReadJoystick		;Read in the Joystick	%---1UDLR
		    ; SSBARLDU
	tst r0,#0b00010000
	bne GameOver_Wait			;Repeat until fire pressed
	b ShowTitle
	
GameOver_NoScore:	
	mov r1,#10
	mov r2,#15
	bl Locate	;Locate X,Y=R1,R2	
	ldr r1,atxtNoHiScore		;Show 'You Suck!'
	bl PrintString
	b GameOver_Wait
	
atxtGameOver:
	.long txtGameOver
atxtGotHiScore:
	.long txtGotHiScore
atxtNoHiScore:
	.long txtNoHiScore
	
txtGameOver:
	.byte "GAME OVER",255
txtGotHiScore:	
	.byte "NEW HISCORE",255
txtNoHiScore:				
	.byte "YOU SUCK!",255	

	.align 4
	
	
UpdateScore:
	STMFD sp!,{lr}
		mov r1,#0
		mov r2,#0
		bl Locate	;Locate X,Y=R1,R2
		mov r11,#Score
		ldr r1,[r11]	
		bl BCD_Show				;Show Score TopLeft
		
		mov r1,#28
		mov r2,#0
		bl Locate	;Locate X,Y=R1,R2
		mov r11,#Lives
		ldrb r1,[r11]	
		mov r1,r1,asl #24
		mov r4,#2				;Show Lives Top Right
		bl ShowBCDalt
	LDMFD sp!,{pc}
	
DoPause:
	subs r0,r0,#1
	bne DoPause
	MOV pc,lr
	
;Xor Sprite, drawing twice will remove sprite from screen.
ShowEnemy:
	mov r11,#EnemyData
	ldrb r8,[r11,#EnemyData_X]
	ldrb r9,[r11,#EnemyData_Y]
	ldrb r10,[r11,#EnemyData_Spr]
	and r10,r10,#1				;2 frames of animation
	add r10,r10,#1				;Enemy sprites are no 1-7
	
	ldrb r0,[r11,#EnemyData_Sca]
	eor r0,r0,#0b00110000
	and r0,r0,#0b00110000		;3 sizes of bat
	add r10,r10,r0,lsr #3
	b ShowSprite
	
ShowPlayer:
	mov r10,#0					;Player cursor is sprite 0
	
ShowSprite:
	ldr r11,aSpriteInfo
	add r11,r11,r10,lsl #3
	
	ldrb r0,[r11,#4]			;Width
	mov r0,r0,lsr #1
	sub r8,r8,r0
	
	ldrb r0,[r11,#5]			;Height
	mov r0,r0,lsr #1
	sub r9,r9,r0
	
	mov r10,#0x06800000 		;VRAM base
	
	mov r1,#2					;Sprite is 8px, 2 bytes per pixel
	mul r2,r1,r8
	add r10,r10,r2				;Xpos *16
	
	mov r1,#256*2				;256 pixels per line, 2 bytes per pixel
	mul r2,r1,r9
	add r10,r10,r2				;Ypos * 256*8*2
	
	
	ldr r1,[r11]				;Sprite source Address
	
	ldrb r6,[r11,#5]			;Height
Sprite_NextLine:	
	ldrb r5,[r11,#4]			;Width (in words / pixels)

	STMFD sp!,{r10}
Sprite_NextByte:
		ldrH r3,[r1],#2			;Must write 16/32bit per VRAM write 
		ldrH r2,[r10]
		eor r3,r3,r2			;Eor Word from screen
		strH r3,[r10],#2
		
		subs r5,r5,#1			;X Loop
		bne Sprite_NextByte
	LDMFD sp!,{r10}		
	add r10,r10,#256*2			;256 - 2 bytes per pixel
	subs r6,r6,#1
	bne Sprite_NextLine			;Y loop
	mov pc,lr
	
aSpriteInfo:
	.long SpriteInfo
	
SpriteInfo:
    .long 0x0000*2 + SpriteBase           ;SpriteAddr 0
     .byte 16,16                                    ;XY 
	 .byte 0,0
    .long 0x0100*2 + SpriteBase           ;SpriteAddr 1
     .byte 32,24                                     ;XY 
	 .byte 0,0
    .long 0x0400*2 + SpriteBase           ;SpriteAddr 2
     .byte 32,32                                     ;XY 
	 .byte 0,0
    .long 0x0800*2 + SpriteBase           ;SpriteAddr 3
     .byte 24,16                                     ;XY 
	 .byte 0,0
    .long 0x0980*2 + SpriteBase           ;SpriteAddr 4
     .byte 24,24                                     ;XY 
	 .byte 0,0
    .long 0x0BC0*2 + SpriteBase           ;SpriteAddr 5
     .byte 16,8                                      ;XY 
	 .byte 0,0
    .long 0x0C40*2 + SpriteBase           ;SpriteAddr 6
     .byte 16,16                                     ;XY 
	.byte 0,0
	
SpriteBase: 	;Smiley ( Color bits: ABBBBBGGGGGRRRRR	A=Alpha )
	.incbin "\ResALL\SuckShoot\GBA_SuckShoot.RAW"

	.align 4	
	
dorangedrandom:		;return a value in R0 between R1 and R4
	STMFD sp!,{lr}
dorangedrandomB:			
		bl dorandom
		cmp	r0,r1
		blt dorangedrandomB		;Below R1
		cmp	r0,r4
		bgt dorangedrandomB		;Above R4
	LDMFD sp!,{pc}
	
WaitForRelease:	
	STMFD sp!,{lr}
		bl ReadJoystick
				; SSBARLDU
		tst r0,#0b00010000
		beq WaitForRelease			;Repeat until fire released
	LDMFD sp!,{pc}
	
ReadJoystick: 		;Convert ------lrDULRSsBA to SsBARLDU
	STMFD sp!,{lr}
		mov r3,#0x4000130			;Read GBA joypad
		ldrh r2,[r3];------lrDULRSsBA
		and r1,r2,#0b0000000011000000	;UD
		mov r0,r1,lsr #6
		and r1,r2,#0b0000000000100000	;L
		orr r0,r0,r1,lsr #3
		and r1,r2,#0b0000000000010000	;R
		orr r0,r0,r1,lsr #1
		and r1,r2,#0b0000000000001111	;SsBA
		orr r0,r0,r1,lsl #4
	LDMFD sp!,{pc}
	
RandomizeEnemy:	
	STMFD sp!,{lr}
		mov r11,#EnemyData
		
		mov r1,#16
		mov r4,#256-16
		bl dorangedrandom
		strb r0,[r11,#EnemyData_X]		;Random Xpos
	
		mov r1,#16
		mov r4,#192-16
		bl dorangedrandom
		strb r0,[r11,#EnemyData_Y]		;Random Ypos
		
		
		mov r0,#16
		strb r0,[r11,#EnemyData_Sca]	;Scale=0
		
		mov r0,#0
		strb r0,[r11,#EnemyData_SpeedB]	;Speed=0
		strb r0,[r11,#EnemyData_Spr]	;Frame=0
	LDMFD sp!,{pc}
	
	
	
;Random number Lookup tables
Randoms1:
	.byte 0x0A,0x9F,0xF0,0x1B,0x69,0x3D,0xE8,0x52,0xC6,0x41,0xB7,0x74,0x23,0xAC,0x8E,0xD5
Randoms2:
	.byte 0x9C,0xEE,0xB5,0xCA,0xAF,0xF0,0xdb,0x69,0x3D,0x58,0x22,0x06,0x41,0x17,0x74,0x83
	
	.include "\SrcAll\V1_Random.asm"
	.include "\SrcAll\V1_BCD.asm"
	.include "\SrcALL\V1_ChibiSound.asm"	
	

	
;See if object XY pos R2,R5 hits object R1,R4 in range R3,R6
	;Return R0=1 Collision... R0!=1 means no collision
rangetest:			
	STMFD sp!,{lr}	;X Axis Check
	
		mov r0,r1 			;Pos1 Xpos
		subs r0,r0,r3		;Shift Pos1 by 'range' to the Left
		blt rangetestb		;<0
		cmp r2,r0			;Does it match Pos2?
		blt rangetestoutofrange
		
rangetestb:
		add r0,r0,r3,asl #1	;Shift Pos1 by 'range' to the Right
		cmp r0,#255
		bgt rangetestd		;>255
		cmp r2,r0			;Does it match Pos2?
		bgt rangetestoutofrange
		
rangetestd:			;Y Axis Check

		mov r0,r4 			;Pos1 Ypos
		subs r0,r0,r6		;Shift Pos1 by 'range' Up
		blt rangetestc		;<0
		cmp r5,r0 			;Does it match Pos2?
		blt rangetestoutofrange
		
rangetestc:
		add r0,r0,r6,asl #1	;Shift Pos1 by 'range' Down
		cmp r0,#255
		bgt rangeteste		;>255
		cmp r5,r0			;Does it match Pos2?
		bgt rangetestoutofrange			
rangeteste:
		movs r0,#1			;1=Collided
	LDMFD sp!,{pc}
	
rangetestoutofrange:		
		movs r0,#0			;0=No Collision
	LDMFD sp!,{pc}
	
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

PrintString:					;Print 255 terminated string 
	STMFD sp!,{r0-r12, lr}
PrintStringAgain:
		ldrB r0,[r1],#1
		cmps r0,#255
		beq PrintStringDone		;Repeat until 255
		bl printchar 			;Print Char
		b PrintStringAgain
PrintStringDone:
	LDMFD sp!,{r0-r12, pc}
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
Cls:
		mov r0, #0x06800000		;Screen Ram
		mov r1, #00				;Fill Word
		mov r2, #256*192/2		;Words to fill
FillScreenLoop:
		str r1, [r0],#4			;Store+inc 2 bytes
		subs r2, r2, #1		
		bne FillScreenLoop	
	MOV pc,lr
	
	
Locate:		;X,Y = R1,R2
	STMFD sp!,{r3,lr}
		mov r3,#CursorX
		strB r1,[r3]			;X pos
		mov r3,#CursorY
		strB r2,[r3]			;Y pos
		
	LDMFD sp!,{r3,pc}
		
	
PrintChar:
	STMFD sp!,{r0-r12, lr}
	mov r4,#0
		mov r5,#0
		
		mov r3,#CursorX
		ldrB r4,[r3]			;X pos
		mov r3,#CursorY
		ldrB r5,[r3]			;Y pos
		
		mov r3,#0x06800000 		;VRAM base
		
		mov r6,#8*2				;Xpos, 2 bytes per pixel, 8 bytes per char
		mul r2,r4,r6
		add r3,r3,r2
		
		mov r4,#256*8*2			;Ypos, 256 pixels per line,
		mul r2,r5,r4				;2 bytes per pixel, 8 lines per char
		add r3,r3,r2
		
		adr r4,BitmapFont 		;Font source
		
		sub r0,r0,#32			;First Char is 32 (space)
		add r4,r4,r0,asl #3		;8 bytes per char
		
		mov r1,#8				;8 lines 
DrawLine:
		mov r7,#8 				;8 pixels per line
		ldrb r8,[r4],#1			;Load Letter
		mov r9,#0b100000000		;Mask
				
		mov r2, #0x7FFF; Color: ABBBBBGGGGGRRRRR   A=Alpha
		mov r10,#0		;Blank
DrawPixel:
		tst r8,r9				;Is bit 1?
		strneh r2,[r3]			;Yes? then fill pixel (HalfWord)
		streqh r10,[r3]			;Yes? then fill pixel (HalfWord)
		add r3,r3,#2
		mov r9,r9,ror #1		;Bitshift Mask
		subs r7,r7,#1
		bne DrawPixel			;Next Hpixel
		
		add r3,r3,#512-16	   ;Move Down a line (256 pixels *2 bytes) 
		subs r1,r1,#1								;-1 char (16 px)
		bne DrawLine			;Next Vline
		
LineDone:	
		mov r3,#CursorX
		ldrB r0,[r3]	
		add r0,r0,#1			;Move across screen
		strB r0,[r3]	
	LDMFD sp!,{r0-r12, pc}

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
BitmapFont:
        .byte 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00     ;  0
        .byte 0x10,0x18,0x18,0x18,0x18,0x00,0x18,0x00     ;  1
        .byte 0x28,0x6C,0x28,0x00,0x00,0x00,0x00,0x00     ;  2
        .byte 0x00,0x28,0x7C,0x28,0x7C,0x28,0x00,0x00     ;  3
        .byte 0x18,0x3E,0x48,0x3C,0x12,0x7C,0x18,0x00     ;  4
        .byte 0x02,0xC4,0xC8,0x10,0x20,0x46,0x86,0x00     ;  5
        .byte 0x10,0x28,0x28,0x72,0x94,0x8C,0x72,0x00     ;  6
        .byte 0x0C,0x1C,0x30,0x00,0x00,0x00,0x00,0x00     ;  7
        .byte 0x18,0x18,0x30,0x30,0x30,0x18,0x18,0x00     ;  8
        .byte 0x18,0x18,0x0C,0x0C,0x0C,0x18,0x18,0x00     ;  9
        .byte 0x08,0x49,0x2A,0x1C,0x14,0x22,0x41,0x00     ; 10
        .byte 0x00,0x18,0x18,0x7E,0x18,0x18,0x00,0x00     ; 11
        .byte 0x00,0x00,0x00,0x00,0x00,0x18,0x18,0x30     ; 12
        .byte 0x00,0x00,0x00,0x7E,0x7E,0x00,0x00,0x00     ; 13
        .byte 0x00,0x00,0x00,0x00,0x00,0x18,0x18,0x00     ; 14
        .byte 0x02,0x04,0x08,0x10,0x20,0x40,0x80,0x00     ; 15
        .byte 0x7C,0xC6,0xD6,0xD6,0xD6,0xC6,0x7C,0x00     ; 16
        .byte 0x10,0x18,0x18,0x18,0x18,0x18,0x08,0x00     ; 17
        .byte 0x3C,0x7E,0x06,0x3C,0x60,0x7E,0x3C,0x00     ; 18
        .byte 0x3C,0x7E,0x06,0x1C,0x06,0x7E,0x3C,0x00     ; 19
        .byte 0x18,0x3C,0x64,0xCC,0x7C,0x0C,0x08,0x00     ; 20
        .byte 0x3C,0x7E,0x60,0x7C,0x06,0x7E,0x3E,0x00     ; 21
        .byte 0x3C,0x7E,0x60,0x7C,0x66,0x66,0x3C,0x00     ; 22
        .byte 0x3C,0x7E,0x06,0x0C,0x18,0x18,0x10,0x00     ; 23
        .byte 0x3C,0x66,0x66,0x3C,0x66,0x66,0x3C,0x00     ; 24
        .byte 0x3C,0x66,0x66,0x3E,0x06,0x7E,0x3C,0x00     ; 25
        .byte 0x00,0x00,0x18,0x18,0x00,0x18,0x18,0x00     ; 26
        .byte 0x00,0x00,0x18,0x18,0x00,0x18,0x18,0x30     ; 27
        .byte 0x0C,0x1C,0x38,0x60,0x38,0x1C,0x0C,0x00     ; 28
        .byte 0x00,0x00,0x7E,0x00,0x00,0x7E,0x00,0x00     ; 29
        .byte 0x60,0x70,0x38,0x0C,0x38,0x70,0x60,0x00     ; 30
        .byte 0x3C,0x76,0x06,0x1C,0x00,0x18,0x18,0x00     ; 31
        .byte 0x7C,0xCE,0xA6,0xB6,0xC6,0xF0,0x7C,0x00     ; 32
        .byte 0x18,0x3C,0x66,0x66,0x7E,0x66,0x24,0x00     ; 33
        .byte 0x3C,0x66,0x66,0x7C,0x66,0x66,0x3C,0x00     ; 34
        .byte 0x38,0x7C,0xC0,0xC0,0xC0,0x7C,0x38,0x00     ; 35
        .byte 0x3C,0x64,0x66,0x66,0x66,0x64,0x38,0x00     ; 36
        .byte 0x3C,0x7E,0x60,0x78,0x60,0x7E,0x3C,0x00     ; 37
        .byte 0x38,0x7C,0x60,0x78,0x60,0x60,0x20,0x00     ; 38
        .byte 0x3C,0x66,0xC0,0xC0,0xCC,0x66,0x3C,0x00     ; 39
        .byte 0x24,0x66,0x66,0x7E,0x66,0x66,0x24,0x00     ; 40
        .byte 0x10,0x18,0x18,0x18,0x18,0x18,0x08,0x00     ; 41
        .byte 0x08,0x0C,0x0C,0x0C,0x4C,0xFC,0x78,0x00     ; 42
        .byte 0x24,0x66,0x6C,0x78,0x6C,0x66,0x24,0x00     ; 43
        .byte 0x20,0x60,0x60,0x60,0x60,0x7E,0x3E,0x00     ; 44
        .byte 0x44,0xEE,0xFE,0xD6,0xD6,0xD6,0x44,0x00     ; 45
        .byte 0x44,0xE6,0xF6,0xDE,0xCE,0xC6,0x44,0x00     ; 46
        .byte 0x38,0x6C,0xC6,0xC6,0xC6,0x6C,0x38,0x00     ; 47
        .byte 0x38,0x6C,0x64,0x7C,0x60,0x60,0x20,0x00     ; 48
        .byte 0x38,0x6C,0xC6,0xC6,0xCA,0x74,0x3A,0x00     ; 49
        .byte 0x3C,0x66,0x66,0x7C,0x6C,0x66,0x26,0x00     ; 50
        .byte 0x3C,0x7E,0x60,0x3C,0x06,0x7E,0x3C,0x00     ; 51
        .byte 0x3C,0x7E,0x18,0x18,0x18,0x18,0x08,0x00     ; 52
        .byte 0x24,0x66,0x66,0x66,0x66,0x66,0x3C,0x00     ; 53
        .byte 0x24,0x66,0x66,0x66,0x66,0x3C,0x18,0x00     ; 54
        .byte 0x44,0xC6,0xD6,0xD6,0xFE,0xEE,0x44,0x00     ; 55
        .byte 0xC6,0x6C,0x38,0x38,0x6C,0xC6,0x44,0x00     ; 56
        .byte 0x24,0x66,0x66,0x3C,0x18,0x18,0x08,0x00     ; 57
        .byte 0x7C,0xFC,0x0C,0x18,0x30,0x7E,0x7C,0x00     ; 58
        .byte 0x1C,0x30,0x30,0x30,0x30,0x30,0x1C,0x00     ; 59
        .byte 0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x00     ; 60
        .byte 0x38,0x0C,0x0C,0x0C,0x0C,0x0C,0x38,0x00     ; 61
        .byte 0x18,0x18,0x18,0x18,0x7E,0x7E,0x18,0x18     ; 62
        .byte 0x18,0x18,0x18,0x18,0x3C,0x3C,0x18,0x18     ; 63
        .byte 0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18     ; 64
        .byte 0x00,0x00,0x38,0x0C,0x7C,0xCC,0x78,0x00     ; 65
        .byte 0x20,0x60,0x7C,0x66,0x66,0x66,0x3C,0x00     ; 66
        .byte 0x00,0x00,0x3C,0x66,0x60,0x66,0x3C,0x00     ; 67
        .byte 0x08,0x0C,0x7C,0xCC,0xCC,0xCC,0x78,0x00     ; 68
        .byte 0x00,0x00,0x3C,0x66,0x7E,0x60,0x3C,0x00     ; 69
        .byte 0x1C,0x36,0x30,0x38,0x30,0x30,0x10,0x00     ; 70
        .byte 0x00,0x00,0x3C,0x66,0x66,0x3E,0x06,0x3C     ; 71
        .byte 0x20,0x60,0x6C,0x76,0x66,0x66,0x24,0x00     ; 72
        .byte 0x18,0x00,0x18,0x18,0x18,0x18,0x08,0x00     ; 73
        .byte 0x06,0x00,0x04,0x06,0x06,0x26,0x66,0x3C     ; 74
        .byte 0x20,0x60,0x66,0x6C,0x78,0x6C,0x26,0x00     ; 75
        .byte 0x10,0x18,0x18,0x18,0x18,0x18,0x08,0x00     ; 76
        .byte 0x00,0x00,0x6C,0xFE,0xD6,0xD6,0xC6,0x00     ; 77
        .byte 0x00,0x00,0x3C,0x66,0x66,0x66,0x24,0x00     ; 78
        .byte 0x00,0x00,0x3C,0x66,0x66,0x66,0x3C,0x00     ; 79
        .byte 0x00,0x00,0x3C,0x66,0x66,0x7C,0x60,0x20     ; 80
        .byte 0x00,0x00,0x78,0xCC,0xCC,0x7C,0x0C,0x08     ; 81
        .byte 0x00,0x00,0x38,0x7C,0x60,0x60,0x20,0x00     ; 82
        .byte 0x00,0x00,0x3C,0x60,0x3C,0x06,0x7C,0x00     ; 83
        .byte 0x10,0x30,0x3C,0x30,0x30,0x3E,0x1C,0x00     ; 84
        .byte 0x00,0x00,0x24,0x66,0x66,0x66,0x3C,0x00     ; 85
        .byte 0x00,0x00,0x24,0x66,0x66,0x3C,0x18,0x00     ; 86
        .byte 0x00,0x00,0x44,0xD6,0xD6,0xFE,0x6C,0x00     ; 87
        .byte 0x00,0x00,0xC6,0x6C,0x38,0x6C,0xC6,0x00     ; 88
        .byte 0x00,0x00,0x24,0x66,0x66,0x3E,0x06,0x7C     ; 89
        .byte 0x00,0x00,0x7E,0x0C,0x18,0x30,0x7E,0x00     ; 90
        .byte 0x08,0x08,0x08,0x08,0x56,0x55,0x57,0x74     ; 91
        .byte 0x18,0x04,0x08,0x1C,0x56,0x55,0x57,0x74     ; 92
        .byte 0x00,0x00,0x00,0x00,0x7E,0x7E,0xFF,0xFF     ; 93
        .byte 0x18,0x3C,0x18,0x18,0x18,0x18,0x7E,0xFF     ; 94
        .byte 0x22,0x77,0x7F,0x7F,0x3E,0x1C,0x08,0x00     ; 95
 
 	Arm9_End:


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	;Arm 7
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Arm7_Start:
Arm7_InfLoop:
	.ifdef ChibiSoundb
		.include "\SrcNDS\V1_ChibiSoundDriver.asm"
	.endif

	;.include "\SrcNDS\V1_JoyPenDriver.asm"
	b Arm7_InfLoop		
Arm7_End:	
	
	
	